/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 120 "language.yacc" /* yacc.c:339  */

/* This is the grammar definition of Pike. */

#include "global.h"
#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#include "interpret.h"
#include "array.h"
#include "object.h"
#include "mapping.h"
#include "stralloc.h"
#include "las.h"
#include "interpret.h"
#include "program.h"
#include "pike_types.h"
#include "constants.h"
#include "pike_macros.h"
#include "pike_error.h"
#include "docode.h"
#include "pike_embed.h"
#include "opcodes.h"
#include "operators.h"
#include "bignum.h"

#define YYMAXDEPTH	1000

#ifdef PIKE_DEBUG
#ifndef YYDEBUG
/* May also be defined by machine.h */
#define YYDEBUG 1
#endif /* YYDEBUG */
#endif

/* Get verbose parse error reporting. */
#define YYERROR_VERBOSE	1

/* #define LAMBDA_DEBUG	1 */

static void yyerror_reserved(const char *keyword);
static struct pike_string *get_new_name(struct pike_string *prefix);
int add_local_name(struct pike_string *, struct pike_type *, node *);
int low_add_local_name(struct compiler_frame *,
		       struct pike_string *, struct pike_type *, node *);
static void mark_lvalues_as_used(node *n);
static node *lexical_islocal(struct pike_string *);
static node *safe_inc_enum(node *n);
static int call_handle_import(struct pike_string *s);

static int inherit_depth;
static struct program_state *inherit_state = NULL;

/*
 * Kludge for Bison not using prototypes.
 */
#ifndef __GNUC__
#ifndef __cplusplus
static void __yy_memcpy(char *to, const char *from,
			unsigned int count);
#endif /* !__cplusplus */
#endif /* !__GNUC__ */


#line 131 "y.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "y.tab.h".  */
#ifndef YY_YY_Y_TAB_H_INCLUDED
# define YY_YY_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_ARROW = 258,
    TOK_CONSTANT = 259,
    TOK_FLOAT = 260,
    TOK_STRING = 261,
    TOK_NUMBER = 262,
    TOK_INC = 263,
    TOK_DEC = 264,
    TOK_RETURN = 265,
    TOK_EQ = 266,
    TOK_GE = 267,
    TOK_LE = 268,
    TOK_NE = 269,
    TOK_NOT = 270,
    TOK_LSH = 271,
    TOK_RSH = 272,
    TOK_LAND = 273,
    TOK_LOR = 274,
    TOK_SWITCH = 275,
    TOK_SSCANF = 276,
    TOK_CATCH = 277,
    TOK_FOREACH = 278,
    TOK_LEX_EOF = 279,
    TOK_ADD_EQ = 280,
    TOK_AND_EQ = 281,
    TOK_ARRAY_ID = 282,
    TOK_ATTRIBUTE_ID = 283,
    TOK_BREAK = 284,
    TOK_CASE = 285,
    TOK_CLASS = 286,
    TOK_COLON_COLON = 287,
    TOK_CONTINUE = 288,
    TOK_DEFAULT = 289,
    TOK_DEPRECATED_ID = 290,
    TOK_DIV_EQ = 291,
    TOK_DO = 292,
    TOK_DOT_DOT = 293,
    TOK_DOT_DOT_DOT = 294,
    TOK_ELSE = 295,
    TOK_ENUM = 296,
    TOK_EXTERN = 297,
    TOK_FLOAT_ID = 298,
    TOK_FOR = 299,
    TOK_FUNCTION_ID = 300,
    TOK_GAUGE = 301,
    TOK_GLOBAL = 302,
    TOK_IDENTIFIER = 303,
    TOK_RESERVED = 304,
    TOK_IF = 305,
    TOK_IMPORT = 306,
    TOK_INHERIT = 307,
    TOK_INLINE = 308,
    TOK_LOCAL_ID = 309,
    TOK_FINAL_ID = 310,
    TOK_FUNCTION_NAME = 311,
    TOK_INT_ID = 312,
    TOK_LAMBDA = 313,
    TOK_MULTISET_ID = 314,
    TOK_MULTISET_END = 315,
    TOK_MULTISET_START = 316,
    TOK_LSH_EQ = 317,
    TOK_MAPPING_ID = 318,
    TOK_MIXED_ID = 319,
    TOK_MOD_EQ = 320,
    TOK_MULT_EQ = 321,
    TOK_NO_MASK = 322,
    TOK_OBJECT_ID = 323,
    TOK_OR_EQ = 324,
    TOK_PRIVATE = 325,
    TOK_PROGRAM_ID = 326,
    TOK_PROTECTED = 327,
    TOK_PREDEF = 328,
    TOK_PUBLIC = 329,
    TOK_RSH_EQ = 330,
    TOK_STATIC = 331,
    TOK_STRING_ID = 332,
    TOK_SUB_EQ = 333,
    TOK_TYPEDEF = 334,
    TOK_TYPEOF = 335,
    TOK_VARIANT = 336,
    TOK_VERSION = 337,
    TOK_VOID_ID = 338,
    TOK_WHILE = 339,
    TOK_XOR_EQ = 340,
    TOK_OPTIONAL = 341,
    TOK_SAFE_INDEX = 342,
    TOK_SAFE_START_INDEX = 343,
    TOK_BITS = 344
  };
#endif
/* Tokens.  */
#define TOK_ARROW 258
#define TOK_CONSTANT 259
#define TOK_FLOAT 260
#define TOK_STRING 261
#define TOK_NUMBER 262
#define TOK_INC 263
#define TOK_DEC 264
#define TOK_RETURN 265
#define TOK_EQ 266
#define TOK_GE 267
#define TOK_LE 268
#define TOK_NE 269
#define TOK_NOT 270
#define TOK_LSH 271
#define TOK_RSH 272
#define TOK_LAND 273
#define TOK_LOR 274
#define TOK_SWITCH 275
#define TOK_SSCANF 276
#define TOK_CATCH 277
#define TOK_FOREACH 278
#define TOK_LEX_EOF 279
#define TOK_ADD_EQ 280
#define TOK_AND_EQ 281
#define TOK_ARRAY_ID 282
#define TOK_ATTRIBUTE_ID 283
#define TOK_BREAK 284
#define TOK_CASE 285
#define TOK_CLASS 286
#define TOK_COLON_COLON 287
#define TOK_CONTINUE 288
#define TOK_DEFAULT 289
#define TOK_DEPRECATED_ID 290
#define TOK_DIV_EQ 291
#define TOK_DO 292
#define TOK_DOT_DOT 293
#define TOK_DOT_DOT_DOT 294
#define TOK_ELSE 295
#define TOK_ENUM 296
#define TOK_EXTERN 297
#define TOK_FLOAT_ID 298
#define TOK_FOR 299
#define TOK_FUNCTION_ID 300
#define TOK_GAUGE 301
#define TOK_GLOBAL 302
#define TOK_IDENTIFIER 303
#define TOK_RESERVED 304
#define TOK_IF 305
#define TOK_IMPORT 306
#define TOK_INHERIT 307
#define TOK_INLINE 308
#define TOK_LOCAL_ID 309
#define TOK_FINAL_ID 310
#define TOK_FUNCTION_NAME 311
#define TOK_INT_ID 312
#define TOK_LAMBDA 313
#define TOK_MULTISET_ID 314
#define TOK_MULTISET_END 315
#define TOK_MULTISET_START 316
#define TOK_LSH_EQ 317
#define TOK_MAPPING_ID 318
#define TOK_MIXED_ID 319
#define TOK_MOD_EQ 320
#define TOK_MULT_EQ 321
#define TOK_NO_MASK 322
#define TOK_OBJECT_ID 323
#define TOK_OR_EQ 324
#define TOK_PRIVATE 325
#define TOK_PROGRAM_ID 326
#define TOK_PROTECTED 327
#define TOK_PREDEF 328
#define TOK_PUBLIC 329
#define TOK_RSH_EQ 330
#define TOK_STATIC 331
#define TOK_STRING_ID 332
#define TOK_SUB_EQ 333
#define TOK_TYPEDEF 334
#define TOK_TYPEOF 335
#define TOK_VARIANT 336
#define TOK_VERSION 337
#define TOK_VOID_ID 338
#define TOK_WHILE 339
#define TOK_XOR_EQ 340
#define TOK_OPTIONAL 341
#define TOK_SAFE_INDEX 342
#define TOK_SAFE_START_INDEX 343
#define TOK_BITS 344

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 186 "language.yacc" /* yacc.c:355  */

  int number;
  FLOAT_TYPE fnum;
  struct node_s *n;
  char *str;
  void *ptr;

#line 357 "y.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (void);

#endif /* !YY_YY_Y_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */
#line 194 "language.yacc" /* yacc.c:358  */

/* Need to be included after YYSTYPE is defined. */
#define INCLUDED_FROM_LANGUAGE_YACC
#include "lex.h"
#include "pike_compiler.h"
#line 201 "language.yacc" /* yacc.c:358  */

/* Include <stdio.h> our selves, so that we can do our magic
 * without being disturbed... */
#include <stdio.h>
int yylex(YYSTYPE *yylval);
/* Bison is stupid, and tries to optimize for space... */
#ifdef YYBISON
#define short int
#endif /* YYBISON */


#line 388 "y.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned /* short */ int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef /* short */ int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   8733

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  114
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  203
/* YYNRULES -- Number of rules.  */
#define YYNRULES  662
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  991

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   344

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   100,    94,     2,
     107,   108,    99,    97,   106,    98,   113,   101,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   104,   103,
      96,    90,    95,    91,   112,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   109,     2,   110,    93,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   111,    92,   105,   102,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   383,   383,   384,   388,   389,   390,   393,   394,   397,
     398,   399,   400,   406,   431,   448,   460,   460,   470,   485,
     491,   498,   504,   505,   510,   513,   520,   528,   529,   534,
     537,   610,   611,   614,   615,   618,   619,   620,   625,   628,
     633,   634,   635,   639,   652,   659,   665,   672,   674,   679,
     680,   686,   693,   695,   701,   720,   723,   732,   772,   729,
     960,   976,   975,   983,   984,   985,   986,   987,   988,   989,
     990,   996,  1002,  1010,  1008,  1021,  1022,  1027,  1030,  1031,
    1032,  1035,  1065,  1072,  1073,  1076,  1077,  1078,  1086,  1093,
    1094,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,  1111,
    1112,  1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,
    1125,  1126,  1127,  1128,  1129,  1130,  1131,  1132,  1133,  1134,
    1135,  1136,  1137,  1138,  1139,  1140,  1144,  1145,  1146,  1147,
    1148,  1149,  1150,  1151,  1152,  1153,  1154,  1155,  1156,  1157,
    1158,  1159,  1160,  1161,  1162,  1163,  1164,  1165,  1166,  1169,
    1169,  1169,  1171,  1171,  1172,  1180,  1187,  1188,  1191,  1195,
    1201,  1210,  1219,  1228,  1231,  1241,  1251,  1251,  1253,  1266,
    1279,  1292,  1293,  1296,  1297,  1300,  1300,  1303,  1304,  1305,
    1306,  1307,  1308,  1309,  1310,  1311,  1312,  1313,  1314,  1319,
    1325,  1329,  1335,  1344,  1443,  1446,  1447,  1460,  1463,  1464,
    1476,  1477,  1484,  1487,  1492,  1527,  1534,  1540,  1541,  1541,
    1575,  1576,  1577,  1585,  1589,  1584,  1616,  1629,  1630,  1633,
    1635,  1634,  1640,  1641,  1645,  1648,  1651,  1644,  1656,  1664,
    1665,  1668,  1684,  1686,  1685,  1734,  1738,  1743,  1750,  1762,
    1763,  1778,  1783,  1789,  1798,  1810,  1811,  1826,  1830,  1837,
    1842,  1836,  1863,  1864,  1875,  1876,  1877,  1882,  1888,  1889,
    1894,  1895,  1900,  1938,  1939,  1942,  1943,  1946,  1947,  1948,
    1953,  1957,  1958,  1964,  1966,  1967,  1968,  1969,  1970,  1971,
    1972,  1973,  1974,  1975,  1982,  1989,  1992,  1996,  1997,  1998,
    1999,  2000,  2001,  2002,  2003,  2007,  2006,  2023,  2024,  2027,
    2028,  2029,  2035,  2038,  2046,  2054,  2062,  2053,  2198,  2217,
    2216,  2344,  2360,  2359,  2490,  2506,  2548,  2551,  2552,  2553,
    2560,  2561,  2564,  2565,  2574,  2574,  2575,  2576,  2584,  2661,
    2583,  2839,  2840,  2843,  2844,  2848,  2849,  2915,  2921,  2922,
    2923,  2928,  2938,  2943,  2927,  2959,  2980,  2984,  2979,  3004,
    3005,  3006,  3013,  3014,  3017,  3028,  3031,  3032,  3033,  3037,
    3038,  3041,  3042,  3047,  3051,  3046,  3074,  3082,  3089,  3098,
    3099,  3107,  3111,  3106,  3131,  3135,  3130,  3151,  3152,  3156,
    3160,  3155,  3175,  3179,  3183,  3189,  3190,  3194,  3198,  3205,
    3216,  3222,  3223,  3226,  3228,  3229,  3232,  3233,  3236,  3237,
    3238,  3239,  3240,  3244,  3245,  3251,  3252,  3254,  3255,  3256,
    3257,  3258,  3267,  3268,  3269,  3270,  3276,  3283,  3284,  3287,
    3288,  3289,  3290,  3291,  3292,  3293,  3294,  3295,  3296,  3299,
    3299,  3301,  3302,  3306,  3307,  3310,  3311,  3314,  3315,  3324,
    3327,  3331,  3334,  3335,  3336,  3337,  3338,  3339,  3340,  3341,
    3342,  3343,  3344,  3345,  3346,  3347,  3348,  3349,  3350,  3351,
    3352,  3353,  3354,  3355,  3356,  3357,  3358,  3359,  3360,  3361,
    3362,  3363,  3364,  3365,  3366,  3367,  3368,  3369,  3370,  3373,
    3374,  3379,  3384,  3385,  3386,  3387,  3388,  3391,  3392,  3393,
    3415,  3419,  3416,  3511,  3517,  3523,  3530,  3536,  3545,  3556,
    3557,  3558,  3559,  3560,  3561,  3562,  3563,  3564,  3565,  3566,
    3567,  3568,  3574,  3580,  3587,  3617,  3649,  3655,  3661,  3663,
    3665,  3667,  3675,  3682,  3692,  3699,  3706,  3707,  3712,  3713,
    3714,  3715,  3719,  3724,  3725,  3726,  3732,  3762,  3770,  3773,
    3774,  3841,  3847,  3848,  3857,  3858,  3861,  3862,  3871,  3948,
    3956,  3986,  3989,  4015,  4031,  4038,  4046,  4062,  4066,  4123,
    4128,  4174,  4175,  4176,  4211,  4219,  4220,  4222,  4224,  4229,
    4236,  4251,  4267,  4268,  4269,  4274,  4277,  4278,  4279,  4284,
    4285,  4286,  4287,  4291,  4290,  4301,  4308,  4315,  4323,  4330,
    4337,  4343,  4350,  4356,  4362,  4363,  4368,  4369,  4372,  4373,
    4379,  4390,  4394,  4400,  4401,  4407,  4408,  4439,  4440,  4453,
    4454,  4468,  4469,  4480,  4499,  4500,  4502,  4504,  4506,  4508,
    4510,  4512,  4514,  4516,  4518,  4520,  4522,  4524,  4526,  4528,
    4530,  4532,  4534,  4544,  4546,  4548,  4550,  4552,  4554,  4556,
    4558,  4560,  4562,  4564,  4566,  4568,  4570,  4572,  4574,  4576,
    4578,  4580,  4582,  4584,  4586,  4588,  4590,  4592,  4594,  4596,
    4598,  4600,  4602
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_ARROW", "TOK_CONSTANT", "TOK_FLOAT",
  "TOK_STRING", "TOK_NUMBER", "TOK_INC", "TOK_DEC", "TOK_RETURN", "TOK_EQ",
  "TOK_GE", "TOK_LE", "TOK_NE", "TOK_NOT", "TOK_LSH", "TOK_RSH",
  "TOK_LAND", "TOK_LOR", "TOK_SWITCH", "TOK_SSCANF", "TOK_CATCH",
  "TOK_FOREACH", "TOK_LEX_EOF", "TOK_ADD_EQ", "TOK_AND_EQ", "TOK_ARRAY_ID",
  "TOK_ATTRIBUTE_ID", "TOK_BREAK", "TOK_CASE", "TOK_CLASS",
  "TOK_COLON_COLON", "TOK_CONTINUE", "TOK_DEFAULT", "TOK_DEPRECATED_ID",
  "TOK_DIV_EQ", "TOK_DO", "TOK_DOT_DOT", "TOK_DOT_DOT_DOT", "TOK_ELSE",
  "TOK_ENUM", "TOK_EXTERN", "TOK_FLOAT_ID", "TOK_FOR", "TOK_FUNCTION_ID",
  "TOK_GAUGE", "TOK_GLOBAL", "TOK_IDENTIFIER", "TOK_RESERVED", "TOK_IF",
  "TOK_IMPORT", "TOK_INHERIT", "TOK_INLINE", "TOK_LOCAL_ID",
  "TOK_FINAL_ID", "TOK_FUNCTION_NAME", "TOK_INT_ID", "TOK_LAMBDA",
  "TOK_MULTISET_ID", "TOK_MULTISET_END", "TOK_MULTISET_START",
  "TOK_LSH_EQ", "TOK_MAPPING_ID", "TOK_MIXED_ID", "TOK_MOD_EQ",
  "TOK_MULT_EQ", "TOK_NO_MASK", "TOK_OBJECT_ID", "TOK_OR_EQ",
  "TOK_PRIVATE", "TOK_PROGRAM_ID", "TOK_PROTECTED", "TOK_PREDEF",
  "TOK_PUBLIC", "TOK_RSH_EQ", "TOK_STATIC", "TOK_STRING_ID", "TOK_SUB_EQ",
  "TOK_TYPEDEF", "TOK_TYPEOF", "TOK_VARIANT", "TOK_VERSION", "TOK_VOID_ID",
  "TOK_WHILE", "TOK_XOR_EQ", "TOK_OPTIONAL", "TOK_SAFE_INDEX",
  "TOK_SAFE_START_INDEX", "TOK_BITS", "'='", "'?'", "'|'", "'^'", "'&'",
  "'>'", "'<'", "'+'", "'-'", "'*'", "'%'", "'/'", "'~'", "';'", "':'",
  "'}'", "','", "'('", "')'", "'['", "']'", "'{'", "'@'", "'.'", "$accept",
  "all", "program", "real_string_or_identifier", "optional_rename_inherit",
  "low_program_ref", "program_ref", "inherit_ref", "@1", "inheritance",
  "import", "constant_name", "constant_list", "constant", "block_or_semi",
  "type_or_error", "open_paren_with_line_info", "close_paren_or_missing",
  "close_brace_or_missing", "close_brace_or_eof",
  "open_bracket_with_line_info", "close_bracket_or_missing",
  "push_compiler_frame0", "optional_constant", "def", "@2", "@3", "$@4",
  "@5", "optional_dot_dot_dot", "optional_identifier", "new_arg_name",
  "func_args", "arguments", "arguments2", "modifier", "magic_identifiers1",
  "magic_identifiers2", "magic_identifiers3", "magic_identifiers",
  "magic_identifier", "modifiers", "modifier_list", "attribute",
  "optional_attributes", "optional_stars", "cast", "soft_cast", "type2",
  "simple_type", "simple_type2", "simple_identifier_type", "full_type",
  "type", "type3", "basic_type", "identifier_type", "number_or_maxint",
  "number_or_minint", "expected_dot_dot", "opt_int_range",
  "opt_string_width", "opt_object_type", "@6", "opt_program_type",
  "opt_function_type", "$@7", "$@8", "function_type_list",
  "function_type_list2", "$@9", "opt_array_type", "opt_mapping_type",
  "$@10", "$@11", "$@12", "name_list", "new_name", "@13", "new_local_name",
  "new_local_name2", "line_number_info", "block", "@14", "@15",
  "end_block", "failsafe_block", "propagated_type", "local_name_list",
  "local_name_list2", "local_constant_name", "local_constant_list",
  "local_constant", "statements", "statement_with_semicolon",
  "normal_label_statement", "statement", "labeled_statement", "$@16",
  "optional_label", "break", "default", "continue", "push_compiler_frame1",
  "implicit_identifier", "lambda", "$@17", "@18", "local_function", "@19",
  "local_function2", "@20", "create_arg", "create_arguments2",
  "create_arguments", "optional_create_arguments", "failsafe_program",
  "@21", "class", "@22", "@23", "simple_identifier", "enum_value",
  "enum_def", "propagated_enum_value", "enum_list", "enum", "$@24", "@25",
  "@26", "typedef", "cond", "@27", "@28", "end_cond", "optional_else_part",
  "safe_lvalue", "safe_expr0", "foreach_optional_lvalue",
  "foreach_lvalues", "foreach", "@29", "@30", "do", "expected_semicolon",
  "for", "@31", "@32", "while", "@33", "@34", "for_expr", "switch", "@35",
  "@36", "case", "expected_colon", "return", "unused", "unused2",
  "optional_comma_expr", "safe_comma_expr", "comma_expr", "comma_expr2",
  "expr00", "expr0", "expr01", "assign", "optional_comma", "expr_list",
  "expr_list2", "m_expr_list", "m_expr_list2", "assoc_pair", "expr1",
  "expr2", "expr3", "optional_block", "@37", "apply", "implicit_modifiers",
  "expr4", "idents2", "idents", "string_or_identifier",
  "inherit_specifier", "low_idents", "range_bound", "gauge", "typeof",
  "catch_arg", "catch", "$@38", "sscanf", "lvalue", "low_lvalue_list",
  "lvalue_list", "string_segment", "string", "string_constant",
  "real_string_constant", "bad_identifier", "bad_expr_ident", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
      61,    63,   124,    94,    38,    62,    60,    43,    45,    42,
      37,    47,   126,    59,    58,   125,    44,    40,    41,    91,
      93,   123,    64,    46
};
# endif

#define YYPACT_NINF -783

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-783)))

#define YYTABLE_NINF -660

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -783,    75,  1182,  -783,   505,  -783,   276,  -783,  -783,  -783,
    -783,  -783,   187,  5956,  -783,  -783,  -783,  -783,   509,  -783,
    7896,    13,    47,  -783,  -783,   173,   188,   231,   217,   310,
    7289,  -783,  -783,    37,  7357,  -783,  -783,   345,  6926,  -783,
    6978,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
     237,  7964,  8032,  -783,  -783,  7425,  -783,  -783,   353,   363,
    -783,  -783,   478,   308,  -783,   296,   323,  8100,  8100,   513,
      54,   467,   314,    55,   318,  -783,   335,   342,   314,   361,
    -783,   378,   386,   342,  -783,  7697,  -783,  -783,  -783,   351,
      62,  -783,    93,   388,   413,  -783,  -783,   409,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  3207,
    -783,  -783,  3207,  -783,  7493,  3207,  -783,  -783,  -783,   398,
    -783,  -783,  -783,   514,  7221,   416,  -783,   351,   281,   428,
    6926,  -783,  -783,    62,  5579,  -783,  -783,   326,  -783,  -783,
    -783,  -783,  -783,   432,  5631,  -783,  -783,  -783,  -783,  6926,
     425,  -783,  4163,    62,  1065,  -783,  -783,  -783,  -783,  -783,
    6813,  6813,  6790,   435,    40,  -783,  5882,   526,   107,  -783,
     173,   438,  6790,  6790,  -783,  -783,  2284,  6504,  6790,  6790,
    -783,  -783,  -783,  -783,   985,  -783,  -783,  -783,   307,  5988,
    -783,   351,  -783,  -783,  -783,  -783,   281,  8635,  -783,   456,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,    31,  -783,  -783,    62,   -22,    62,   151,   455,   159,
    6874,   461,  -783,   470,   554,    72,  6926,   467,   474,   258,
    -783,  -783,  -783,  -783,  -783,   186,  -783,  8168,   329,  -783,
     435,  -783,    49,   526,  -783,   438,  3316,   114,   114,  5518,
    -783,   146,  3643,    49,  -783,  2393,  -783,  -783,  -783,  8236,
    -783,  2879,  3752,  -783,  -783,   336,  6599,  6301,   263,  -783,
     253,  -783,  6504,   527,   -23,  -783,   114,  5760,   480,   477,
    -783,  -783,  -783,  4337,  4406,  4475,  4544,  4613,  4682,  4751,
    4820,  6790,  4889,  4958,  5027,  5096,  5165,  5234,  5303,  5372,
    5441,  5510,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  3861,
    -783,  2988,  1629,  3970,  6708,  6708,   506,  7044,  -783,   617,
      62,  -783,   521,  6926,  -783,  -783,  -783,   409,   442,   528,
    -783,  -783,  -783,  -783,  -783,  -783,   109,   134,  -783,   524,
    -783,  -783,  6926,   525,   277,   -36,  -783,  -783,   -23,   348,
      80,  -783,   349,  -783,  8304,   548,  -783,   534,   538,  -783,
    -783,  -783,  -783,   283,  6708,  -783,  -783,    -2,   539,   395,
     541,  -783,  -783,  -783,  -783,   546,  6504,   236,   536,   549,
    -783,  5868,  8635,  6926,  -783,  6708,  -783,   548,   542,  -783,
    -783,  6504,  -783,   812,  -783,  1057,  -783,   453,  -783,   453,
    -783,  1057,  -783,   596,  -783,   596,  -783,  5708,  -783,  1178,
     553,  -783,  5802,  -783,  7120,  -783,   829,  -783,   453,  -783,
     453,  -783,   407,  -783,   407,  -783,  -783,  -783,  -783,  -783,
    -783,  7125,   610,  6083,  -783,  -783,   611,   419,   552,   304,
    -783,  6410,   556,  -783,   558,    72,  -783,  -783,  -783,  -783,
      59,    58,  -783,   572,  -783,   557,  -783,  -783,   292,  -783,
    -783,   560,   230,  -783,  -783,   662,   562,  -783,  -783,  -783,
    3425,   112,  6708,   564,  8372,  -783,  -783,  -783,  -783,  -783,
     462,  6708,  -783,  -783,  -783,  -783,  8440,  -783,   570,  -783,
      34,  -783,   571,  -783,   588,  -783,  -783,   128,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  6599,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,   574,   569,  -783,  -783,  -783,  -783,
    4079,  -783,   576,  3097,  -783,  -783,  -783,  -783,   480,  -783,
    6708,  6708,  6790,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,   578,    72,  -783,  -783,  -783,  -783,   575,   575,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  6192,
    6926,  -783,   299,   590,  -783,  -783,  -783,  -783,  -783,  3207,
    -783,  -783,    48,  -783,  -783,  6926,  -783,  -783,  6926,  -783,
    -783,  6708,  -783,  -783,  -783,  6874,   612,   613,  -783,  -783,
    -783,  -783,    84,   122,   615,  -783,  3207,   130,  -783,  3207,
    -783,  -783,   593,  -783,  -783,  5937,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  6192,  -783,  -783,  -783,
     598,  -783,  -783,    28,  -783,  -783,  -783,  4251,  -783,  8508,
    -783,  -783,  -783,  6926,   409,   409,  -783,  6874,  -783,   601,
     368,    35,  -783,   468,   602,  3534,   145,  6708,  -783,  -783,
    -783,  6874,  -783,  -783,  -783,  1501,  -783,   603,  -783,  -783,
    7828,  -783,  -783,    48,  -783,   312,   606,   590,    39,  6926,
    6926,  -783,  8100,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  8576,  -783,   590,    66,  -783,   523,
    7561,  1282,   604,   608,     9,  1391,     9,  7756,  8643,   609,
     193,   614,  5680,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,   219,  -783,   219,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,   219,  -783,    66,  -783,  -783,   669,
    -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,    66,   630,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,   517,   632,  -783,   331,   633,  -783,  -783,
    -783,  -783,   219,  -783,  -783,  -783,  -783,  -783,  2502,   452,
    -783,  -783,  1739,  -783,   620,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,    39,  -783,  -783,  3207,  -783,  -783,  3207,
    -783,  7629,  3207,  -783,  -783,  -783,   236,  1848,  -783,    25,
    -783,  1739,  -783,  -783,  1501,  -783,  -783,  -783,   635,  -783,
    -783,   621,   622,  -783,   236,  -783,  -783,    14,   626,  -783,
     627,   636,  -783,  2502,  6708,  -783,  -783,  2502,  2066,  2502,
    2502,   185,   357,   185,   219,  -783,   185,   185,  -783,  -783,
    -783,  1739,  2690,  2784,   185,   219,  2175,  1739,  1739,  -783,
    -783,  -783,   624,  -783,  -783,  1739,  -783,   219,  -783,   697,
    -783,  2596,  -783,  1957,  1739,  -783,  -783,   185,  -783,  1739,
    -783
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       6,     0,     0,     1,     0,     3,     0,     5,    64,    65,
      66,     4,   161,   155,    69,    70,    71,    72,     0,   605,
       0,     0,   552,   555,   606,     0,     0,     0,     0,     0,
       0,   542,   607,   547,     0,   248,   341,     0,     0,    73,
       0,    67,    68,    91,    97,    94,    89,    88,    93,    96,
      95,    90,    98,    92,   157,    28,    27,    29,   647,   654,
     653,   650,   661,   615,   616,   656,   657,   617,   658,   659,
     618,   645,   646,   619,   643,   620,   660,   621,   651,   563,
     632,   662,   648,   649,   633,   634,   644,   622,   623,   652,
     626,   624,   625,   635,   627,   637,   628,   638,   636,   639,
     642,   629,   630,   655,   641,   631,   640,   564,   614,   549,
       0,     0,     0,   553,    25,     0,   548,   562,   560,   561,
      26,   608,     0,     0,    33,     0,     0,    80,    80,     0,
       0,     0,   223,     0,     0,   177,   216,   202,   223,   228,
     179,   207,   210,   202,   178,     0,   172,   175,   176,   193,
     547,     6,     0,   160,    55,   162,    43,   168,   554,   556,
     557,   558,   559,   545,   543,   544,   550,   551,    37,     0,
      36,    38,     0,    35,     0,     0,    78,   328,    79,     0,
      23,    22,    24,     0,     0,     0,    17,    14,   609,    13,
       0,   186,   190,     0,     0,   213,   183,     0,   181,   187,
     224,   182,   184,     0,     0,   185,   206,   180,   331,     0,
       0,   332,     0,     0,     0,    56,   163,   358,   501,   500,
     498,   498,   498,   653,   650,   357,     0,   634,   652,   248,
     636,   655,   498,   498,    44,    51,     0,   498,   498,   498,
     506,    32,   356,   407,   417,   442,   479,   510,     0,   487,
     509,   539,   503,   504,   502,   505,   499,     0,    30,     0,
      34,    31,   329,   342,    20,    19,    21,    11,   611,     7,
       9,     8,    10,    18,     0,     0,   609,     0,     0,     0,
     429,     0,   198,     0,     0,     0,     0,     0,     0,     0,
     171,   345,    50,    49,    74,     0,   159,     0,     0,   229,
       0,   583,     0,     0,   248,     0,     0,   482,   483,     0,
     484,   487,     0,     0,   582,     0,   249,   581,   570,     0,
     304,     0,     0,   486,   485,     0,   431,   435,     0,   174,
       0,   403,   498,     0,   166,   167,   598,   193,   603,     0,
     601,   480,   481,     0,     0,     0,     0,     0,     0,     0,
       0,   498,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   507,   508,   248,   488,   489,   424,   419,   428,
     422,   427,   426,   420,   423,   425,   421,   248,   248,     0,
     248,     0,     0,     0,   498,   498,   322,     0,   612,     0,
     610,   222,     0,     0,   192,   191,   430,   219,    77,   429,
     217,   205,   203,   199,   200,   201,   194,     0,    15,     0,
     212,   211,   430,     0,    54,   232,    63,   163,     0,     0,
       0,   584,     0,   163,     0,   169,   170,     0,   398,   248,
     540,   541,   303,     0,   498,   433,   405,     0,   429,     0,
       0,   527,   528,   529,   526,    48,   498,     0,    53,   429,
     437,   487,   601,     0,   164,   498,   521,   166,     0,   600,
     165,   498,   602,     0,   466,   448,   469,   451,   471,   453,
     467,   449,   472,   454,   473,   455,   462,   444,   461,   443,
       0,   463,   445,   464,   446,   465,   447,   468,   450,   470,
     452,   474,   456,   475,   457,   476,   458,   477,   459,   478,
     460,     0,     0,   498,   409,   408,     0,     0,     0,     0,
     568,   498,     0,   566,   403,     0,   413,   412,   410,   414,
     156,     0,   340,   333,   338,   343,   613,   189,     0,    76,
      75,     0,   220,   218,   195,     0,     0,   225,   209,   158,
       0,     0,   498,     0,     0,   230,   595,   597,   596,   594,
       0,   498,   578,   580,   579,   577,     0,   258,   399,   402,
     244,   260,   400,   401,   245,   576,   250,     0,   532,   530,
     533,   534,   531,   406,   524,   525,   430,   432,   574,   575,
     573,   572,   571,    47,     0,     0,   388,   386,   385,   387,
       0,    52,     0,     0,   436,   173,   404,   599,   603,   416,
     498,   498,   498,   538,   137,   144,   146,   145,   132,   131,
     112,   113,   135,   136,   134,   138,   139,   114,   127,   130,
     124,   102,   122,   128,   118,   133,   148,   152,   153,   126,
     140,   141,   107,   104,   100,   119,   123,   142,   116,   115,
     111,    99,   117,   103,   120,   106,   143,   105,   101,   121,
     125,   147,   109,   110,   129,   108,   149,   150,   151,   154,
     535,   536,   403,     0,   537,   495,   496,   497,   490,   490,
     517,   518,   519,   520,   516,   569,   567,   511,   512,   498,
       0,   317,   429,    46,   320,   326,   327,     6,   330,     0,
     336,   337,     0,   188,   214,     0,   196,   204,     0,   235,
     236,   498,    60,    57,   237,   429,   231,   232,   591,   593,
     592,   590,     0,   238,   239,   257,     0,     0,   257,     0,
     271,   308,     0,   434,   522,     0,   441,   440,   523,   439,
     438,   604,   411,   415,   418,   514,   498,   248,   494,   493,
       0,   163,   156,   156,   321,    45,   323,     0,   334,   335,
     253,   252,   344,     0,   221,   226,   234,   429,    85,     0,
     429,    77,    83,     0,     0,     0,     0,   498,   163,   246,
     311,   429,   309,   163,   247,     0,   306,     0,    54,   513,
      77,   319,   318,     0,   339,     0,     0,    46,     0,     0,
     430,    84,    80,   587,   589,   588,   586,   585,   242,   243,
     240,   314,   312,   241,     0,   259,    46,     0,   261,     0,
       0,     0,   654,   661,   656,     0,   658,   301,   248,   660,
     552,   662,     0,   374,   285,   275,   279,   251,   278,   274,
     286,   272,   294,     0,   293,     0,   276,   290,   288,   289,
     287,   291,   292,   277,     0,   393,     0,   515,   491,     0,
     316,   325,   215,   227,    58,    42,    41,    40,    62,    39,
      87,    86,    81,     0,   238,    82,   255,   256,   254,   310,
     283,   282,   284,     0,     0,   265,     0,     0,   397,   370,
     369,   389,     0,   396,   248,   248,   297,   299,     0,     0,
     302,   300,     0,   248,     0,   248,   248,   280,   281,   273,
     307,   271,   315,     0,   313,   269,     0,   268,   270,     0,
     267,     0,     0,   390,   380,   364,     0,     0,   382,     0,
     372,     0,   347,   375,     0,    59,   264,   262,     0,   266,
     263,     0,     0,   384,     0,   395,   368,     0,     0,   296,
       0,     0,   492,     0,   498,   383,   367,     0,     0,     0,
       0,     0,     0,     0,     0,   392,     0,     0,   351,   350,
     349,     0,     0,     0,     0,     0,     0,     0,     0,   381,
     355,   360,     0,   354,   361,     0,   366,     0,   378,   352,
     376,     0,   365,     0,     0,   348,   362,     0,   353,     0,
     373
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -783,  -783,  -143,  -783,  -783,   457,  -783,  -783,  -783,  -783,
      -1,   565,  -783,  -783,  -158,    68,  -173,  -722,  -783,  -783,
     684,  -783,   -25,  -783,  -783,  -783,  -783,  -783,  -783,  -517,
    -125,  -301,  -661,  -442,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -493,  -783,  -783,  -783,  -207,  -783,  -783,  -783,  -783,
    -783,  -783,   421,  -231,  -195,   370,   -15,  -783,  -783,  -499,
     616,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,   619,  -783,  -783,  -783,  -783,  -783,   337,  -783,  -416,
    -783,   -33,  -222,  -783,  -783,  -739,  -528,    42,  -783,  -783,
    -153,  -783,  -783,  -140,  -783,  -783,  -539,  -783,  -783,   -52,
    -783,  -783,  -783,  -540,  -783,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -225,  -783,  -783,  -783,  -783,  -783,   518,  -783,
    -783,   623,  -783,    21,  -783,  -783,   530,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -326,  -783,  -192,  -157,  -208,  -783,
    -783,  -783,  -783,  -783,  -782,  -783,  -783,  -783,  -783,  -783,
    -783,  -783,  -783,  -783,  -783,  -783,  -553,  -783,  -202,  -783,
    -783,  -769,  -249,     4,   200,   -80,  -332,  -246,  -256,   -81,
    -783,  -783,  -783,   195,  5567,   415,  -783,   117,  -783,  -783,
    -783,   245,  -783,    -6,  -783,  -783,  -783,  -475,  -783,  -783,
     479,  -783,  -783,  -783,  -451,  -302,  -567,   -20,    82,  -116,
    -783,    -8,   -13
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     2,   270,   185,   186,   409,   130,   131,     8,
     825,   124,   125,    10,   858,   154,   236,   746,   584,   294,
     237,   592,   541,   216,    11,   757,   903,   543,   151,   531,
     177,   758,   772,   759,   760,    54,   656,   657,   658,   659,
     660,    12,    13,   155,    40,   804,   238,   239,   333,   156,
     423,   424,   761,   425,   146,   329,   426,   536,   285,   406,
     198,   207,   202,   203,   205,   196,   280,   753,   398,   399,
     695,   191,   201,   286,   698,   786,   298,   299,   701,   557,
     561,   320,   826,   429,   720,   752,   869,   768,   558,   562,
     875,   876,   828,   775,   829,   830,   831,   832,   894,   887,
     833,   834,   835,   567,   432,   240,   722,   846,   563,   807,
     559,   863,   681,   682,   683,   521,   688,   783,    41,   262,
     386,   523,   690,   524,   749,   525,    42,   128,   387,   692,
      14,   836,   895,   940,   961,   985,   971,   241,   972,   964,
     837,   885,   932,   838,   881,   839,   893,   938,   840,   896,
     941,   977,   841,   884,   931,   842,   590,   843,   954,   844,
     934,   955,   883,   428,   435,   331,   243,   383,   762,   437,
     438,   448,   449,   450,   244,   245,   246,   738,   901,   247,
     248,   249,   250,   251,    29,    30,    31,   515,   252,   253,
     318,   254,   313,   255,   338,   339,   462,    32,   256,   189,
     271,   178,   257
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      28,     9,   127,   179,   317,   328,   334,   108,   212,   297,
     598,   385,   107,   121,   290,   258,   679,   108,   261,   480,
     717,   108,   119,   148,   400,   148,   126,   680,   663,  -430,
     458,   731,   149,  -298,   149,  -303,   827,   388,   946,   413,
     855,  -583,   882,    19,   851,   109,   889,   306,   306,   936,
     314,   897,  -430,   898,   542,   183,   192,   886,   574,   685,
    -429,   776,   899,   856,   306,   854,   427,   866,    19,   453,
     209,   -61,   750,   529,   530,     3,   381,   277,   418,  -546,
     317,   550,   686,  -429,   865,   763,   391,   460,    33,   242,
     867,   317,   242,    24,   192,   242,   334,   295,   108,   108,
     913,   457,   108,   160,   162,   802,   575,   165,  -248,   937,
     404,   405,  -298,   702,   108,   108,   534,   364,    24,   916,
     150,   947,   150,  -303,   716,   187,   110,   209,   389,   721,
     121,   770,   108,   513,   381,   381,  -430,   211,   381,  -430,
     120,  -303,   857,   533,   585,   764,   801,  -583,   935,   364,
     316,  -583,   392,   751,   365,   366,   315,   -12,   184,   306,
     316,   108,   193,   381,   736,   396,   126,  -429,   121,   687,
    -429,   108,   966,   766,   951,   148,   272,   316,   953,   148,
     956,   957,   577,   976,   149,   942,   551,   392,   149,   148,
     461,    34,  -603,   594,   148,   983,   321,   978,   149,   148,
     213,   377,   378,   149,   740,   111,   385,   535,   149,   958,
     544,     9,   765,   188,  -248,   334,   556,   601,    35,   703,
     112,   234,   335,   235,   340,  -546,   209,   380,    36,  -303,
     457,   337,   420,   377,   378,  -305,   121,   771,   537,    37,
     330,   436,   440,   879,   792,   445,   436,   447,   274,   680,
     680,   209,   771,   234,   513,   235,   121,   393,   595,   380,
     586,   777,   676,   849,   684,   148,    38,   395,  -430,  -430,
     734,   148,   150,   306,   149,   276,   150,    18,   381,   113,
     149,   187,    19,   274,   108,   158,   150,    19,   306,   415,
     959,   150,   412,   960,  -429,   276,   150,  -295,    39,   505,
     508,   436,   514,   517,   518,   519,   108,   568,    20,   337,
     330,   431,   335,  -547,   452,   787,   888,   335,   900,   340,
     114,   337,   880,    21,    22,    23,   337,   281,   670,   806,
     115,   501,    24,   282,  -430,   904,   918,    24,    35,   587,
     588,   589,   116,   569,   502,   503,   129,   506,    36,    25,
     209,   -16,   805,   919,   573,   453,   390,   808,    26,   455,
     441,   456,   150,   933,  -197,  -197,   411,   540,   150,   188,
     121,   454,   546,   552,   108,   596,   337,   -16,   148,   211,
    -231,   945,   939,  -231,   209,   166,   570,   149,   571,    27,
     917,   572,   -16,   -16,   -16,   167,   566,   148,   172,   173,
     693,   -16,   174,   742,   209,   743,   149,   671,   147,   672,
     147,   108,   673,   175,   674,   283,   564,   215,   -16,   578,
     852,   190,   969,   662,   284,   194,   744,   -16,   979,   980,
     513,   335,   416,   340,   910,   417,   982,   911,   148,   442,
     337,   443,   195,   665,   444,   988,   335,   149,   340,   197,
     990,   547,   553,   548,   554,   337,   549,   555,   -16,   145,
     962,   157,   704,   963,   115,   307,   308,   311,   200,   347,
     348,   712,   789,    19,   790,   150,   586,   311,   311,   601,
     529,   530,   336,   311,   311,  -208,   708,   513,   860,   861,
     404,   405,   793,   204,   150,   214,   436,   337,   579,    20,
     580,   209,   168,   581,   791,   337,   359,   360,   361,   263,
     727,   973,   973,   447,    21,    22,    23,   781,   782,   273,
     732,   733,   666,    24,   667,   274,   845,   668,   291,    15,
     973,   108,   748,    55,   780,   150,   707,   180,   264,   287,
      25,   905,   312,   108,   747,   322,   169,   870,   714,    26,
     357,   358,   359,   360,   361,   587,   588,   589,   319,   769,
     147,   403,   774,   394,   147,   709,   859,   710,   169,   401,
     711,   794,   451,   795,   147,   459,   796,   336,   402,   147,
      27,   170,   410,   171,   147,   868,   461,   463,   311,   311,
     311,   311,   311,   311,   311,   311,   311,   311,   311,   311,
     311,   311,   311,   311,   311,   311,   311,   906,    16,   242,
      17,   275,    56,   520,    57,   279,   181,   265,   182,   266,
     907,   756,   908,   526,   868,   289,   871,   965,   872,   527,
     967,   968,   538,   539,   532,   279,   242,   310,   975,   242,
     453,   868,   565,   845,   455,   576,   591,   323,   324,   582,
     147,   583,   597,   341,   342,   593,   147,   602,   661,   664,
     669,   989,   689,   691,   694,   148,   677,   862,   678,   696,
     697,   705,   845,   337,   149,   845,   715,   718,   719,   725,
     148,   859,   724,   148,   728,   800,   737,   803,   735,   149,
     148,   336,   149,   357,   358,   359,   360,   361,   745,   149,
     771,   397,   540,   542,   778,   767,   336,   407,   779,   788,
     797,  -379,   845,   847,   853,  -363,  -371,   902,   845,   845,
     765,  -346,   909,   912,   921,   906,   845,   981,   943,   944,
     337,   457,   457,   948,   949,   845,   108,   984,   148,   260,
     845,   211,   148,   950,   408,   925,     9,   149,   741,   926,
     457,   149,   927,   848,   545,   930,   148,   199,   929,   206,
     773,   924,   150,   147,   890,   149,   362,   108,   210,   337,
     784,   974,   850,   986,   148,   148,   723,   150,   363,   108,
     150,   987,   147,   149,   149,   892,   739,   150,   730,   306,
     306,   108,   421,     0,     0,     0,   714,   108,     0,     0,
       0,     0,   877,     0,     0,   337,     0,     0,   306,   337,
       0,     0,     0,   599,   528,     0,    28,     0,     0,     0,
       0,     0,     0,   147,     0,     0,   242,     0,     0,   242,
       0,     0,   242,   528,     0,   150,     0,   367,   368,   150,
     343,   344,   345,   346,     0,   347,   348,   311,   369,     0,
       0,   914,   915,   150,     0,     0,     0,     0,     0,     0,
     920,     0,   922,   923,   952,     0,     0,     0,     0,     0,
       0,   150,   150,     0,   370,     0,     0,   371,   372,     0,
       0,   373,   337,     0,     0,     0,   337,   374,     0,     0,
     375,     0,     0,     0,     0,     0,     0,   376,   108,     0,
       0,     0,   600,   877,    33,     0,   309,     0,     0,     0,
       0,   337,     0,     0,     0,   337,   309,   309,   337,     0,
     327,   332,   309,   309,   355,   356,   357,   358,   359,   360,
     361,     0,     0,   382,     0,     0,     0,   337,     0,     0,
       0,   337,   337,   337,   337,     0,     0,   335,   335,   340,
     340,     0,     0,     0,     0,   337,   337,   337,     0,     0,
     337,   337,   337,     0,     0,     0,   335,     0,   340,   337,
       0,     0,     0,     0,     0,   337,     0,   337,   337,     0,
       0,     0,     0,   337,     0,     0,     0,     0,     0,     0,
     327,   382,   382,     0,     0,   382,   343,   344,   345,   346,
       0,   347,   348,   349,   350,     0,     0,     0,     0,     0,
       0,   446,     0,     0,     0,     0,   332,     0,     0,     0,
     382,     0,     0,     0,     0,     0,     0,   309,   309,   309,
     309,   309,   309,   309,   309,   309,   309,   309,   309,   309,
     309,   309,   309,   309,   309,   309,     0,     0,     0,     0,
     147,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   147,   278,     0,   147,   344,
     345,    19,     0,   347,   348,   147,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,     0,     0,     0,
       0,     0,   132,   133,     0,     0,     0,    20,     0,     0,
     134,   157,     0,     0,     0,     0,     0,     0,   135,     0,
     136,     0,    21,    22,    23,     0,   754,     0,     0,   755,
       0,    24,   137,   147,   138,     0,     0,   147,   139,   140,
     332,     0,     0,   141,     0,   382,   142,     0,    25,     0,
       0,   147,   143,     0,     0,   332,     0,    26,   144,     0,
       0,     0,   355,   356,   357,   358,   359,   360,   361,   147,
     147,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   296,   785,     0,     0,     0,    27,     0,
       0,     0,    -2,     4,     0,     0,  -156,     0,  -156,   343,
     344,   345,   346,     0,   347,   348,   349,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     5,   336,   336,  -156,
    -156,     0,     0,  -156,  -156,     0,     0,  -156,     0,     0,
       0,     0,     0,  -156,  -156,  -156,   336,  -156,     0,  -156,
    -156,  -156,     0,     6,  -156,  -156,  -156,  -156,  -156,  -156,
       0,  -156,     0,     0,     0,  -156,  -156,     0,     0,  -156,
    -156,     0,  -156,  -156,  -156,  -156,  -156,     0,  -156,  -156,
       0,  -156,     0,  -156,  -156,  -156,     0,     0,  -156,     0,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,     0,     0,   878,     0,     7,   309,   218,    19,   219,
     220,   221,    58,  -156,     0,  -156,     0,   222,     0,     0,
       0,     0,    59,   223,   224,    62,   879,  -647,  -647,   132,
     133,    65,    66,  -498,    20,    68,    69,   134,  -647,    71,
       0,     0,    72,  -498,    74,   135,    76,   136,   226,    21,
      22,    23,    81,    82,    83,    84,   227,    86,    24,   137,
     228,   138,     0,   229,  -647,   139,   140,  -647,  -647,    93,
     141,  -647,    95,   142,    97,   230,    99,  -647,   100,   143,
    -647,     0,   231,   104,    26,   144,     0,  -647,   106,     0,
       0,     0,  -647,     0,     0,     0,     0,     0,     0,     0,
     232,     0,     0,     0,   233,   880,     0,     0,     0,   234,
       0,   235,   878,     0,     0,    27,   218,    19,   219,   220,
     221,    58,     0,     0,     0,     0,   222,     0,     0,     0,
       0,    59,   223,   224,    62,     0,  -657,  -657,   132,   133,
      65,    66,  -498,    20,    68,    69,   134,  -657,    71,   404,
     405,    72,  -498,    74,   135,    76,   136,   226,    21,    22,
      23,    81,    82,    83,    84,   227,    86,    24,   137,   228,
     138,     0,   229,  -657,   139,   140,  -657,  -657,    93,   141,
    -657,    95,   142,    97,   230,    99,  -657,   100,   143,  -657,
       0,   231,   104,    26,   144,     0,  -657,   106,     0,     0,
       0,  -657,     0,     0,     0,     0,     0,     0,     0,   232,
       0,     0,     0,   233,     0,     0,     0,     0,   234,     0,
     235,     0,   809,     0,    27,   810,   218,    19,   219,   220,
     221,   811,     0,     0,     0,     0,   222,     0,     0,     0,
       0,   812,   223,   224,   813,   750,     0,     0,   132,   133,
     814,   815,  -498,    20,   816,   817,   134,     0,   818,     0,
       0,    72,  -498,    74,   135,   819,   136,   226,    21,   820,
      23,   821,   822,    83,    84,   227,    86,    24,   137,   228,
     138,     0,   229,     0,   139,   140,     0,     0,    93,   141,
       0,    95,   142,    97,   230,    99,     0,   100,   143,     0,
       0,   231,   104,    26,   144,   823,     0,   106,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   232,
       0,     0,     0,   233,   824,     0,   751,     0,   234,     0,
     235,     0,   316,     0,    27,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     509,     0,     0,     0,   218,    19,   219,   220,   221,    58,
       0,     0,     0,     0,   222,     0,   332,   332,     0,    59,
     223,   224,    62,   510,     0,     0,   132,   133,    65,    66,
    -498,    20,    68,    69,   134,   332,    71,  -565,  -565,    72,
    -498,    74,   135,    76,   136,   226,    21,    22,    23,    81,
      82,    83,    84,   227,    86,    24,   137,   228,   138,     0,
     229,     0,   139,   140,     0,     0,    93,   141,     0,    95,
     142,    97,   230,    99,     0,   100,   143,     0,     0,   231,
     104,    26,   144,     0,     0,   106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   511,     0,   232,   512,     0,
       0,   233,     0,     0,     0,     0,   234,     0,   235,     0,
     809,     0,    27,   810,   218,    19,   219,   220,   221,   811,
       0,     0,     0,     0,   222,     0,     0,     0,     0,   812,
     223,   224,   813,     0,     0,     0,   132,   133,   814,   815,
    -498,    20,   816,   817,   134,     0,   818,     0,     0,    72,
    -498,    74,   135,   819,   136,   226,    21,   820,    23,   821,
     822,    83,    84,   227,    86,    24,   137,   228,   138,     0,
     229,     0,   139,   140,     0,     0,    93,   141,     0,    95,
     142,    97,   230,    99,     0,   100,   143,     0,     0,   231,
     104,    26,   144,   823,     0,   106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   232,     0,     0,
       0,   233,   824,     0,     0,     0,   234,     0,   235,   878,
     316,     0,    27,   218,    19,   219,   220,   221,    58,     0,
       0,     0,     0,   222,     0,     0,     0,     0,    59,   223,
     224,    62,  -394,     0,     0,   132,   133,    65,    66,  -498,
      20,    68,    69,   134,     0,    71,     0,     0,    72,  -498,
      74,   135,    76,   136,   226,    21,    22,    23,    81,    82,
      83,    84,   227,    86,    24,   137,   228,   138,     0,   229,
       0,   139,   140,     0,     0,    93,   141,     0,    95,   142,
      97,   230,    99,     0,   100,   143,     0,     0,   231,   104,
      26,   144,     0,     0,   106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   232,     0,     0,     0,
     233,  -394,  -394,  -394,     0,   234,     0,   235,   878,     0,
       0,    27,   218,    19,   219,   220,   221,    58,     0,     0,
       0,     0,   222,     0,     0,     0,     0,    59,   223,   224,
      62,  -391,     0,     0,   132,   133,    65,    66,  -498,    20,
      68,    69,   134,     0,    71,     0,     0,    72,  -498,    74,
     135,    76,   136,   226,    21,    22,    23,    81,    82,    83,
      84,   227,    86,    24,   137,   228,   138,     0,   229,     0,
     139,   140,     0,     0,    93,   141,     0,    95,   142,    97,
     230,    99,     0,   100,   143,     0,     0,   231,   104,    26,
     144,     0,     0,   106,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   232,     0,     0,     0,   233,
       0,     0,  -391,     0,   234,  -391,   235,   878,     0,     0,
      27,   218,    19,   219,   220,   221,    58,     0,     0,     0,
       0,   222,     0,     0,     0,     0,    59,   223,   224,    62,
    -391,     0,     0,   132,   133,    65,    66,  -498,    20,    68,
      69,   134,     0,    71,     0,     0,    72,  -498,    74,   135,
      76,   136,   226,    21,    22,    23,    81,    82,    83,    84,
     227,    86,    24,   137,   228,   138,     0,   229,     0,   139,
     140,     0,     0,    93,   141,     0,    95,   142,    97,   230,
      99,     0,   100,   143,     0,     0,   231,   104,    26,   144,
       0,     0,   106,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   232,     0,     0,     0,   233,  -391,
       0,     0,     0,   234,     0,   235,   878,     0,     0,    27,
     218,    19,   219,   220,   221,    58,     0,     0,     0,     0,
     222,     0,     0,     0,     0,    59,   223,   224,    62,  -377,
       0,     0,   132,   133,    65,    66,  -498,    20,    68,    69,
     134,     0,    71,     0,     0,    72,  -498,    74,   135,    76,
     136,   226,    21,    22,    23,    81,    82,    83,    84,   227,
      86,    24,   137,   228,   138,     0,   229,     0,   139,   140,
       0,     0,    93,   141,     0,    95,   142,    97,   230,    99,
       0,   100,   143,     0,     0,   231,   104,    26,   144,     0,
       0,   106,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   232,     0,     0,     0,   233,  -377,     0,
       0,     0,   234,     0,   235,   325,     0,     0,    27,   218,
      19,   219,   220,   221,    58,     0,     0,     0,     0,   222,
       0,     0,     0,     0,    59,   223,   224,    62,     0,     0,
       0,   132,   133,    65,    66,  -498,    20,    68,    69,   134,
       0,    71,     0,     0,    72,  -498,    74,   135,    76,   136,
     226,    21,    22,    23,    81,    82,    83,    84,   227,    86,
      24,   137,   228,   138,     0,   229,     0,   139,   140,     0,
       0,    93,   141,     0,    95,   142,    97,   230,    99,     0,
     100,   143,     0,     0,   231,   104,    26,   144,     0,     0,
     106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   232,     0,     0,     0,   233,     0,     0,     0,
       0,   234,     0,   235,   422,   326,     0,    27,   218,    19,
     219,   220,   221,    58,     0,     0,     0,     0,   222,     0,
       0,     0,     0,    59,   223,   224,    62,     0,     0,     0,
     132,   133,    65,    66,  -498,    20,    68,    69,   134,     0,
      71,     0,     0,    72,  -498,    74,   135,    76,   136,   226,
      21,    22,    23,    81,    82,    83,    84,   227,    86,    24,
     137,   228,   138,     0,   229,     0,   139,   140,     0,     0,
      93,   141,     0,    95,   142,    97,   230,    99,     0,   100,
     143,     0,     0,   231,   104,    26,   144,     0,     0,   106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   232,     0,     0,     0,   233,     0,     0,     0,     0,
     234,     0,   235,   878,     0,     0,    27,   218,    19,   219,
     220,   221,    58,     0,     0,     0,     0,   222,     0,     0,
       0,     0,    59,   223,   224,    62,     0,     0,     0,   132,
     133,    65,    66,  -498,    20,    68,    69,   134,     0,    71,
       0,     0,    72,  -498,    74,   135,    76,   136,   226,    21,
      22,    23,    81,    82,    83,    84,   227,    86,    24,   137,
     228,   138,     0,   229,     0,   139,   140,     0,     0,    93,
     141,     0,    95,   142,    97,   230,    99,     0,   100,   143,
       0,     0,   231,   104,    26,   144,     0,     0,   106,     0,
       0,     0,     0,     0,     0,     0,     0,   970,     0,     0,
     232,   218,    19,   219,   233,     0,    58,     0,     0,   234,
       0,   235,     0,     0,     0,    27,    59,   223,   224,    62,
    -359,     0,     0,   132,   133,    65,    66,  -498,    20,    68,
      69,   134,     0,    71,     0,     0,    72,  -498,    74,   135,
      76,   136,   226,    21,    22,    23,    81,    82,    83,    84,
     227,    86,    24,   137,   228,   138,     0,   229,     0,   139,
     140,     0,     0,    93,   141,     0,    95,   142,    97,   230,
      99,     0,   100,   143,     0,     0,   231,   104,    26,   144,
       0,     0,   106,     0,     0,     0,     0,     0,     0,     0,
       0,   970,     0,     0,     0,   218,    19,   219,     0,     0,
      58,  -359,     0,   234,  -359,   235,     0,     0,     0,    27,
      59,   223,   224,    62,     0,     0,     0,   132,   133,    65,
      66,  -498,    20,    68,    69,   134,     0,    71,     0,     0,
      72,  -498,    74,   135,    76,   136,   226,    21,    22,    23,
      81,    82,    83,    84,   227,    86,    24,   137,   228,   138,
       0,   229,     0,   139,   140,     0,     0,    93,   141,     0,
      95,   142,    97,   230,    99,     0,   100,   143,     0,     0,
     231,   104,    26,   144,     0,     0,   106,     0,     0,     0,
       0,     0,     0,     0,     0,   970,     0,     0,     0,   218,
      19,   219,     0,  -359,    58,     0,     0,   234,     0,   235,
       0,     0,     0,    27,    59,   223,   224,    62,     0,     0,
       0,   132,   133,    65,    66,  -498,    20,    68,    69,   134,
       0,    71,     0,     0,    72,  -498,    74,   135,    76,   136,
     226,    21,    22,    23,    81,    82,    83,    84,   227,    86,
      24,   137,   228,   138,     0,   229,     0,   139,   140,     0,
       0,    93,   141,     0,    95,   142,    97,   230,    99,     0,
     100,   143,     0,     0,   231,   104,    26,   144,     0,     0,
     106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     433,     0,     0,     0,   218,    19,   219,   220,   221,    58,
       0,   234,     0,   235,   222,     0,     0,    27,     0,    59,
     223,   224,    62,     0,     0,     0,     0,     0,    65,    66,
    -498,    20,    68,    69,     0,     0,    71,     0,     0,    72,
    -498,    74,     0,    76,     0,   226,    21,    22,    23,    81,
      82,    83,    84,   227,    86,    24,     0,   228,     0,  -431,
     229,     0,     0,     0,     0,     0,    93,     0,     0,    95,
       0,    97,   230,    99,     0,   100,     0,     0,     0,   231,
     104,    26,     0,     0,     0,   106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   232,     0,     0,
       0,   233,     0,     0,     0,     0,   234,  -431,   235,   507,
       0,   434,    27,   218,    19,   219,   220,   221,    58,     0,
       0,     0,     0,   222,     0,     0,     0,     0,    59,   223,
     224,    62,     0,     0,     0,     0,     0,    65,    66,  -498,
      20,    68,    69,     0,     0,    71,     0,     0,    72,  -498,
      74,     0,    76,     0,   226,    21,    22,    23,    81,    82,
      83,    84,   227,    86,    24,     0,   228,     0,     0,   229,
       0,     0,     0,     0,     0,    93,     0,     0,    95,     0,
      97,   230,    99,     0,   100,     0,     0,     0,   231,   104,
      26,     0,     0,     0,   106,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   232,     0,     0,     0,
     233,     0,     0,     0,     0,   234,  -431,   235,   729,     0,
     434,    27,   218,    19,   219,   220,   221,    58,     0,     0,
       0,     0,   222,     0,     0,     0,     0,    59,   223,   224,
      62,     0,     0,     0,     0,     0,    65,    66,  -498,    20,
      68,    69,     0,     0,    71,     0,     0,    72,  -498,    74,
       0,    76,     0,   226,    21,    22,    23,    81,    82,    83,
      84,   227,    86,    24,     0,   228,     0,     0,   229,     0,
       0,     0,     0,     0,    93,     0,     0,    95,     0,    97,
     230,    99,     0,   100,     0,     0,     0,   231,   104,    26,
       0,     0,     0,   106,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   232,     0,     0,     0,   233,
       0,     0,     0,     0,   234,  -430,   235,  -430,   217,     0,
      27,     0,   218,    19,   219,   220,   221,    58,     0,     0,
       0,     0,   222,     0,     0,     0,     0,    59,   223,   224,
      62,   225,     0,     0,     0,     0,    65,    66,  -498,    20,
      68,    69,     0,     0,    71,     0,     0,    72,  -498,    74,
       0,    76,     0,   226,    21,    22,    23,    81,    82,    83,
      84,   227,    86,    24,     0,   228,     0,     0,   229,     0,
       0,     0,     0,     0,    93,     0,     0,    95,     0,    97,
     230,    99,     0,   100,     0,     0,     0,   231,   104,    26,
       0,     0,     0,   106,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   232,     0,     0,     0,   233,
       0,     0,     0,     0,   234,     0,   235,   325,     0,     0,
      27,   218,    19,   219,   220,   221,    58,     0,     0,     0,
       0,   222,     0,     0,     0,     0,    59,   223,   224,    62,
       0,     0,     0,     0,     0,    65,    66,  -498,    20,    68,
      69,     0,     0,    71,     0,     0,    72,  -498,    74,     0,
      76,     0,   226,    21,    22,    23,    81,    82,    83,    84,
     227,    86,    24,     0,   228,     0,     0,   229,     0,     0,
       0,     0,     0,    93,     0,     0,    95,     0,    97,   230,
      99,     0,   100,     0,     0,     0,   231,   104,    26,     0,
       0,     0,   106,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   232,     0,     0,     0,   233,     0,
       0,     0,     0,   234,     0,   235,   699,   326,     0,    27,
    -233,  -233,  -233,  -233,  -233,  -233,     0,     0,     0,     0,
    -233,     0,     0,     0,     0,  -233,  -233,  -233,  -233,   700,
       0,     0,     0,     0,  -233,  -233,  -233,  -233,  -233,  -233,
       0,     0,  -233,     0,     0,  -233,  -233,  -233,     0,  -233,
       0,  -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,  -233,
    -233,  -233,     0,  -233,     0,     0,  -233,     0,     0,     0,
       0,     0,  -233,     0,     0,  -233,     0,  -233,  -233,  -233,
       0,  -233,     0,     0,     0,  -233,  -233,  -233,     0,     0,
       0,  -233,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  -233,     0,     0,     0,  -233,     0,     0,
       0,     0,  -233,     0,  -233,   798,     0,     0,  -233,   218,
      19,   219,   220,   221,    58,     0,     0,     0,     0,   222,
       0,     0,     0,     0,    59,   223,   224,    62,   799,     0,
       0,     0,     0,    65,    66,  -498,    20,    68,    69,     0,
       0,    71,     0,     0,    72,  -498,    74,     0,    76,     0,
     226,    21,    22,    23,    81,    82,    83,    84,   227,    86,
      24,     0,   228,     0,     0,   229,     0,     0,     0,     0,
       0,    93,     0,     0,    95,     0,    97,   230,    99,     0,
     100,     0,     0,     0,   231,   104,    26,     0,     0,     0,
     106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   232,     0,     0,     0,   233,     0,     0,     0,
       0,   234,     0,   235,   419,     0,     0,    27,   218,    19,
     219,   220,   221,    58,     0,     0,     0,     0,   222,     0,
       0,     0,     0,    59,   223,   224,    62,     0,     0,     0,
       0,     0,    65,    66,  -498,    20,    68,    69,     0,     0,
      71,     0,     0,    72,  -498,    74,     0,    76,     0,   226,
      21,    22,    23,    81,    82,    83,    84,   227,    86,    24,
       0,   228,     0,     0,   229,     0,     0,     0,     0,     0,
      93,     0,     0,    95,     0,    97,   230,    99,     0,   100,
       0,     0,     0,   231,   104,    26,     0,     0,     0,   106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   232,     0,     0,     0,   233,     0,     0,     0,     0,
     234,     0,   235,   439,     0,     0,    27,   218,    19,   219,
     220,   221,    58,     0,     0,     0,     0,   222,     0,     0,
       0,     0,    59,   223,   224,    62,     0,     0,     0,     0,
       0,    65,    66,  -498,    20,    68,    69,     0,     0,    71,
       0,     0,    72,  -498,    74,     0,    76,     0,   226,    21,
      22,    23,    81,    82,    83,    84,   227,    86,    24,     0,
     228,     0,     0,   229,     0,     0,     0,     0,     0,    93,
       0,     0,    95,     0,    97,   230,    99,     0,   100,     0,
       0,     0,   231,   104,    26,     0,     0,     0,   106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     232,     0,     0,     0,   233,     0,     0,     0,     0,   234,
       0,   235,   504,     0,     0,    27,   218,    19,   219,   220,
     221,    58,     0,     0,     0,     0,   222,     0,     0,     0,
       0,    59,   223,   224,    62,     0,     0,     0,     0,     0,
      65,    66,  -498,    20,    68,    69,     0,     0,    71,     0,
       0,    72,  -498,    74,     0,    76,     0,   226,    21,    22,
      23,    81,    82,    83,    84,   227,    86,    24,     0,   228,
       0,     0,   229,     0,     0,     0,     0,     0,    93,     0,
       0,    95,     0,    97,   230,    99,     0,   100,     0,     0,
       0,   231,   104,    26,     0,     0,     0,   106,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   232,
       0,     0,     0,   233,     0,     0,     0,     0,   234,     0,
     235,   516,     0,     0,    27,   218,    19,   219,   220,   221,
      58,     0,     0,     0,     0,   222,     0,     0,     0,     0,
      59,   223,   224,    62,     0,     0,     0,     0,     0,    65,
      66,  -498,    20,    68,    69,     0,     0,    71,     0,     0,
      72,  -498,    74,     0,    76,     0,   226,    21,    22,    23,
      81,    82,    83,    84,   227,    86,    24,     0,   228,     0,
       0,   229,     0,     0,     0,     0,     0,    93,     0,     0,
      95,     0,    97,   230,    99,     0,   100,     0,     0,     0,
     231,   104,    26,     0,     0,     0,   106,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   232,     0,
       0,     0,   233,     0,     0,     0,     0,   234,     0,   235,
     726,     0,     0,    27,   218,    19,   219,   220,   221,    58,
       0,     0,     0,     0,   222,     0,     0,     0,     0,    59,
     223,   224,    62,     0,     0,     0,     0,     0,    65,    66,
    -498,    20,    68,    69,     0,     0,    71,     0,     0,    72,
    -498,    74,     0,    76,     0,   226,    21,    22,    23,    81,
      82,    83,    84,   227,    86,    24,     0,   228,     0,     0,
     229,     0,     0,     0,     0,     0,    93,     0,     0,    95,
       0,    97,   230,    99,     0,   100,     0,     0,     0,   231,
     104,    26,     0,     0,     4,   106,     0,  -156,     0,  -156,
       0,     0,     0,     0,     0,     0,     0,   232,     0,     0,
       0,   233,     0,     0,     0,     0,   234,   292,   235,     0,
    -156,  -156,    27,     0,  -156,  -156,     0,     0,  -156,     0,
       0,     0,     0,     0,  -156,  -156,  -156,     0,  -156,     0,
    -156,  -156,  -156,     0,     6,  -156,  -156,  -156,  -156,  -156,
    -156,     0,  -156,     0,     0,     0,  -156,  -156,     0,     0,
    -156,  -156,     0,  -156,  -156,  -156,  -156,  -156,     0,  -156,
    -156,     0,  -156,     0,  -156,  -156,  -156,     0,     0,  -156,
       0,     0,     4,     0,     0,  -156,     0,  -156,     0,     0,
       0,     0,     0,     0,     0,     0,     7,     0,   293,     0,
       0,     0,     0,     0,  -156,  -324,  -156,     0,  -156,  -156,
       0,     0,  -156,  -156,     0,     0,  -156,     0,     0,     0,
       0,     0,  -156,  -156,  -156,     0,  -156,     0,  -156,  -156,
    -156,     0,     6,  -156,  -156,  -156,  -156,  -156,  -156,     0,
    -156,     0,     0,     0,  -156,  -156,     0,     0,  -156,  -156,
       0,  -156,  -156,  -156,  -156,  -156,     0,  -156,  -156,     0,
    -156,     0,  -156,  -156,  -156,     0,     0,  -156,   464,     0,
       0,     0,   218,    19,   219,   220,   221,     0,     0,     0,
       0,     0,   222,     0,     7,     0,  -324,     0,   300,   301,
       0,     0,  -156,     0,  -156,     0,     0,     0,  -498,    20,
       0,     0,     0,     0,     0,     0,     0,     0,  -498,     0,
       0,     0,     0,   302,    21,    22,    23,     0,     0,     0,
       0,   303,     0,    24,     0,   304,     0,     0,   229,     0,
       0,     0,     0,     0,     0,     0,     0,   466,     0,     0,
      25,   218,    19,   219,   220,   221,     0,   305,     0,    26,
       0,   222,     0,     0,     0,     0,     0,   300,   301,     0,
       0,     0,     0,     0,     0,   232,     0,  -498,    20,   233,
       0,     0,     0,     0,   234,     0,   235,  -498,     0,     0,
      27,     0,   302,    21,    22,    23,     0,     0,     0,     0,
     303,     0,    24,     0,   304,     0,     0,   229,     0,     0,
       0,     0,     0,     0,     0,     0,   468,     0,     0,    25,
     218,    19,   219,   220,   221,     0,   305,     0,    26,     0,
     222,     0,     0,     0,     0,     0,   300,   301,     0,     0,
       0,     0,     0,     0,   232,     0,  -498,    20,   233,     0,
       0,     0,     0,   234,     0,   235,  -498,     0,     0,    27,
       0,   302,    21,    22,    23,     0,     0,     0,     0,   303,
       0,    24,     0,   304,     0,     0,   229,     0,     0,     0,
       0,     0,     0,     0,     0,   470,     0,     0,    25,   218,
      19,   219,   220,   221,     0,   305,     0,    26,     0,   222,
       0,     0,     0,     0,     0,   300,   301,     0,     0,     0,
       0,     0,     0,   232,     0,  -498,    20,   233,     0,     0,
       0,     0,   234,     0,   235,  -498,     0,     0,    27,     0,
     302,    21,    22,    23,     0,     0,     0,     0,   303,     0,
      24,     0,   304,     0,     0,   229,     0,     0,     0,     0,
       0,     0,     0,     0,   472,     0,     0,    25,   218,    19,
     219,   220,   221,     0,   305,     0,    26,     0,   222,     0,
       0,     0,     0,     0,   300,   301,     0,     0,     0,     0,
       0,     0,   232,     0,  -498,    20,   233,     0,     0,     0,
       0,   234,     0,   235,  -498,     0,     0,    27,     0,   302,
      21,    22,    23,     0,     0,     0,     0,   303,     0,    24,
       0,   304,     0,     0,   229,     0,     0,     0,     0,     0,
       0,     0,     0,   474,     0,     0,    25,   218,    19,   219,
     220,   221,     0,   305,     0,    26,     0,   222,     0,     0,
       0,     0,     0,   300,   301,     0,     0,     0,     0,     0,
       0,   232,     0,  -498,    20,   233,     0,     0,     0,     0,
     234,     0,   235,  -498,     0,     0,    27,     0,   302,    21,
      22,    23,     0,     0,     0,     0,   303,     0,    24,     0,
     304,     0,     0,   229,     0,     0,     0,     0,     0,     0,
       0,     0,   476,     0,     0,    25,   218,    19,   219,   220,
     221,     0,   305,     0,    26,     0,   222,     0,     0,     0,
       0,     0,   300,   301,     0,     0,     0,     0,     0,     0,
     232,     0,  -498,    20,   233,     0,     0,     0,     0,   234,
       0,   235,  -498,     0,     0,    27,     0,   302,    21,    22,
      23,     0,     0,     0,     0,   303,     0,    24,     0,   304,
       0,     0,   229,     0,     0,     0,     0,     0,     0,     0,
       0,   478,     0,     0,    25,   218,    19,   219,   220,   221,
       0,   305,     0,    26,     0,   222,     0,     0,     0,     0,
       0,   300,   301,     0,     0,     0,     0,     0,     0,   232,
       0,  -498,    20,   233,     0,     0,     0,     0,   234,     0,
     235,  -498,     0,     0,    27,     0,   302,    21,    22,    23,
       0,     0,     0,     0,   303,     0,    24,     0,   304,     0,
       0,   229,     0,     0,     0,     0,     0,     0,     0,     0,
     481,     0,     0,    25,   218,    19,   219,   220,   221,     0,
     305,     0,    26,     0,   222,     0,     0,     0,     0,     0,
     300,   301,     0,     0,     0,     0,     0,     0,   232,     0,
    -498,    20,   233,     0,     0,     0,     0,   234,     0,   235,
    -498,     0,     0,    27,     0,   302,    21,    22,    23,     0,
       0,     0,     0,   303,     0,    24,     0,   304,     0,     0,
     229,     0,     0,     0,     0,     0,     0,     0,     0,   483,
       0,     0,    25,   218,    19,   219,   220,   221,     0,   305,
       0,    26,     0,   222,     0,     0,     0,     0,     0,   300,
     301,     0,     0,     0,     0,     0,     0,   232,     0,  -498,
      20,   233,     0,     0,     0,     0,   234,     0,   235,  -498,
       0,     0,    27,     0,   302,    21,    22,    23,     0,     0,
       0,     0,   303,     0,    24,     0,   304,     0,     0,   229,
       0,     0,     0,     0,     0,     0,     0,     0,   485,     0,
       0,    25,   218,    19,   219,   220,   221,     0,   305,     0,
      26,     0,   222,     0,     0,     0,     0,     0,   300,   301,
       0,     0,     0,     0,     0,     0,   232,     0,  -498,    20,
     233,     0,     0,     0,     0,   234,     0,   235,  -498,     0,
       0,    27,     0,   302,    21,    22,    23,     0,     0,     0,
       0,   303,     0,    24,     0,   304,     0,     0,   229,     0,
       0,     0,     0,     0,     0,     0,     0,   487,     0,     0,
      25,   218,    19,   219,   220,   221,     0,   305,     0,    26,
       0,   222,     0,     0,     0,     0,     0,   300,   301,     0,
       0,     0,     0,     0,     0,   232,     0,  -498,    20,   233,
       0,     0,     0,     0,   234,     0,   235,  -498,     0,     0,
      27,     0,   302,    21,    22,    23,     0,     0,     0,     0,
     303,     0,    24,     0,   304,     0,     0,   229,     0,     0,
       0,     0,     0,     0,     0,     0,   489,     0,     0,    25,
     218,    19,   219,   220,   221,     0,   305,     0,    26,     0,
     222,     0,     0,     0,     0,     0,   300,   301,     0,     0,
       0,     0,     0,     0,   232,     0,  -498,    20,   233,     0,
       0,     0,     0,   234,     0,   235,  -498,     0,     0,    27,
       0,   302,    21,    22,    23,     0,     0,     0,     0,   303,
       0,    24,     0,   304,     0,     0,   229,     0,     0,     0,
       0,     0,     0,     0,     0,   491,     0,     0,    25,   218,
      19,   219,   220,   221,     0,   305,     0,    26,     0,   222,
       0,     0,     0,     0,     0,   300,   301,     0,     0,     0,
       0,     0,     0,   232,     0,  -498,    20,   233,     0,     0,
       0,     0,   234,     0,   235,  -498,     0,     0,    27,     0,
     302,    21,    22,    23,     0,     0,     0,     0,   303,     0,
      24,     0,   304,     0,     0,   229,     0,     0,     0,     0,
       0,     0,     0,     0,   493,     0,     0,    25,   218,    19,
     219,   220,   221,     0,   305,     0,    26,     0,   222,     0,
       0,     0,     0,     0,   300,   301,     0,     0,     0,     0,
       0,     0,   232,     0,  -498,    20,   233,     0,     0,     0,
       0,   234,     0,   235,  -498,     0,     0,    27,     0,   302,
      21,    22,    23,     0,     0,     0,     0,   303,     0,    24,
       0,   304,     0,     0,   229,     0,     0,     0,     0,     0,
       0,     0,     0,   495,     0,     0,    25,   218,    19,   219,
     220,   221,     0,   305,     0,    26,     0,   222,     0,     0,
       0,     0,     0,   300,   301,     0,     0,     0,     0,     0,
       0,   232,     0,  -498,    20,   233,     0,     0,     0,     0,
     234,     0,   235,  -498,     0,     0,    27,     0,   302,    21,
      22,    23,     0,     0,     0,     0,   303,     0,    24,     0,
     304,     0,     0,   229,     0,     0,     0,     0,     0,     0,
       0,     0,   497,     0,     0,    25,   218,    19,   219,   220,
     221,     0,   305,     0,    26,     0,   222,     0,     0,     0,
       0,     0,   300,   301,     0,     0,     0,     0,     0,     0,
     232,     0,  -498,    20,   233,     0,     0,     0,     0,   234,
       0,   235,  -498,     0,     0,    27,     0,   302,    21,    22,
      23,     0,     0,     0,     0,   303,     0,    24,     0,   304,
       0,     0,   229,     0,     0,     0,     0,     0,     0,     0,
       0,   499,     0,     0,    25,   218,    19,   219,   220,   221,
       0,   305,     0,    26,     0,   222,     0,     0,     0,     0,
       0,   300,   301,     0,     0,     0,     0,     0,     0,   232,
       0,  -498,    20,   233,     0,   132,   133,     0,   234,     0,
     235,  -498,     0,   134,    27,     0,   302,    21,    22,    23,
       0,   135,     0,   136,   303,     0,    24,     0,   304,     0,
       0,   229,     0,     0,     0,   137,     0,   138,     0,     0,
     278,   139,   140,    25,     0,    19,   141,     0,     0,   142,
     305,     0,    26,     0,     0,   143,     0,     0,     0,     0,
       0,   144,     0,     0,     0,     0,   132,   133,   232,     0,
       0,    20,   233,     0,   134,     0,     0,   234,     0,   235,
       0,     0,   135,    27,   136,     0,    21,    22,    23,     0,
       0,     0,   288,     0,     0,    24,   137,    19,   138,     0,
       0,     0,   139,   140,     0,     0,     0,   141,     0,     0,
     142,     0,    25,     0,     0,     0,   143,     0,   132,   133,
       0,    26,   144,    20,     0,     0,   134,     0,     0,     0,
       0,     0,     0,     0,   135,     0,   136,     0,    21,    22,
      23,    18,     0,     0,     0,     0,    19,    24,   137,     0,
     138,     0,    27,     0,   139,   140,     0,     0,     0,   141,
       0,     0,   142,     0,    25,  -648,  -648,     0,   143,     0,
       0,     0,    20,    26,   144,     0,  -648,     0,     0,   343,
     344,   345,   346,     0,   347,   348,     0,    21,    22,    23,
       0,     0,     0,     0,     0,     0,    24,     0,     0,     0,
       0,     0,  -648,     0,    27,  -648,  -648,     0,     0,  -648,
       0,     0,     0,    25,     0,  -648,     0,     0,  -648,     0,
       0,     0,    26,  -539,     0,  -648,     0,     0,  -539,  -539,
    -648,  -539,  -539,  -539,  -539,     0,  -539,  -539,  -539,  -539,
       0,     0,     0,     0,  -539,  -539,  -539,     0,     0,     0,
       0,     0,     0,    27,     0,     0,  -539,     0,  -539,  -539,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   361,
       0,     0,     0,   343,   344,   345,   346,     0,   347,   348,
       0,     0,  -539,     0,     0,  -539,  -539,     0,     0,  -539,
       0,     0,     0,     0,     0,  -539,     0,     0,  -539,     0,
       0,     0,     0,     0,     0,  -539,     0,  -539,  -539,     0,
    -539,  -539,  -539,  -539,  -539,  -539,  -539,  -539,  -539,  -539,
    -539,  -539,     0,  -539,  -539,  -539,  -539,  -539,  -539,  -539,
    -539,   364,     0,   115,     0,     0,   365,   366,     0,     0,
       0,     0,     0,   314,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   367,   368,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   369,     0,  -651,  -651,  -651,     0,
     465,   467,   469,   471,   473,   475,   477,   479,  -651,   482,
     484,   486,   488,   490,   492,   494,   496,   498,   500,     0,
     370,     0,     0,   371,   372,     0,     0,   373,   599,     0,
       0,     0,     0,   374,  -651,     0,   375,  -651,  -651,     0,
       0,  -651,     0,   376,     0,   377,   378,  -651,   379,     0,
    -651,     0,   367,   368,     0,     0,     0,  -651,     0,     0,
       0,     0,  -651,   369,  -598,   234,     0,   235,  -598,     0,
       0,   380,     0,     0,     0,  -651,     0,  -651,  -651,   315,
    -651,   364,  -651,   316,     0,     0,   365,   366,    43,   370,
       0,     0,   371,   372,     0,     0,   373,     0,     0,    44,
      45,    46,   374,   367,   368,   375,     0,     0,     0,     0,
       0,     0,   376,    47,   369,     0,    48,   600,    49,     0,
      50,     0,    51,     0,     0,     0,     0,    52,     0,     0,
       0,     0,    53,  -599,     0,     0,     0,  -599,     0,     0,
     370,     0,     0,   371,   372,     0,     0,   373,     0,     0,
       0,     0,     0,   374,     0,     0,   375,     0,     0,     0,
       0,     0,     0,   376,     0,   377,   378,     0,   379,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   218,    19,
     219,   220,   221,    58,     0,   234,     0,   235,   222,     0,
       0,   380,     0,    59,   223,   224,    62,   510,     0,     0,
     132,   133,    65,    66,     0,    20,    68,    69,   134,     0,
      71,  -565,  -565,    72,     0,    74,   135,    76,   136,   226,
      21,    22,    23,    81,    82,    83,    84,   227,    86,    24,
     137,   228,   138,     0,   229,     0,   139,   140,     0,     0,
      93,   141,     0,    95,   142,    97,   230,    99,     0,   100,
     143,     0,     0,   231,   104,    26,   144,     0,     0,   106,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   511,
       0,   232,     0,     0,     0,   233,     0,     0,     0,     0,
     234,     0,   235,     0,     0,     0,    27,   218,    19,   219,
     220,   221,    58,     0,     0,     0,     0,   222,     0,     0,
       0,     0,    59,   223,   224,    62,   510,     0,     0,   132,
     133,    65,    66,     0,    20,    68,    69,   134,     0,    71,
       0,     0,    72,     0,    74,   135,    76,   136,   226,    21,
      22,    23,    81,    82,    83,    84,   227,    86,    24,   137,
     228,   138,     0,   229,     0,   139,   140,     0,     0,    93,
     141,     0,    95,   142,    97,   230,    99,     0,   100,   143,
       0,     0,   231,   104,    26,   144,     0,     0,   106,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   511,     0,
     232,     0,     0,     0,   233,     0,     0,     0,     0,   234,
       0,   235,  -565,     0,     0,    27,   218,    19,   219,   220,
     221,    58,     0,     0,     0,     0,   222,     0,     0,     0,
       0,    59,   223,   224,    62,     0,     0,     0,   132,   133,
      65,    66,  -498,    20,    68,    69,   134,     0,    71,     0,
       0,    72,  -498,    74,   135,    76,   136,   226,    21,    22,
      23,    81,    82,    83,    84,   227,    86,    24,   137,   228,
     138,     0,   229,     0,   139,   140,     0,     0,    93,   141,
       0,    95,   142,    97,   230,    99,     0,   100,   143,     0,
       0,   231,   104,    26,   144,     0,     0,   106,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   232,
       0,     0,     0,   233,     0,     0,     0,     0,   234,     0,
     235,     0,     0,     0,    27,   218,    19,   219,   220,   221,
      58,     0,     0,     0,     0,   222,     0,     0,     0,     0,
      59,   223,   224,    62,   675,     0,     0,   132,   133,    65,
      66,     0,    20,    68,    69,   134,     0,    71,     0,     0,
      72,     0,    74,   135,    76,   136,   226,    21,    22,    23,
      81,    82,    83,    84,   227,    86,    24,   137,   228,   138,
       0,   229,     0,   139,   140,     0,     0,    93,   141,     0,
      95,   142,    97,   230,    99,     0,   100,   143,     0,     0,
     231,   104,    26,   144,     0,     0,   106,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   232,   218,
      19,   219,   233,     0,    58,     0,     0,   234,     0,   235,
       0,     0,     0,    27,    59,   223,   224,    62,     0,     0,
       0,   132,   133,    65,    66,     0,    20,    68,    69,   134,
       0,    71,     0,     0,    72,     0,    74,   135,    76,   136,
     226,    21,    22,    23,    81,    82,    83,    84,   227,    86,
      24,   137,   228,   138,     0,   229,     0,   139,   140,     0,
       0,    93,   141,     0,    95,   142,    97,   230,    99,     0,
     100,   143,     0,     0,   231,   104,    26,   144,     0,     0,
     106,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   218,    19,   219,   220,   221,    58,
       0,   234,     0,   235,   222,     0,     0,    27,     0,    59,
     223,   224,    62,     0,     0,     0,     0,     0,    65,    66,
    -498,    20,    68,    69,     0,     0,    71,     0,     0,    72,
    -498,    74,     0,    76,     0,   226,    21,    22,    23,    81,
      82,    83,    84,   227,    86,    24,     0,   228,     0,     0,
     229,     0,     0,     0,     0,     0,    93,     0,     0,    95,
       0,    97,   230,    99,     0,   100,     0,     0,     0,   231,
     104,    26,     0,     0,     0,   106,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   232,     0,     0,
       0,   233,     0,     0,     0,     0,   234,     0,   235,     0,
       0,   434,    27,   218,    19,   219,   220,   221,    58,     0,
       0,     0,     0,   222,     0,     0,     0,     0,    59,   223,
     224,    62,     0,     0,     0,     0,     0,    65,    66,     0,
      20,    68,    69,     0,     0,    71,     0,     0,    72,     0,
      74,     0,    76,     0,   226,    21,    22,    23,    81,    82,
      83,    84,   227,    86,    24,     0,   228,     0,     0,   229,
       0,     0,     0,     0,     0,    93,     0,     0,    95,     0,
      97,   230,    99,     0,   100,     0,     0,     0,   231,   104,
      26,     0,     0,     0,   106,   218,    19,   219,   220,   221,
       0,     0,     0,     0,     0,   222,   232,     0,     0,     0,
     233,   300,   301,     0,     0,   234,     0,   235,   218,    19,
     219,    27,    20,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   300,   301,   302,    21,    22,    23,
       0,     0,     0,     0,   303,    20,    24,     0,   304,     0,
       0,   229,     0,     0,     0,     0,     0,     0,     0,   302,
      21,    22,    23,    25,     0,     0,     0,   303,     0,    24,
     305,   304,    26,     0,   229,     0,     0,     0,     0,     0,
      19,     0,     0,     0,     0,     0,    25,     0,   232,     0,
       0,     0,   233,   305,     0,    26,     0,   234,     0,   235,
       0,   132,   133,    27,     0,     0,    20,     0,     0,   134,
       0,     0,     0,     0,     0,     0,     0,   135,     0,   136,
     234,    21,    22,    23,     0,     0,    27,     0,     0,     0,
      24,   137,    19,   138,     0,     0,     0,   139,   140,     0,
       0,     0,   141,     0,     0,   142,     0,    25,     0,     0,
       0,   143,     0,   132,   133,     0,    26,   144,    20,     0,
       0,   134,     0,     0,     0,     0,     0,     0,     0,   135,
       0,   136,     0,    21,    22,    23,     0,     0,     0,     0,
     396,     0,    24,   137,    19,   138,     0,    27,     0,   139,
     140,     0,     0,     0,   141,     0,     0,   142,     0,    25,
       0,     0,     0,   143,     0,   132,   152,     0,    26,   144,
      20,     0,     0,   153,     0,     0,     0,     0,     0,     0,
       0,   135,     0,   136,     0,    21,    22,    23,     0,     0,
       0,     0,     0,     0,    24,   137,     0,   138,     0,    27,
       0,   139,   140,     0,     0,   522,   141,     0,     0,   142,
       0,    25,     0,     0,    58,   143,     0,     0,     0,     0,
      26,   144,     0,     0,    59,    60,    61,    62,  -335,     0,
       0,    63,    64,    65,    66,    67,     0,    68,    69,    70,
       0,    71,     0,     0,    72,    73,    74,    75,    76,    77,
      78,    27,   208,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     0,     0,     0,    91,    92,     0,
       0,    93,    94,     0,    95,    96,    97,    98,    99,     0,
     100,   101,     0,   102,   103,   104,   603,   105,     0,   604,
     106,   343,   344,   345,   346,   605,   347,   348,     0,     0,
       0,     0,     0,     0,     0,   606,   607,   608,   609,  -335,
    -335,     0,   610,   611,   612,   613,   614,     0,   615,   616,
     617,     0,   618,     0,     0,   619,   620,   621,   622,   623,
     624,   625,   626,   627,   628,   629,   630,   631,   632,   633,
     634,   635,   636,   637,   638,     0,     0,     0,   639,   640,
       0,     0,   641,   642,     0,   643,   644,   645,   646,   647,
       0,   648,   649,     0,   650,   651,   652,     0,   653,   654,
       0,   655,     0,     0,   354,   355,   356,   357,   358,   359,
     360,   361,   267,     0,     0,     0,     0,   268,     0,     0,
       0,    58,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    59,    60,    61,    62,     0,     0,     0,    63,    64,
      65,    66,    67,     0,    68,    69,    70,     0,    71,     0,
       0,    72,    73,    74,    75,    76,    77,    78,     0,   269,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,     0,     0,    91,    92,     0,     0,    93,    94,
     117,    95,    96,    97,    98,    99,     0,   100,   101,    58,
     102,   103,   104,     0,   105,     0,     0,   106,     0,    59,
      60,    61,    62,     0,     0,     0,    63,    64,    65,    66,
      67,     0,    68,    69,    70,     0,    71,     0,     0,    72,
      73,    74,    75,    76,    77,    78,     0,   118,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,     0,
       0,     0,    91,    92,     0,     0,    93,    94,   122,    95,
      96,    97,    98,    99,     0,   100,   101,    58,   102,   103,
     104,     0,   105,     0,     0,   106,     0,    59,    60,    61,
      62,     0,     0,     0,    63,    64,    65,    66,    67,     0,
      68,    69,    70,     0,    71,     0,     0,    72,    73,    74,
      75,    76,    77,    78,     0,   123,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,     0,     0,     0,
      91,    92,     0,     0,    93,    94,   163,    95,    96,    97,
      98,    99,     0,   100,   101,    58,   102,   103,   104,     0,
     105,     0,     0,   106,     0,    59,    60,    61,    62,     0,
       0,     0,    63,    64,    65,    66,    67,     0,    68,    69,
      70,     0,    71,     0,     0,    72,    73,    74,    75,    76,
      77,    78,     0,   164,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,     0,     0,     0,    91,    92,
       0,     0,    93,    94,   259,    95,    96,    97,    98,    99,
       0,   100,   101,    58,   102,   103,   104,     0,   105,     0,
       0,   106,     0,    59,    60,    61,    62,     0,     0,     0,
      63,    64,    65,    66,    67,     0,    68,    69,    70,     0,
      71,     0,     0,    72,    73,    74,    75,    76,    77,    78,
       0,   123,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,     0,     0,     0,    91,    92,     0,     0,
      93,    94,   873,    95,    96,    97,    98,    99,     0,   100,
     101,    58,   102,   103,   104,     0,   105,     0,     0,   106,
       0,    59,    60,    61,    62,     0,     0,     0,    63,    64,
      65,    66,    67,     0,    68,    69,    70,     0,    71,     0,
       0,    72,    73,    74,    75,    76,    77,    78,     0,   874,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,     0,     0,     0,    91,    92,     0,     0,    93,    94,
     928,    95,    96,    97,    98,    99,     0,   100,   101,    58,
     102,   103,   104,     0,   105,     0,     0,   106,     0,    59,
      60,    61,    62,     0,     0,     0,    63,    64,    65,    66,
      67,     0,    68,    69,    70,     0,    71,     0,     0,    72,
      73,    74,    75,    76,    77,    78,     0,   874,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,     0,
       0,     0,    91,    92,     0,     0,    93,    94,     0,    95,
      96,    97,    98,    99,     0,   100,   101,    58,   102,   103,
     104,     0,   105,     0,     0,   106,     0,    59,    60,    61,
      62,     0,     0,     0,    63,    64,    65,    66,    67,     0,
      68,    69,    70,     0,    71,     0,     0,    72,    73,    74,
      75,    76,    77,    78,     0,   208,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,     0,     0,     0,
      91,    92,     0,     0,    93,    94,     0,    95,    96,    97,
      98,    99,     0,   100,   101,     0,   102,   103,   104,     0,
     105,  -659,  -659,   106,     0,     0,     0,     0,     0,   209,
       0,     0,  -659,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  -659,     0,
       0,  -659,  -659,     0,     0,  -659,     0,     0,     0,     0,
       0,  -659,     0,     0,  -659,     0,     0,     0,    58,     0,
       0,  -659,     0,     0,     0,     0,  -659,     0,    59,    60,
      61,    62,     0,     0,     0,    63,    64,    65,    66,    67,
     891,    68,    69,    70,     0,    71,   529,   530,    72,    73,
      74,    75,    76,    77,    78,     0,     0,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     0,     0,
       0,    91,    92,     0,     0,    93,    94,     0,    95,    96,
      97,    98,    99,     0,   100,   101,    58,   102,   103,   104,
       0,   105,     0,     0,   106,     0,    59,    60,    61,    62,
       0,     0,     0,    63,    64,    65,    66,    67,     0,    68,
      69,    70,     0,    71,     0,     0,    72,    73,    74,    75,
      76,    77,    78,     0,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     0,     0,     0,    91,
      92,     0,     0,    93,    94,     0,    95,    96,    97,    98,
      99,     0,   100,   101,    58,   102,   103,   104,     0,   105,
       0,     0,   106,     0,    59,    60,    61,    62,     0,     0,
       0,    63,    64,    65,    66,    67,     0,    68,    69,    70,
       0,    71,     0,     0,    72,    73,    74,    75,    76,    77,
      78,     0,   159,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     0,     0,     0,    91,    92,     0,
       0,    93,    94,     0,    95,    96,    97,    98,    99,     0,
     100,   101,    58,   102,   103,   104,     0,   105,     0,     0,
     106,     0,    59,    60,    61,    62,     0,     0,     0,    63,
      64,    65,    66,    67,     0,    68,    69,    70,     0,    71,
       0,     0,    72,    73,    74,    75,    76,    77,    78,     0,
     161,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     0,     0,     0,    91,    92,     0,     0,    93,
      94,     0,    95,    96,    97,    98,    99,     0,   100,   101,
      58,   102,   103,   104,     0,   105,     0,     0,   106,     0,
      59,    60,    61,    62,     0,     0,     0,    63,    64,    65,
      66,    67,     0,    68,    69,    70,     0,    71,     0,     0,
      72,    73,    74,    75,    76,    77,    78,     0,   176,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       0,     0,     0,    91,    92,     0,     0,    93,    94,     0,
      95,    96,    97,    98,    99,     0,   100,   101,    58,   102,
     103,   104,     0,   105,     0,     0,   106,     0,    59,    60,
      61,    62,     0,     0,     0,    63,    64,    65,    66,    67,
       0,    68,    69,    70,     0,    71,     0,     0,    72,    73,
      74,    75,    76,    77,    78,     0,   414,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     0,     0,
       0,    91,    92,     0,     0,    93,    94,     0,    95,    96,
      97,    98,    99,     0,   100,   101,    58,   102,   103,   104,
       0,   105,     0,     0,   106,     0,    59,    60,    61,    62,
       0,     0,     0,    63,    64,    65,    66,    67,     0,    68,
      69,    70,     0,    71,     0,     0,    72,    73,    74,    75,
      76,    77,    78,     0,   430,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     0,     0,     0,    91,
      92,     0,     0,    93,    94,     0,    95,    96,    97,    98,
      99,     0,   100,   101,    58,   102,   103,   104,     0,   105,
       0,     0,   106,     0,    59,    60,    61,    62,     0,     0,
       0,    63,    64,    65,    66,    67,     0,    68,    69,    70,
       0,    71,     0,     0,    72,    73,    74,    75,    76,    77,
      78,     0,   560,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,     0,     0,     0,    91,    92,     0,
       0,    93,    94,     0,    95,    96,    97,    98,    99,     0,
     100,   101,    58,   102,   103,   104,     0,   105,     0,     0,
     106,     0,    59,    60,    61,    62,     0,     0,     0,    63,
      64,    65,    66,    67,     0,    68,    69,    70,     0,    71,
       0,     0,    72,    73,    74,    75,    76,    77,    78,     0,
     706,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,     0,     0,     0,    91,    92,     0,     0,    93,
      94,     0,    95,    96,    97,    98,    99,     0,   100,   101,
      58,   102,   103,   104,     0,   105,     0,     0,   106,     0,
      59,    60,    61,    62,     0,     0,     0,    63,    64,    65,
      66,    67,     0,    68,    69,    70,     0,    71,     0,     0,
      72,    73,    74,    75,    76,    77,    78,     0,   713,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
       0,     0,     0,    91,    92,     0,     0,    93,    94,     0,
      95,    96,    97,    98,    99,     0,   100,   101,    58,   102,
     103,   104,     0,   105,     0,     0,   106,     0,    59,    60,
      61,    62,     0,     0,     0,    63,    64,    65,    66,    67,
       0,    68,    69,    70,     0,    71,     0,     0,    72,    73,
      74,    75,    76,    77,    78,     0,   208,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,     0,     0,
       0,    91,    92,     0,     0,    93,    94,     0,    95,    96,
      97,    98,    99,     0,   100,   101,    58,   102,   103,   104,
       0,   105,     0,     0,   106,     0,    59,    60,    61,    62,
       0,     0,     0,    63,    64,    65,    66,    67,     0,    68,
      69,    70,     0,    71,     0,     0,    72,    73,    74,    75,
      76,    77,    78,     0,   864,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,     0,     0,     0,    91,
      92,     0,     0,    93,    94,     0,    95,    96,    97,    98,
      99,     0,   100,   101,     0,   102,   103,   104,     0,   105,
     367,   368,   106,     0,     0,     0,     0,     0,  -645,  -645,
       0,   369,     0,     0,     0,     0,     0,     0,     0,  -645,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   370,     0,     0,
     371,   372,     0,     0,   373,  -645,     0,     0,  -645,  -645,
     374,     0,  -645,   375,     0,     0,     0,     0,  -645,     0,
     376,  -645,     0,     0,     0,   384,     0,     0,  -645,     0,
       0,     0,     0,  -645
};

static const yytype_int16 yycheck[] =
{
       6,     2,    35,   128,   226,   236,   237,    20,   151,   216,
     461,   257,    20,    33,   209,   172,   515,    30,   175,   351,
     560,    34,    30,    38,   280,    40,    34,   520,   503,     1,
     332,   598,    38,    24,    40,     1,   775,     6,    24,   295,
       1,     1,   811,     6,   783,    32,   815,   220,   221,    24,
       1,   833,    24,   835,    90,     1,     1,    48,    60,     1,
       1,   722,   844,    24,   237,   787,   315,     1,     6,    92,
      92,   107,    24,    38,    39,     0,   249,   193,   309,    32,
     302,     1,    24,    24,   806,     1,   108,   110,     6,   169,
      24,   313,   172,    56,     1,   175,   327,   213,   111,   112,
     882,   332,   115,   111,   112,   766,   108,   115,     1,    84,
      38,    39,   103,     1,   127,   128,     7,     3,    56,   888,
      38,   107,    40,     1,    90,   131,   113,    92,    97,     1,
     150,     1,   145,   382,   307,   308,   108,   145,   311,   111,
     103,   107,   103,   399,   446,   712,     1,   107,   917,     3,
     111,   111,     1,   105,     8,     9,   107,   103,   104,   332,
     111,   174,   107,   336,   663,   106,   174,   108,   188,   111,
     111,   184,   954,   713,   943,   190,   184,   111,   947,   194,
     949,   950,   438,   965,   190,   924,   106,     1,   194,   204,
     106,     4,   108,   449,   209,   977,   229,   966,   204,   214,
     107,    87,    88,   209,   679,    32,   452,    98,   214,    24,
     417,   212,    90,   131,   107,   446,   423,   463,    31,   107,
      32,   107,   237,   109,   237,    32,    92,   113,    41,   107,
     461,   237,   312,    87,    88,   107,   256,   107,   104,    52,
     236,   321,   322,    24,   761,   326,   326,   327,    97,   742,
     743,    92,   107,   107,   503,   109,   276,   106,   453,   113,
      24,   736,   511,   780,   520,   280,    79,   108,    38,    39,
     602,   286,   190,   446,   280,   193,   194,     1,   451,    48,
     286,   287,     6,    97,   297,    48,   204,     6,   461,   297,
     105,   209,   106,   108,   108,   213,   214,   104,   111,   379,
     381,   381,   382,   383,   384,   385,   319,    24,    32,   315,
     306,   319,   327,    32,   327,   757,   815,   332,   846,   332,
     103,   327,   103,    47,    48,    49,   332,     1,    24,   771,
     113,   364,    56,     7,   104,   863,   889,    56,    31,   103,
     104,   105,    32,    60,   377,   378,     1,   380,    41,    73,
      92,     6,   768,   892,   434,    92,   274,   773,    82,   106,
      24,   108,   280,   916,    38,    39,   108,    90,   286,   287,
     390,   108,    24,    24,   387,   455,   382,    32,   393,   387,
     103,   934,   921,   106,    92,    32,   103,   393,   105,   113,
     889,   108,    47,    48,    49,    32,   429,   412,    90,   103,
     108,    56,   106,   104,    92,   106,   412,   103,    38,   105,
      40,   424,   108,    90,   110,    89,   424,     4,    73,    24,
     108,   107,   961,   503,    98,   107,   682,    82,   967,   968,
     679,   446,   103,   446,   103,   106,   975,   106,   453,   103,
     446,   105,   107,    24,   108,   984,   461,   453,   461,   107,
     989,   103,   103,   105,   105,   461,   108,   108,   113,    38,
     103,    40,   542,   106,   113,   220,   221,   222,   107,    16,
      17,   551,   104,     6,   106,   393,    24,   232,   233,   725,
      38,    39,   237,   238,   239,   107,    24,   736,   789,   790,
      38,    39,    24,   107,   412,   107,   576,   503,   103,    32,
     105,    92,    24,   108,   760,   511,    99,   100,   101,   111,
     590,   962,   963,   593,    47,    48,    49,   742,   743,   103,
     600,   601,   103,    56,   105,    97,   775,   108,   103,    24,
     981,   544,   689,    24,   741,   453,   544,    24,    24,   107,
      73,    24,   107,   556,   687,   107,    90,    24,   556,    82,
      97,    98,    99,   100,   101,   103,   104,   105,    32,   716,
     190,     7,   719,   108,   194,   103,   788,   105,    90,   108,
     108,   103,   327,   105,   204,    48,   108,   332,   108,   209,
     113,   103,   108,   105,   214,   807,   106,   110,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,    90,   103,   689,
     105,   190,   103,   107,   105,   194,   103,   103,   105,   105,
     103,   701,   105,     6,   846,   204,   103,   953,   105,   108,
     956,   957,   108,   108,   106,   214,   716,   222,   964,   719,
      92,   863,   108,   892,   106,   106,   110,   232,   233,   108,
     280,   105,   110,   238,   239,   106,   286,   104,    48,    48,
     108,   987,    90,   106,   104,   680,   110,   792,   110,     7,
     108,   107,   921,   679,   680,   924,   106,   106,    90,   110,
     695,   903,   108,   698,   108,   765,   111,   767,   110,   695,
     705,   446,   698,    97,    98,    99,   100,   101,   108,   705,
     107,   280,    90,    90,   737,    90,   461,   286,   110,   108,
     108,   107,   961,   110,   108,   107,   107,    48,   967,   968,
      90,   107,    90,    90,   104,    90,   975,   103,   107,   107,
     736,   962,   963,   107,   107,   984,   749,    40,   753,   174,
     989,   749,   757,   107,   287,   903,   747,   753,   680,   906,
     981,   757,   909,   778,   417,   912,   771,   138,   911,   143,
     718,   901,   680,   393,   816,   771,   248,   780,   145,   775,
     749,   963,   780,   981,   789,   790,   576,   695,   248,   792,
     698,   983,   412,   789,   790,   818,   669,   705,   593,   962,
     963,   804,   313,    -1,    -1,    -1,   804,   810,    -1,    -1,
      -1,    -1,   810,    -1,    -1,   811,    -1,    -1,   981,   815,
      -1,    -1,    -1,     1,   393,    -1,   822,    -1,    -1,    -1,
      -1,    -1,    -1,   453,    -1,    -1,   906,    -1,    -1,   909,
      -1,    -1,   912,   412,    -1,   753,    -1,    25,    26,   757,
      11,    12,    13,    14,    -1,    16,    17,   602,    36,    -1,
      -1,   884,   885,   771,    -1,    -1,    -1,    -1,    -1,    -1,
     893,    -1,   895,   896,   944,    -1,    -1,    -1,    -1,    -1,
      -1,   789,   790,    -1,    62,    -1,    -1,    65,    66,    -1,
      -1,    69,   888,    -1,    -1,    -1,   892,    75,    -1,    -1,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    85,   911,    -1,
      -1,    -1,    90,   911,   822,    -1,   222,    -1,    -1,    -1,
      -1,   917,    -1,    -1,    -1,   921,   232,   233,   924,    -1,
     236,   237,   238,   239,    95,    96,    97,    98,    99,   100,
     101,    -1,    -1,   249,    -1,    -1,    -1,   943,    -1,    -1,
      -1,   947,   948,   949,   950,    -1,    -1,   962,   963,   962,
     963,    -1,    -1,    -1,    -1,   961,   962,   963,    -1,    -1,
     966,   967,   968,    -1,    -1,    -1,   981,    -1,   981,   975,
      -1,    -1,    -1,    -1,    -1,   981,    -1,   983,   984,    -1,
      -1,    -1,    -1,   989,    -1,    -1,    -1,    -1,    -1,    -1,
     306,   307,   308,    -1,    -1,   311,    11,    12,    13,    14,
      -1,    16,    17,    18,    19,    -1,    -1,    -1,    -1,    -1,
      -1,   327,    -1,    -1,    -1,    -1,   332,    -1,    -1,    -1,
     336,    -1,    -1,    -1,    -1,    -1,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,    -1,    -1,    -1,    -1,
     680,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   695,     1,    -1,   698,    12,
      13,     6,    -1,    16,    17,   705,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,    -1,    -1,    -1,
      -1,    -1,    27,    28,    -1,    -1,    -1,    32,    -1,    -1,
      35,   680,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,
      45,    -1,    47,    48,    49,    -1,   695,    -1,    -1,   698,
      -1,    56,    57,   753,    59,    -1,    -1,   757,    63,    64,
     446,    -1,    -1,    68,    -1,   451,    71,    -1,    73,    -1,
      -1,   771,    77,    -1,    -1,   461,    -1,    82,    83,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   789,
     790,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   108,   753,    -1,    -1,    -1,   113,    -1,
      -1,    -1,     0,     1,    -1,    -1,     4,    -1,     6,    11,
      12,    13,    14,    -1,    16,    17,    18,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    24,   962,   963,    27,
      28,    -1,    -1,    31,    32,    -1,    -1,    35,    -1,    -1,
      -1,    -1,    -1,    41,    42,    43,   981,    45,    -1,    47,
      48,    49,    -1,    51,    52,    53,    54,    55,    56,    57,
      -1,    59,    -1,    -1,    -1,    63,    64,    -1,    -1,    67,
      68,    -1,    70,    71,    72,    73,    74,    -1,    76,    77,
      -1,    79,    -1,    81,    82,    83,    -1,    -1,    86,    -1,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,    -1,    -1,     1,    -1,   103,   602,     5,     6,     7,
       8,     9,    10,   111,    -1,   113,    -1,    15,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      -1,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    -1,    80,    81,    82,    83,    -1,    85,    86,    -1,
      -1,    -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,   102,   103,    -1,    -1,    -1,   107,
      -1,   109,     1,    -1,    -1,   113,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    -1,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      -1,    80,    81,    82,    83,    -1,    85,    86,    -1,    -1,
      -1,    90,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,   107,    -1,
     109,    -1,     1,    -1,   113,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    24,    -1,    -1,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    -1,    63,    64,    -1,    -1,    67,    68,
      -1,    70,    71,    72,    73,    74,    -1,    76,    77,    -1,
      -1,    80,    81,    82,    83,    84,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,   103,    -1,   105,    -1,   107,    -1,
     109,    -1,   111,    -1,   113,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    -1,   962,   963,    -1,    20,
      21,    22,    23,    24,    -1,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,   981,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    -1,    63,    64,    -1,    -1,    67,    68,    -1,    70,
      71,    72,    73,    74,    -1,    76,    77,    -1,    -1,    80,
      81,    82,    83,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    96,    -1,    98,    99,    -1,
      -1,   102,    -1,    -1,    -1,    -1,   107,    -1,   109,    -1,
       1,    -1,   113,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    -1,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      61,    -1,    63,    64,    -1,    -1,    67,    68,    -1,    70,
      71,    72,    73,    74,    -1,    76,    77,    -1,    -1,    80,
      81,    82,    83,    84,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,   102,   103,    -1,    -1,    -1,   107,    -1,   109,     1,
     111,    -1,   113,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    24,    -1,    -1,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    -1,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    61,
      -1,    63,    64,    -1,    -1,    67,    68,    -1,    70,    71,
      72,    73,    74,    -1,    76,    77,    -1,    -1,    80,    81,
      82,    83,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
     102,   103,   104,   105,    -1,   107,    -1,   109,     1,    -1,
      -1,   113,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    -1,    -1,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    -1,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    61,    -1,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      73,    74,    -1,    76,    77,    -1,    -1,    80,    81,    82,
      83,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
      -1,    -1,   105,    -1,   107,   108,   109,     1,    -1,    -1,
     113,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      24,    -1,    -1,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    -1,    63,
      64,    -1,    -1,    67,    68,    -1,    70,    71,    72,    73,
      74,    -1,    76,    77,    -1,    -1,    80,    81,    82,    83,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,   103,
      -1,    -1,    -1,   107,    -1,   109,     1,    -1,    -1,   113,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      -1,    -1,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    -1,    37,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    61,    -1,    63,    64,
      -1,    -1,    67,    68,    -1,    70,    71,    72,    73,    74,
      -1,    76,    77,    -1,    -1,    80,    81,    82,    83,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,   102,   103,    -1,
      -1,    -1,   107,    -1,   109,     1,    -1,    -1,   113,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    -1,    63,    64,    -1,
      -1,    67,    68,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    -1,    80,    81,    82,    83,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,    -1,    -1,    -1,
      -1,   107,    -1,   109,     1,   111,    -1,   113,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    -1,
      37,    -1,    -1,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    -1,    63,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    72,    73,    74,    -1,    76,
      77,    -1,    -1,    80,    81,    82,    83,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,
     107,    -1,   109,     1,    -1,    -1,   113,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    -1,    37,
      -1,    -1,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    -1,    63,    64,    -1,    -1,    67,
      68,    -1,    70,    71,    72,    73,    74,    -1,    76,    77,
      -1,    -1,    80,    81,    82,    83,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      98,     5,     6,     7,   102,    -1,    10,    -1,    -1,   107,
      -1,   109,    -1,    -1,    -1,   113,    20,    21,    22,    23,
      24,    -1,    -1,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    61,    -1,    63,
      64,    -1,    -1,    67,    68,    -1,    70,    71,    72,    73,
      74,    -1,    76,    77,    -1,    -1,    80,    81,    82,    83,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    -1,     5,     6,     7,    -1,    -1,
      10,   105,    -1,   107,   108,   109,    -1,    -1,    -1,   113,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    -1,    63,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    72,    73,    74,    -1,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    -1,     5,
       6,     7,    -1,   103,    10,    -1,    -1,   107,    -1,   109,
      -1,    -1,    -1,   113,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    -1,    63,    64,    -1,
      -1,    67,    68,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    -1,    80,    81,    82,    83,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      -1,   107,    -1,   109,    15,    -1,    -1,   113,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
      31,    32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    -1,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    -1,    60,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    70,
      -1,    72,    73,    74,    -1,    76,    -1,    -1,    -1,    80,
      81,    82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,   102,    -1,    -1,    -1,    -1,   107,   108,   109,     1,
      -1,   112,   113,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,
      32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,    41,
      42,    -1,    44,    -1,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    70,    -1,
      72,    73,    74,    -1,    76,    -1,    -1,    -1,    80,    81,
      82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,
     102,    -1,    -1,    -1,    -1,   107,   108,   109,     1,    -1,
     112,   113,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,
      33,    34,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    -1,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    70,    -1,    72,
      73,    74,    -1,    76,    -1,    -1,    -1,    80,    81,    82,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
      -1,    -1,    -1,    -1,   107,   108,   109,   110,     1,    -1,
     113,    -1,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,
      23,    24,    -1,    -1,    -1,    -1,    29,    30,    31,    32,
      33,    34,    -1,    -1,    37,    -1,    -1,    40,    41,    42,
      -1,    44,    -1,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    -1,    58,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    67,    -1,    -1,    70,    -1,    72,
      73,    74,    -1,    76,    -1,    -1,    -1,    80,    81,    82,
      -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,
      -1,    -1,    -1,    -1,   107,    -1,   109,     1,    -1,    -1,
     113,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      -1,    15,    -1,    -1,    -1,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,
      34,    -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,
      44,    -1,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    -1,    58,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    67,    -1,    -1,    70,    -1,    72,    73,
      74,    -1,    76,    -1,    -1,    -1,    80,    81,    82,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    -1,    -1,    -1,   102,    -1,
      -1,    -1,    -1,   107,    -1,   109,     1,   111,    -1,   113,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,
      15,    -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,
      -1,    -1,    -1,    -1,    29,    30,    31,    32,    33,    34,
      -1,    -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,
      -1,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    -1,    58,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    67,    -1,    -1,    70,    -1,    72,    73,    74,
      -1,    76,    -1,    -1,    -1,    80,    81,    82,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    -1,    -1,   102,    -1,    -1,
      -1,    -1,   107,    -1,   109,     1,    -1,    -1,   113,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,
      -1,    -1,    -1,    -1,    20,    21,    22,    23,    24,    -1,
      -1,    -1,    -1,    29,    30,    31,    32,    33,    34,    -1,
      -1,    37,    -1,    -1,    40,    41,    42,    -1,    44,    -1,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    -1,    58,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    67,    -1,    -1,    70,    -1,    72,    73,    74,    -1,
      76,    -1,    -1,    -1,    80,    81,    82,    -1,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    -1,    -1,   102,    -1,    -1,    -1,
      -1,   107,    -1,   109,     1,    -1,    -1,   113,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    -1,    15,    -1,
      -1,    -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,
      -1,    -1,    29,    30,    31,    32,    33,    34,    -1,    -1,
      37,    -1,    -1,    40,    41,    42,    -1,    44,    -1,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      -1,    58,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      67,    -1,    -1,    70,    -1,    72,    73,    74,    -1,    76,
      -1,    -1,    -1,    80,    81,    82,    -1,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,
     107,    -1,   109,     1,    -1,    -1,   113,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    -1,
      -1,    29,    30,    31,    32,    33,    34,    -1,    -1,    37,
      -1,    -1,    40,    41,    42,    -1,    44,    -1,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    -1,
      58,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    67,
      -1,    -1,    70,    -1,    72,    73,    74,    -1,    76,    -1,
      -1,    -1,    80,    81,    82,    -1,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,   107,
      -1,   109,     1,    -1,    -1,   113,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,
      29,    30,    31,    32,    33,    34,    -1,    -1,    37,    -1,
      -1,    40,    41,    42,    -1,    44,    -1,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    -1,    58,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,
      -1,    70,    -1,    72,    73,    74,    -1,    76,    -1,    -1,
      -1,    80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,   107,    -1,
     109,     1,    -1,    -1,   113,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,
      30,    31,    32,    33,    34,    -1,    -1,    37,    -1,    -1,
      40,    41,    42,    -1,    44,    -1,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    -1,    58,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,
      70,    -1,    72,    73,    74,    -1,    76,    -1,    -1,    -1,
      80,    81,    82,    -1,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      -1,    -1,   102,    -1,    -1,    -1,    -1,   107,    -1,   109,
       1,    -1,    -1,   113,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
      31,    32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    -1,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    70,
      -1,    72,    73,    74,    -1,    76,    -1,    -1,    -1,    80,
      81,    82,    -1,    -1,     1,    86,    -1,     4,    -1,     6,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,   102,    -1,    -1,    -1,    -1,   107,    24,   109,    -1,
      27,    28,   113,    -1,    31,    32,    -1,    -1,    35,    -1,
      -1,    -1,    -1,    -1,    41,    42,    43,    -1,    45,    -1,
      47,    48,    49,    -1,    51,    52,    53,    54,    55,    56,
      57,    -1,    59,    -1,    -1,    -1,    63,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    72,    73,    74,    -1,    76,
      77,    -1,    79,    -1,    81,    82,    83,    -1,    -1,    86,
      -1,    -1,     1,    -1,    -1,     4,    -1,     6,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   103,    -1,   105,    -1,
      -1,    -1,    -1,    -1,   111,    24,   113,    -1,    27,    28,
      -1,    -1,    31,    32,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    41,    42,    43,    -1,    45,    -1,    47,    48,
      49,    -1,    51,    52,    53,    54,    55,    56,    57,    -1,
      59,    -1,    -1,    -1,    63,    64,    -1,    -1,    67,    68,
      -1,    70,    71,    72,    73,    74,    -1,    76,    77,    -1,
      79,    -1,    81,    82,    83,    -1,    -1,    86,     1,    -1,
      -1,    -1,     5,     6,     7,     8,     9,    -1,    -1,    -1,
      -1,    -1,    15,    -1,   103,    -1,   105,    -1,    21,    22,
      -1,    -1,   111,    -1,   113,    -1,    -1,    -1,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    41,    -1,
      -1,    -1,    -1,    46,    47,    48,    49,    -1,    -1,    -1,
      -1,    54,    -1,    56,    -1,    58,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      73,     5,     6,     7,     8,     9,    -1,    80,    -1,    82,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    31,    32,   102,
      -1,    -1,    -1,    -1,   107,    -1,   109,    41,    -1,    -1,
     113,    -1,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    56,    -1,    58,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    73,
       5,     6,     7,     8,     9,    -1,    80,    -1,    82,    -1,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    -1,    31,    32,   102,    -1,
      -1,    -1,    -1,   107,    -1,   109,    41,    -1,    -1,   113,
      -1,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    54,
      -1,    56,    -1,    58,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    73,     5,
       6,     7,     8,     9,    -1,    80,    -1,    82,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    31,    32,   102,    -1,    -1,
      -1,    -1,   107,    -1,   109,    41,    -1,    -1,   113,    -1,
      46,    47,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      56,    -1,    58,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    73,     5,     6,
       7,     8,     9,    -1,    80,    -1,    82,    -1,    15,    -1,
      -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    31,    32,   102,    -1,    -1,    -1,
      -1,   107,    -1,   109,    41,    -1,    -1,   113,    -1,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    56,
      -1,    58,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    73,     5,     6,     7,
       8,     9,    -1,    80,    -1,    82,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    31,    32,   102,    -1,    -1,    -1,    -1,
     107,    -1,   109,    41,    -1,    -1,   113,    -1,    46,    47,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    56,    -1,
      58,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    73,     5,     6,     7,     8,
       9,    -1,    80,    -1,    82,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    31,    32,   102,    -1,    -1,    -1,    -1,   107,
      -1,   109,    41,    -1,    -1,   113,    -1,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    54,    -1,    56,    -1,    58,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    73,     5,     6,     7,     8,     9,
      -1,    80,    -1,    82,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    31,    32,   102,    -1,    -1,    -1,    -1,   107,    -1,
     109,    41,    -1,    -1,   113,    -1,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    54,    -1,    56,    -1,    58,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       1,    -1,    -1,    73,     5,     6,     7,     8,     9,    -1,
      80,    -1,    82,    -1,    15,    -1,    -1,    -1,    -1,    -1,
      21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,
      31,    32,   102,    -1,    -1,    -1,    -1,   107,    -1,   109,
      41,    -1,    -1,   113,    -1,    46,    47,    48,    49,    -1,
      -1,    -1,    -1,    54,    -1,    56,    -1,    58,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,
      -1,    -1,    73,     5,     6,     7,     8,     9,    -1,    80,
      -1,    82,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,
      22,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    31,
      32,   102,    -1,    -1,    -1,    -1,   107,    -1,   109,    41,
      -1,    -1,   113,    -1,    46,    47,    48,    49,    -1,    -1,
      -1,    -1,    54,    -1,    56,    -1,    58,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,
      -1,    73,     5,     6,     7,     8,     9,    -1,    80,    -1,
      82,    -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,
      -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    31,    32,
     102,    -1,    -1,    -1,    -1,   107,    -1,   109,    41,    -1,
      -1,   113,    -1,    46,    47,    48,    49,    -1,    -1,    -1,
      -1,    54,    -1,    56,    -1,    58,    -1,    -1,    61,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      73,     5,     6,     7,     8,     9,    -1,    80,    -1,    82,
      -1,    15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    31,    32,   102,
      -1,    -1,    -1,    -1,   107,    -1,   109,    41,    -1,    -1,
     113,    -1,    46,    47,    48,    49,    -1,    -1,    -1,    -1,
      54,    -1,    56,    -1,    58,    -1,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    73,
       5,     6,     7,     8,     9,    -1,    80,    -1,    82,    -1,
      15,    -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    -1,    31,    32,   102,    -1,
      -1,    -1,    -1,   107,    -1,   109,    41,    -1,    -1,   113,
      -1,    46,    47,    48,    49,    -1,    -1,    -1,    -1,    54,
      -1,    56,    -1,    58,    -1,    -1,    61,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,    73,     5,
       6,     7,     8,     9,    -1,    80,    -1,    82,    -1,    15,
      -1,    -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    -1,
      -1,    -1,    -1,    98,    -1,    31,    32,   102,    -1,    -1,
      -1,    -1,   107,    -1,   109,    41,    -1,    -1,   113,    -1,
      46,    47,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,
      56,    -1,    58,    -1,    -1,    61,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     1,    -1,    -1,    73,     5,     6,
       7,     8,     9,    -1,    80,    -1,    82,    -1,    15,    -1,
      -1,    -1,    -1,    -1,    21,    22,    -1,    -1,    -1,    -1,
      -1,    -1,    98,    -1,    31,    32,   102,    -1,    -1,    -1,
      -1,   107,    -1,   109,    41,    -1,    -1,   113,    -1,    46,
      47,    48,    49,    -1,    -1,    -1,    -1,    54,    -1,    56,
      -1,    58,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    73,     5,     6,     7,
       8,     9,    -1,    80,    -1,    82,    -1,    15,    -1,    -1,
      -1,    -1,    -1,    21,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    98,    -1,    31,    32,   102,    -1,    -1,    -1,    -1,
     107,    -1,   109,    41,    -1,    -1,   113,    -1,    46,    47,
      48,    49,    -1,    -1,    -1,    -1,    54,    -1,    56,    -1,
      58,    -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     1,    -1,    -1,    73,     5,     6,     7,     8,
       9,    -1,    80,    -1,    82,    -1,    15,    -1,    -1,    -1,
      -1,    -1,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,
      98,    -1,    31,    32,   102,    -1,    -1,    -1,    -1,   107,
      -1,   109,    41,    -1,    -1,   113,    -1,    46,    47,    48,
      49,    -1,    -1,    -1,    -1,    54,    -1,    56,    -1,    58,
      -1,    -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     1,    -1,    -1,    73,     5,     6,     7,     8,     9,
      -1,    80,    -1,    82,    -1,    15,    -1,    -1,    -1,    -1,
      -1,    21,    22,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    31,    32,   102,    -1,    27,    28,    -1,   107,    -1,
     109,    41,    -1,    35,   113,    -1,    46,    47,    48,    49,
      -1,    43,    -1,    45,    54,    -1,    56,    -1,    58,    -1,
      -1,    61,    -1,    -1,    -1,    57,    -1,    59,    -1,    -1,
       1,    63,    64,    73,    -1,     6,    68,    -1,    -1,    71,
      80,    -1,    82,    -1,    -1,    77,    -1,    -1,    -1,    -1,
      -1,    83,    -1,    -1,    -1,    -1,    27,    28,    98,    -1,
      -1,    32,   102,    -1,    35,    -1,    -1,   107,    -1,   109,
      -1,    -1,    43,   113,    45,    -1,    47,    48,    49,    -1,
      -1,    -1,     1,    -1,    -1,    56,    57,     6,    59,    -1,
      -1,    -1,    63,    64,    -1,    -1,    -1,    68,    -1,    -1,
      71,    -1,    73,    -1,    -1,    -1,    77,    -1,    27,    28,
      -1,    82,    83,    32,    -1,    -1,    35,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    43,    -1,    45,    -1,    47,    48,
      49,     1,    -1,    -1,    -1,    -1,     6,    56,    57,    -1,
      59,    -1,   113,    -1,    63,    64,    -1,    -1,    -1,    68,
      -1,    -1,    71,    -1,    73,    25,    26,    -1,    77,    -1,
      -1,    -1,    32,    82,    83,    -1,    36,    -1,    -1,    11,
      12,    13,    14,    -1,    16,    17,    -1,    47,    48,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      -1,    -1,    62,    -1,   113,    65,    66,    -1,    -1,    69,
      -1,    -1,    -1,    73,    -1,    75,    -1,    -1,    78,    -1,
      -1,    -1,    82,     3,    -1,    85,    -1,    -1,     8,     9,
      90,    11,    12,    13,    14,    -1,    16,    17,    18,    19,
      -1,    -1,    -1,    -1,    24,    25,    26,    -1,    -1,    -1,
      -1,    -1,    -1,   113,    -1,    -1,    36,    -1,    38,    39,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
      -1,    -1,    -1,    11,    12,    13,    14,    -1,    16,    17,
      -1,    -1,    62,    -1,    -1,    65,    66,    -1,    -1,    69,
      -1,    -1,    -1,    -1,    -1,    75,    -1,    -1,    78,    -1,
      -1,    -1,    -1,    -1,    -1,    85,    -1,    87,    88,    -1,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,    -1,   103,   104,   105,   106,   107,   108,   109,
     110,     3,    -1,   113,    -1,    -1,     8,     9,    -1,    -1,
      -1,    -1,    -1,     1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    25,    26,    93,    94,    95,    96,    97,
      98,    99,   100,   101,    36,    -1,    24,    25,    26,    -1,
     343,   344,   345,   346,   347,   348,   349,   350,    36,   352,
     353,   354,   355,   356,   357,   358,   359,   360,   361,    -1,
      62,    -1,    -1,    65,    66,    -1,    -1,    69,     1,    -1,
      -1,    -1,    -1,    75,    62,    -1,    78,    65,    66,    -1,
      -1,    69,    -1,    85,    -1,    87,    88,    75,    90,    -1,
      78,    -1,    25,    26,    -1,    -1,    -1,    85,    -1,    -1,
      -1,    -1,    90,    36,   106,   107,    -1,   109,   110,    -1,
      -1,   113,    -1,    -1,    -1,   103,    -1,   105,   106,   107,
     108,     3,   110,   111,    -1,    -1,     8,     9,    42,    62,
      -1,    -1,    65,    66,    -1,    -1,    69,    -1,    -1,    53,
      54,    55,    75,    25,    26,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    85,    67,    36,    -1,    70,    90,    72,    -1,
      74,    -1,    76,    -1,    -1,    -1,    -1,    81,    -1,    -1,
      -1,    -1,    86,   106,    -1,    -1,    -1,   110,    -1,    -1,
      62,    -1,    -1,    65,    66,    -1,    -1,    69,    -1,    -1,
      -1,    -1,    -1,    75,    -1,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    85,    -1,    87,    88,    -1,    90,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     5,     6,
       7,     8,     9,    10,    -1,   107,    -1,   109,    15,    -1,
      -1,   113,    -1,    20,    21,    22,    23,    24,    -1,    -1,
      27,    28,    29,    30,    -1,    32,    33,    34,    35,    -1,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    61,    -1,    63,    64,    -1,    -1,
      67,    68,    -1,    70,    71,    72,    73,    74,    -1,    76,
      77,    -1,    -1,    80,    81,    82,    83,    -1,    -1,    86,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    98,    -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,
     107,    -1,   109,    -1,    -1,    -1,   113,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,
      -1,    -1,    20,    21,    22,    23,    24,    -1,    -1,    27,
      28,    29,    30,    -1,    32,    33,    34,    35,    -1,    37,
      -1,    -1,    40,    -1,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    61,    -1,    63,    64,    -1,    -1,    67,
      68,    -1,    70,    71,    72,    73,    74,    -1,    76,    77,
      -1,    -1,    80,    81,    82,    83,    -1,    -1,    86,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,    -1,
      98,    -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,   107,
      -1,   109,   110,    -1,    -1,   113,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    -1,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    61,    -1,    63,    64,    -1,    -1,    67,    68,
      -1,    70,    71,    72,    73,    74,    -1,    76,    77,    -1,
      -1,    80,    81,    82,    83,    -1,    -1,    86,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,
      -1,    -1,    -1,   102,    -1,    -1,    -1,    -1,   107,    -1,
     109,    -1,    -1,    -1,   113,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,
      20,    21,    22,    23,    24,    -1,    -1,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    61,    -1,    63,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    72,    73,    74,    -1,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    -1,    86,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,     5,
       6,     7,   102,    -1,    10,    -1,    -1,   107,    -1,   109,
      -1,    -1,    -1,   113,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    -1,    32,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    61,    -1,    63,    64,    -1,
      -1,    67,    68,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    -1,    80,    81,    82,    83,    -1,    -1,
      86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     5,     6,     7,     8,     9,    10,
      -1,   107,    -1,   109,    15,    -1,    -1,   113,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,
      31,    32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,
      41,    42,    -1,    44,    -1,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    -1,    58,    -1,    -1,
      61,    -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    70,
      -1,    72,    73,    74,    -1,    76,    -1,    -1,    -1,    80,
      81,    82,    -1,    -1,    -1,    86,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,
      -1,   102,    -1,    -1,    -1,    -1,   107,    -1,   109,    -1,
      -1,   112,   113,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    -1,    15,    -1,    -1,    -1,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    -1,    -1,    29,    30,    -1,
      32,    33,    34,    -1,    -1,    37,    -1,    -1,    40,    -1,
      42,    -1,    44,    -1,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    -1,    58,    -1,    -1,    61,
      -1,    -1,    -1,    -1,    -1,    67,    -1,    -1,    70,    -1,
      72,    73,    74,    -1,    76,    -1,    -1,    -1,    80,    81,
      82,    -1,    -1,    -1,    86,     5,     6,     7,     8,     9,
      -1,    -1,    -1,    -1,    -1,    15,    98,    -1,    -1,    -1,
     102,    21,    22,    -1,    -1,   107,    -1,   109,     5,     6,
       7,   113,    32,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    21,    22,    46,    47,    48,    49,
      -1,    -1,    -1,    -1,    54,    32,    56,    -1,    58,    -1,
      -1,    61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    46,
      47,    48,    49,    73,    -1,    -1,    -1,    54,    -1,    56,
      80,    58,    82,    -1,    61,    -1,    -1,    -1,    -1,    -1,
       6,    -1,    -1,    -1,    -1,    -1,    73,    -1,    98,    -1,
      -1,    -1,   102,    80,    -1,    82,    -1,   107,    -1,   109,
      -1,    27,    28,   113,    -1,    -1,    32,    -1,    -1,    35,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,    -1,    45,
     107,    47,    48,    49,    -1,    -1,   113,    -1,    -1,    -1,
      56,    57,     6,    59,    -1,    -1,    -1,    63,    64,    -1,
      -1,    -1,    68,    -1,    -1,    71,    -1,    73,    -1,    -1,
      -1,    77,    -1,    27,    28,    -1,    82,    83,    32,    -1,
      -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    43,
      -1,    45,    -1,    47,    48,    49,    -1,    -1,    -1,    -1,
     106,    -1,    56,    57,     6,    59,    -1,   113,    -1,    63,
      64,    -1,    -1,    -1,    68,    -1,    -1,    71,    -1,    73,
      -1,    -1,    -1,    77,    -1,    27,    28,    -1,    82,    83,
      32,    -1,    -1,    35,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    43,    -1,    45,    -1,    47,    48,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    56,    57,    -1,    59,    -1,   113,
      -1,    63,    64,    -1,    -1,     1,    68,    -1,    -1,    71,
      -1,    73,    -1,    -1,    10,    77,    -1,    -1,    -1,    -1,
      82,    83,    -1,    -1,    20,    21,    22,    23,    24,    -1,
      -1,    27,    28,    29,    30,    31,    -1,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,   113,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    -1,    -1,    63,    64,    -1,
      -1,    67,    68,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    -1,    79,    80,    81,     1,    83,    -1,     4,
      86,    11,    12,    13,    14,    10,    16,    17,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    20,    21,    22,    23,   105,
     106,    -1,    27,    28,    29,    30,    31,    -1,    33,    34,
      35,    -1,    37,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    -1,    -1,    63,    64,
      -1,    -1,    67,    68,    -1,    70,    71,    72,    73,    74,
      -1,    76,    77,    -1,    79,    80,    81,    -1,    83,    84,
      -1,    86,    -1,    -1,    94,    95,    96,    97,    98,    99,
     100,   101,     1,    -1,    -1,    -1,    -1,     6,    -1,    -1,
      -1,    10,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    -1,    33,    34,    35,    -1,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    -1,    -1,    63,    64,    -1,    -1,    67,    68,
       1,    70,    71,    72,    73,    74,    -1,    76,    77,    10,
      79,    80,    81,    -1,    83,    -1,    -1,    86,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      -1,    -1,    63,    64,    -1,    -1,    67,    68,     1,    70,
      71,    72,    73,    74,    -1,    76,    77,    10,    79,    80,
      81,    -1,    83,    -1,    -1,    86,    -1,    20,    21,    22,
      23,    -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,
      33,    34,    35,    -1,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    -1,    -1,
      63,    64,    -1,    -1,    67,    68,     1,    70,    71,    72,
      73,    74,    -1,    76,    77,    10,    79,    80,    81,    -1,
      83,    -1,    -1,    86,    -1,    20,    21,    22,    23,    -1,
      -1,    -1,    27,    28,    29,    30,    31,    -1,    33,    34,
      35,    -1,    37,    -1,    -1,    40,    41,    42,    43,    44,
      45,    46,    -1,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    -1,    -1,    -1,    63,    64,
      -1,    -1,    67,    68,     1,    70,    71,    72,    73,    74,
      -1,    76,    77,    10,    79,    80,    81,    -1,    83,    -1,
      -1,    86,    -1,    20,    21,    22,    23,    -1,    -1,    -1,
      27,    28,    29,    30,    31,    -1,    33,    34,    35,    -1,
      37,    -1,    -1,    40,    41,    42,    43,    44,    45,    46,
      -1,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    -1,    -1,    -1,    63,    64,    -1,    -1,
      67,    68,     1,    70,    71,    72,    73,    74,    -1,    76,
      77,    10,    79,    80,    81,    -1,    83,    -1,    -1,    86,
      -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,    28,
      29,    30,    31,    -1,    33,    34,    35,    -1,    37,    -1,
      -1,    40,    41,    42,    43,    44,    45,    46,    -1,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    -1,    -1,    -1,    63,    64,    -1,    -1,    67,    68,
       1,    70,    71,    72,    73,    74,    -1,    76,    77,    10,
      79,    80,    81,    -1,    83,    -1,    -1,    86,    -1,    20,
      21,    22,    23,    -1,    -1,    -1,    27,    28,    29,    30,
      31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,
      41,    42,    43,    44,    45,    46,    -1,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    -1,
      -1,    -1,    63,    64,    -1,    -1,    67,    68,    -1,    70,
      71,    72,    73,    74,    -1,    76,    77,    10,    79,    80,
      81,    -1,    83,    -1,    -1,    86,    -1,    20,    21,    22,
      23,    -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,
      33,    34,    35,    -1,    37,    -1,    -1,    40,    41,    42,
      43,    44,    45,    46,    -1,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    -1,    -1,    -1,
      63,    64,    -1,    -1,    67,    68,    -1,    70,    71,    72,
      73,    74,    -1,    76,    77,    -1,    79,    80,    81,    -1,
      83,    25,    26,    86,    -1,    -1,    -1,    -1,    -1,    92,
      -1,    -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,
      -1,    65,    66,    -1,    -1,    69,    -1,    -1,    -1,    -1,
      -1,    75,    -1,    -1,    78,    -1,    -1,    -1,    10,    -1,
      -1,    85,    -1,    -1,    -1,    -1,    90,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    28,    29,    30,    31,
     104,    33,    34,    35,    -1,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    -1,    -1,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    -1,
      -1,    63,    64,    -1,    -1,    67,    68,    -1,    70,    71,
      72,    73,    74,    -1,    76,    77,    10,    79,    80,    81,
      -1,    83,    -1,    -1,    86,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    -1,    -1,    63,
      64,    -1,    -1,    67,    68,    -1,    70,    71,    72,    73,
      74,    -1,    76,    77,    10,    79,    80,    81,    -1,    83,
      -1,    -1,    86,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    -1,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    -1,    -1,    63,    64,    -1,
      -1,    67,    68,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    10,    79,    80,    81,    -1,    83,    -1,    -1,
      86,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    -1,    33,    34,    35,    -1,    37,
      -1,    -1,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    -1,    -1,    63,    64,    -1,    -1,    67,
      68,    -1,    70,    71,    72,    73,    74,    -1,    76,    77,
      10,    79,    80,    81,    -1,    83,    -1,    -1,    86,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    -1,    -1,    63,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    72,    73,    74,    -1,    76,    77,    10,    79,
      80,    81,    -1,    83,    -1,    -1,    86,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    -1,
      -1,    63,    64,    -1,    -1,    67,    68,    -1,    70,    71,
      72,    73,    74,    -1,    76,    77,    10,    79,    80,    81,
      -1,    83,    -1,    -1,    86,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    -1,    -1,    63,
      64,    -1,    -1,    67,    68,    -1,    70,    71,    72,    73,
      74,    -1,    76,    77,    10,    79,    80,    81,    -1,    83,
      -1,    -1,    86,    -1,    20,    21,    22,    23,    -1,    -1,
      -1,    27,    28,    29,    30,    31,    -1,    33,    34,    35,
      -1,    37,    -1,    -1,    40,    41,    42,    43,    44,    45,
      46,    -1,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    -1,    -1,    -1,    63,    64,    -1,
      -1,    67,    68,    -1,    70,    71,    72,    73,    74,    -1,
      76,    77,    10,    79,    80,    81,    -1,    83,    -1,    -1,
      86,    -1,    20,    21,    22,    23,    -1,    -1,    -1,    27,
      28,    29,    30,    31,    -1,    33,    34,    35,    -1,    37,
      -1,    -1,    40,    41,    42,    43,    44,    45,    46,    -1,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    -1,    -1,    -1,    63,    64,    -1,    -1,    67,
      68,    -1,    70,    71,    72,    73,    74,    -1,    76,    77,
      10,    79,    80,    81,    -1,    83,    -1,    -1,    86,    -1,
      20,    21,    22,    23,    -1,    -1,    -1,    27,    28,    29,
      30,    31,    -1,    33,    34,    35,    -1,    37,    -1,    -1,
      40,    41,    42,    43,    44,    45,    46,    -1,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      -1,    -1,    -1,    63,    64,    -1,    -1,    67,    68,    -1,
      70,    71,    72,    73,    74,    -1,    76,    77,    10,    79,
      80,    81,    -1,    83,    -1,    -1,    86,    -1,    20,    21,
      22,    23,    -1,    -1,    -1,    27,    28,    29,    30,    31,
      -1,    33,    34,    35,    -1,    37,    -1,    -1,    40,    41,
      42,    43,    44,    45,    46,    -1,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    -1,    -1,
      -1,    63,    64,    -1,    -1,    67,    68,    -1,    70,    71,
      72,    73,    74,    -1,    76,    77,    10,    79,    80,    81,
      -1,    83,    -1,    -1,    86,    -1,    20,    21,    22,    23,
      -1,    -1,    -1,    27,    28,    29,    30,    31,    -1,    33,
      34,    35,    -1,    37,    -1,    -1,    40,    41,    42,    43,
      44,    45,    46,    -1,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    -1,    -1,    -1,    63,
      64,    -1,    -1,    67,    68,    -1,    70,    71,    72,    73,
      74,    -1,    76,    77,    -1,    79,    80,    81,    -1,    83,
      25,    26,    86,    -1,    -1,    -1,    -1,    -1,    25,    26,
      -1,    36,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    62,    -1,    -1,
      65,    66,    -1,    -1,    69,    62,    -1,    -1,    65,    66,
      75,    -1,    69,    78,    -1,    -1,    -1,    -1,    75,    -1,
      85,    78,    -1,    -1,    -1,    90,    -1,    -1,    85,    -1,
      -1,    -1,    -1,    90
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,   115,   116,     0,     1,    24,    51,   103,   123,   124,
     127,   138,   155,   156,   244,    24,   103,   105,     1,     6,
      32,    47,    48,    49,    56,    73,    82,   113,   297,   298,
     299,   300,   311,   312,     4,    31,    41,    52,    79,   111,
     158,   232,   240,    42,    53,    54,    55,    67,    70,    72,
      74,    76,    81,    86,   149,    24,   103,   105,    10,    20,
      21,    22,    23,    27,    28,    29,    30,    31,    33,    34,
      35,    37,    40,    41,    42,    43,    44,    45,    46,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    63,    64,    67,    68,    70,    71,    72,    73,    74,
      76,    77,    79,    80,    81,    83,    86,   315,   316,    32,
     113,    32,    32,    48,   103,   113,    32,     1,    48,   315,
     103,   311,     1,    48,   125,   126,   315,   195,   241,     1,
     121,   122,    27,    28,    35,    43,    45,    57,    59,    63,
      64,    68,    71,    77,    83,   166,   168,   169,   170,   297,
     312,   142,    28,    35,   129,   157,   163,   166,    48,    48,
     315,    48,   315,     1,    48,   315,    32,    32,    24,    90,
     103,   105,    90,   103,   106,    90,    48,   144,   315,   144,
      24,   103,   105,     1,   104,   118,   119,   297,   312,   313,
     107,   185,     1,   107,   107,   107,   179,   107,   174,   185,
     107,   186,   176,   177,   107,   178,   174,   175,    48,    92,
     235,   315,   116,   107,   107,     4,   137,     1,     5,     7,
       8,     9,    15,    21,    22,    24,    46,    54,    58,    61,
      73,    80,    98,   102,   107,   109,   130,   134,   160,   161,
     219,   251,   279,   280,   288,   289,   290,   293,   294,   295,
     296,   297,   302,   303,   305,   307,   312,   316,   251,     1,
     125,   251,   233,   111,    24,   103,   105,     1,     6,    48,
     117,   314,   315,   103,    97,   166,   312,   313,     1,   166,
     180,     1,     7,    89,    98,   172,   187,   107,     1,   166,
     168,   103,    24,   105,   133,   313,   108,   159,   190,   191,
      21,    22,    46,    54,    58,    80,   130,   295,   295,   134,
     289,   295,   107,   306,     1,   107,   111,   196,   304,    32,
     195,   195,   107,   289,   289,     1,   111,   134,   167,   169,
     277,   279,   134,   162,   167,   170,   295,   297,   308,   309,
     316,   289,   289,    11,    12,    13,    14,    16,    17,    18,
      19,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   232,   240,     3,     8,     9,    25,    26,    36,
      62,    65,    66,    69,    75,    78,    85,    87,    88,    90,
     113,   130,   134,   281,    90,   281,   234,   242,     6,    97,
     312,   108,     1,   106,   108,   108,   106,   166,   182,   183,
     282,   108,   108,     7,    38,    39,   173,   166,   119,   120,
     108,   108,   106,   282,    48,   315,   103,   106,   167,     1,
     279,   304,     1,   164,   165,   167,   170,   276,   277,   197,
      48,   315,   218,     1,   112,   278,   279,   283,   284,     1,
     279,    24,   103,   105,   108,   283,   134,   279,   285,   286,
     287,   295,   316,    92,   108,   106,   108,   167,   309,    48,
     110,   106,   310,   110,     1,   288,     1,   288,     1,   288,
       1,   288,     1,   288,     1,   288,     1,   288,     1,   288,
     280,     1,   288,     1,   288,     1,   288,     1,   288,     1,
     288,     1,   288,     1,   288,     1,   288,     1,   288,     1,
     288,   195,   195,   195,     1,   279,   195,     1,   283,     1,
      24,    96,    99,   276,   279,   301,     1,   279,   279,   279,
     107,   229,     1,   235,   237,   239,     6,   108,   166,    38,
      39,   143,   106,   282,     7,    98,   171,   104,   108,   108,
      90,   136,    90,   141,   159,   191,    24,   103,   105,   108,
       1,   106,    24,   103,   105,   108,   159,   193,   202,   224,
      48,   194,   203,   222,   315,   108,   195,   217,    24,    60,
     103,   105,   108,   279,    60,   108,   106,   282,    24,   103,
     105,   108,   108,   105,   132,   309,    24,   103,   104,   105,
     270,   110,   135,   106,   282,   168,   279,   110,   308,     1,
      90,   281,   104,     1,     4,    10,    20,    21,    22,    23,
      27,    28,    29,    30,    31,    33,    34,    35,    37,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    63,
      64,    67,    68,    70,    71,    72,    73,    74,    76,    77,
      79,    80,    81,    83,    84,    86,   150,   151,   152,   153,
     154,    48,   279,   301,    48,    24,   103,   105,   108,   108,
      24,   103,   105,   108,   110,    24,   276,   110,   110,   173,
     155,   226,   227,   228,   282,     1,    24,   111,   230,    90,
     236,   106,   243,   108,   104,   184,     7,   108,   188,     1,
      24,   192,     1,   107,   279,   107,    48,   315,    24,   103,
     105,   108,   279,    48,   315,   106,    90,   217,   106,    90,
     198,     1,   220,   278,   108,   110,     1,   279,   108,     1,
     287,   310,   279,   279,   280,   110,   173,   111,   291,   291,
     301,   129,   104,   106,   282,   108,   131,   116,   251,   238,
      24,   105,   199,   181,   166,   166,   279,   139,   145,   147,
     148,   166,   282,     1,   310,    90,   217,    90,   201,   251,
       1,   107,   146,   201,   251,   207,   146,   301,   195,   110,
     159,   226,   226,   231,   237,   166,   189,   147,   108,   104,
     106,   282,   143,    24,   103,   105,   108,   108,     1,    24,
     279,     1,   146,   279,   159,   193,   147,   223,   193,     1,
       4,    10,    20,    23,    29,    30,    33,    34,    37,    44,
      48,    50,    51,    84,   103,   124,   196,   199,   206,   208,
     209,   210,   211,   214,   215,   216,   245,   254,   257,   259,
     262,   266,   269,   271,   273,   276,   221,   110,   136,   143,
     315,   199,   108,   108,   131,     1,    24,   103,   128,   196,
     145,   145,   144,   225,    48,   131,     1,    24,   196,   200,
      24,   103,   105,     1,    48,   204,   205,   315,     1,    24,
     103,   258,   275,   276,   267,   255,    48,   213,   173,   275,
     213,   104,   195,   260,   212,   246,   263,   258,   258,   258,
     200,   292,    48,   140,   200,    24,    90,   103,   105,    90,
     103,   106,    90,   258,   195,   195,   275,   173,   270,   210,
     195,   104,   195,   195,   207,   128,   251,   251,     1,   204,
     251,   268,   256,   270,   274,   275,    24,    84,   261,   210,
     247,   264,   199,   107,   107,   270,    24,   107,   107,   107,
     107,   275,   279,   275,   272,   275,   275,   275,    24,   105,
     108,   248,   103,   106,   253,   248,   258,   248,   248,   210,
       1,   250,   252,   308,   250,   248,   258,   265,   275,   210,
     210,   103,   210,   258,    40,   249,   252,   272,   210,   248,
     210
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   114,   115,   115,   116,   116,   116,   117,   117,   118,
     118,   118,   118,   119,   119,   120,   122,   121,   123,   123,
     123,   123,   123,   123,   123,   124,   124,   124,   124,   124,
     125,   125,   125,   126,   126,   127,   127,   127,   127,   128,
     128,   128,   128,   129,   130,   131,   131,   132,   132,   133,
     133,   134,   135,   135,   136,   137,   137,   139,   140,   138,
     138,   141,   138,   138,   138,   138,   138,   138,   138,   138,
     138,   138,   138,   142,   138,   143,   143,   143,   144,   144,
     144,   145,   146,   147,   147,   148,   148,   148,   149,   149,
     149,   149,   149,   149,   149,   149,   149,   149,   149,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     151,   151,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   151,   151,   151,   151,   151,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   152,   152,   152,   152,
     152,   152,   152,   152,   152,   152,   152,   152,   152,   153,
     153,   153,   154,   154,   154,   155,   156,   156,   157,   157,
     157,   158,   158,   159,   160,   161,   162,   162,   163,   164,
     165,   166,   166,   167,   167,   168,   168,   169,   169,   169,
     169,   169,   169,   169,   169,   169,   169,   169,   169,   169,
     169,   169,   169,   170,   171,   171,   171,   172,   172,   172,
     173,   173,   174,   174,   174,   174,   175,   176,   177,   176,
     178,   178,   178,   180,   181,   179,   179,   182,   182,   183,
     184,   183,   185,   185,   187,   188,   189,   186,   186,   190,
     190,   191,   191,   192,   191,   191,   191,   191,   193,   193,
     193,   193,   193,   193,   194,   194,   194,   194,   195,   197,
     198,   196,   199,   199,   200,   200,   200,   201,   202,   202,
     203,   203,   204,   204,   204,   205,   205,   206,   206,   206,
     206,   207,   207,   208,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   210,   210,   210,   210,
     210,   210,   210,   210,   210,   212,   211,   213,   213,   214,
     215,   215,   216,   217,   218,   220,   221,   219,   219,   223,
     222,   222,   225,   224,   224,   226,   226,   227,   227,   227,
     228,   228,   229,   229,   231,   230,   230,   230,   233,   234,
     232,   235,   235,   236,   236,   237,   237,   238,   239,   239,
     239,   241,   242,   243,   240,   244,   246,   247,   245,   248,
     248,   248,   249,   249,   250,   250,   251,   251,   251,   252,
     252,   253,   253,   255,   256,   254,   257,   257,   257,   258,
     258,   260,   261,   259,   263,   264,   262,   265,   265,   267,
     268,   266,   269,   269,   269,   270,   270,   270,   270,   271,
     271,   272,   272,   273,   274,   274,   275,   275,   276,   276,
     276,   276,   276,   277,   277,   278,   278,   279,   279,   279,
     279,   279,   279,   279,   279,   279,   279,   280,   280,   281,
     281,   281,   281,   281,   281,   281,   281,   281,   281,   282,
     282,   283,   283,   284,   284,   285,   285,   286,   286,   286,
     287,   287,   288,   288,   288,   288,   288,   288,   288,   288,
     288,   288,   288,   288,   288,   288,   288,   288,   288,   288,
     288,   288,   288,   288,   288,   288,   288,   288,   288,   288,
     288,   288,   288,   288,   288,   288,   288,   288,   288,   289,
     289,   289,   289,   289,   289,   289,   289,   290,   290,   290,
     291,   292,   291,   293,   293,   293,   293,   293,   294,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   295,   295,   295,   295,   295,   295,   296,
     296,   296,   297,   297,   297,   297,   298,   298,   299,   299,
     299,   299,   300,   300,   300,   300,   300,   300,   300,   300,
     300,   300,   300,   300,   300,   301,   301,   301,   301,   301,
     302,   303,   303,   303,   303,   303,   304,   304,   304,   304,
     304,   304,   304,   306,   305,   307,   307,   307,   307,   307,
     307,   307,   307,   307,   307,   307,   307,   307,   308,   308,
     308,   308,   309,   310,   310,   311,   311,   312,   312,   313,
     313,   314,   314,   314,   315,   315,   315,   315,   315,   315,
     315,   315,   315,   315,   315,   315,   315,   315,   315,   315,
     315,   315,   315,   316,   316,   316,   316,   316,   316,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     316,   316,   316
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     2,     0,     1,     1,     2,
       2,     2,     0,     1,     1,     1,     0,     2,     5,     5,
       5,     5,     4,     4,     4,     3,     3,     3,     3,     3,
       3,     3,     3,     1,     3,     4,     4,     4,     4,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     1,
       1,     1,     1,     0,     0,     0,     1,     0,     0,    13,
       8,     0,    11,     6,     1,     1,     1,     2,     2,     1,
       2,     2,     2,     0,     5,     1,     1,     0,     1,     1,
       0,     3,     3,     1,     2,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     5,     3,
       1,     0,     2,     0,     3,     3,     1,     1,     1,     1,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     6,     5,
       2,     4,     4,     1,     0,     1,     2,     0,     1,     2,
       1,     1,     0,     3,     5,     3,     1,     0,     0,     4,
       0,     3,     3,     0,     0,     8,     0,     1,     2,     1,
       0,     4,     3,     0,     0,     0,     0,     8,     0,     1,
       3,     2,     2,     0,     5,     4,     4,     4,     2,     2,
       4,     4,     4,     4,     1,     1,     3,     3,     0,     0,
       0,     6,     1,     1,     1,     1,     1,     0,     1,     4,
       1,     4,     3,     3,     3,     1,     3,     3,     3,     3,
       3,     0,     2,     2,     1,     1,     1,     1,     1,     1,
       2,     2,     2,     2,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     4,     1,     0,     2,
       2,     1,     2,     0,     0,     0,     0,     8,     5,     0,
       5,     3,     0,     6,     4,     5,     4,     1,     3,     3,
       1,     2,     0,     3,     0,     4,     1,     1,     0,     0,
       7,     1,     1,     0,     2,     0,     2,     0,     1,     4,
       1,     0,     0,     0,     8,     5,     0,     0,     9,     1,
       1,     1,     0,     2,     1,     1,     1,     1,     1,     0,
       1,     2,     4,     0,     0,     9,     8,     5,     4,     1,
       1,     0,     0,    12,     0,     0,     8,     0,     1,     0,
       0,     8,     3,     5,     4,     1,     1,     1,     1,     2,
       3,     0,     1,     1,     0,     1,     1,     1,     1,     2,
       2,     2,     2,     1,     3,     1,     2,     1,     3,     3,
       3,     5,     3,     3,     3,     5,     4,     1,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       1,     0,     2,     1,     3,     0,     2,     1,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       2,     2,     2,     2,     2,     2,     2,     1,     2,     2,
       0,     0,     6,     5,     5,     4,     4,     4,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       1,     4,     4,     6,     5,     7,     4,     4,     4,     4,
       4,     3,     5,     5,     4,     4,     3,     3,     3,     3,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     1,
       3,     3,     1,     3,     3,     3,     1,     1,     2,     2,
       3,     3,     1,     2,     3,     1,     3,     3,     3,     3,
       2,     2,     2,     2,     2,     0,     1,     2,     1,     2,
       2,     4,     4,     4,     4,     4,     3,     3,     3,     3,
       3,     1,     1,     0,     3,     7,     7,     7,     7,     7,
       5,     5,     5,     5,     4,     4,     4,     4,     1,     3,
       2,     1,     2,     0,     3,     1,     1,     1,     2,     1,
       3,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 383 "language.yacc" /* yacc.c:1646  */
    { YYACCEPT; }
#line 3822 "y.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 384 "language.yacc" /* yacc.c:1646  */
    { YYACCEPT; }
#line 3828 "y.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 397 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 3834 "y.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 398 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 3840 "y.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 399 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 3846 "y.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 400 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 3852 "y.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 407 "language.yacc" /* yacc.c:1646  */
    {
    STACK_LEVEL_START(0);

    ref_push_string((yyvsp[0].n)->u.sval.u.string);
    if (call_handle_inherit((yyvsp[0].n)->u.sval.u.string)) {
      STACK_LEVEL_CHECK(2);
      (yyval.n)=mksvaluenode(Pike_sp-1);
      pop_stack();
    }
    else
      (yyval.n)=mknewintnode(0);
    STACK_LEVEL_CHECK(1);
    if((yyval.n)->name) free_string((yyval.n)->name);
#ifdef PIKE_DEBUG
    if (TYPEOF(Pike_sp[-1]) != T_STRING) {
      Pike_fatal("Compiler lost track of program name.\n");
    }
#endif /* PIKE_DEBUG */
    /* FIXME: Why not use $1->u.sval.u.string here? */
    add_ref( (yyval.n)->name=Pike_sp[-1].u.string );
    free_node((yyvsp[0].n));

    STACK_LEVEL_DONE(1);
  }
#line 3881 "y.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 432 "language.yacc" /* yacc.c:1646  */
    {
    STACK_LEVEL_START(0);

    if(Pike_compiler->last_identifier)
    {
      ref_push_string(Pike_compiler->last_identifier);
    }else{
      push_empty_string();
    }
    (yyval.n)=(yyvsp[0].n);

    STACK_LEVEL_DONE(1);
  }
#line 3899 "y.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 449 "language.yacc" /* yacc.c:1646  */
    {
    STACK_LEVEL_START(0);

    resolv_program((yyvsp[0].n));
    free_node((yyvsp[0].n));

    STACK_LEVEL_DONE(1);
  }
#line 3912 "y.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 460 "language.yacc" /* yacc.c:1646  */
    {
    SET_FORCE_RESOLVE((yyval.number));
  }
#line 3920 "y.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 464 "language.yacc" /* yacc.c:1646  */
    {
    UNSET_FORCE_RESOLVE((yyvsp[-1].number));
    (yyval.n) = (yyvsp[0].n);
  }
#line 3929 "y.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 471 "language.yacc" /* yacc.c:1646  */
    {
    if (((yyvsp[-4].number) & ID_EXTERN) && (Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared inherit.");
    }
    if((yyvsp[-2].n))
    {
      struct pike_string *s=Pike_sp[-1].u.string;
      if((yyvsp[-1].n)) s=(yyvsp[-1].n)->u.sval.u.string;
      compiler_do_inherit((yyvsp[-2].n),(yyvsp[-4].number),s);
    }
    if((yyvsp[-1].n)) free_node((yyvsp[-1].n));
    pop_stack();
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
  }
#line 3948 "y.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 486 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerrok;
  }
#line 3958 "y.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 492 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 3969 "y.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 499 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].n)) free_node((yyvsp[-2].n));
    pop_stack();
    yyerror("Missing ';'.");
  }
#line 3979 "y.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 504 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 3985 "y.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 506 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 3994 "y.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 510 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ';'."); }
#line 4000 "y.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 514 "language.yacc" /* yacc.c:1646  */
    {
    resolv_constant((yyvsp[-1].n));
    free_node((yyvsp[-1].n));
    use_module(Pike_sp-1);
    pop_stack();
  }
#line 4011 "y.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 521 "language.yacc" /* yacc.c:1646  */
    {
    if (call_handle_import((yyvsp[-1].n)->u.sval.u.string)) {
      use_module(Pike_sp-1);
      pop_stack();
    }
    free_node((yyvsp[-1].n));
  }
#line 4023 "y.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 528 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 4029 "y.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 530 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 4038 "y.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 534 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ';'."); }
#line 4044 "y.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 538 "language.yacc" /* yacc.c:1646  */
    {
    /* This can be made more lenient in the future */

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
      Pike_compiler->compiler_pass=tmp;
    }

    if (!TEST_COMPAT(7, 6) && (Pike_compiler->current_modifiers & ID_EXTERN)) {
      int depth = 0;
      struct program_state *state = Pike_compiler;
      node *n = (yyvsp[0].n);
      while (((n->token == F_COMMA_EXPR) || (n->token == F_ARG_LIST)) &&
	     ((!CAR(n)) ^ (!CDR(n)))) {
	if (CAR(n)) n = CAR(n);
	else n = CDR(n);
      }
      if (n->token == F_EXTERNAL) {
	while (state && (state->new_program->id != n->u.integer.a)) {
	  depth++;
	  state = state->previous;
	}
      }
      if (depth && state) {
	/* Alias for a symbol in a surrounding scope. */
	int id = really_low_reference_inherited_identifier(state, 0,
							   n->u.integer.b);
	define_alias((yyvsp[-2].n)->u.sval.u.string, n->type,
		     Pike_compiler->current_modifiers & ~ID_EXTERN,
		     depth, id);
      } else if (Pike_compiler->compiler_pass == 1) {
	yyerror("Invalid extern declared constant.");
	add_constant((yyvsp[-2].n)->u.sval.u.string, &svalue_undefined,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      }
    } else {
      if (TEST_COMPAT(7, 6) &&
	  (Pike_compiler->current_modifiers & ID_EXTERN) &&
	  (Pike_compiler->compiler_pass == 1)) {
	yywarning("Extern declared constant.");
      }
      if(!is_const((yyvsp[0].n))) {
	if (Pike_compiler->compiler_pass == 2) {
	  yyerror("Constant definition is not constant.");
	}
	add_constant((yyvsp[-2].n)->u.sval.u.string, 0,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
      } else {
	if(!Pike_compiler->num_parse_error)
	{
	  ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
	  if(tmp < 1)
	  {
	    yyerror("Error in constant definition.");
	    push_undefined();
	  }else{
	    pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	  }
	} else {
	  push_undefined();
	}
	add_constant((yyvsp[-2].n)->u.sval.u.string, Pike_sp-1,
		     Pike_compiler->current_modifiers & ~ID_EXTERN);
	pop_stack();
      }
    }
  const_def_ok:
    if((yyvsp[0].n)) free_node((yyvsp[0].n));
    free_node((yyvsp[-2].n));
  }
#line 4121 "y.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 610 "language.yacc" /* yacc.c:1646  */
    { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 4127 "y.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 611 "language.yacc" /* yacc.c:1646  */
    { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 4133 "y.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 618 "language.yacc" /* yacc.c:1646  */
    {}
#line 4139 "y.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 619 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 4145 "y.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 621 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 4154 "y.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 625 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ';'."); }
#line 4160 "y.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 629 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[0].n));
  }
#line 4169 "y.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 633 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = NULL; }
#line 4175 "y.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 634 "language.yacc" /* yacc.c:1646  */
    { yyerror("Expected ';'."); (yyval.n) = NULL; }
#line 4181 "y.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 635 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = NULL; }
#line 4187 "y.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 640 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    check_type_string((yyvsp[0].n)->u.sval.u.type);
#endif /* PIKE_DEBUG */
    if(Pike_compiler->compiler_frame->current_type)
      free_type(Pike_compiler->compiler_frame->current_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_type,
		   (yyvsp[0].n)->u.sval.u.type);
    free_node((yyvsp[0].n));
  }
#line 4202 "y.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 653 "language.yacc" /* yacc.c:1646  */
    {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 4211 "y.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 660 "language.yacc" /* yacc.c:1646  */
    {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 4220 "y.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 665 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 4230 "y.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 674 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing '}'.");
  }
#line 4238 "y.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 681 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing '}'.");
  }
#line 4246 "y.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 687 "language.yacc" /* yacc.c:1646  */
    {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 4255 "y.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 695 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ']'.");
  }
#line 4263 "y.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 701 "language.yacc" /* yacc.c:1646  */
    {
    push_compiler_frame(SCOPE_LOCAL);

    if(!Pike_compiler->compiler_frame->previous ||
       !Pike_compiler->compiler_frame->previous->current_type)
    {
      yyerror("Internal compiler error (push_compiler_frame0).");
      copy_pike_type(Pike_compiler->compiler_frame->current_type,
		mixed_type_string);
    }else{
      copy_pike_type(Pike_compiler->compiler_frame->current_type,
		Pike_compiler->compiler_frame->previous->current_type);
    }

    (yyval.ptr) = Pike_compiler->compiler_frame;
  }
#line 4284 "y.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 720 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number) = OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT;
  }
#line 4292 "y.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 724 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number) = 0;
  }
#line 4300 "y.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 732 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number) = 0;
    /* Check for the (very special) case of create and create_args. */
    if (Pike_compiler->num_create_args) {
      struct pike_string *create_string = NULL;
      int e;
      MAKE_CONST_STRING(create_string, "create");
      if ((yyvsp[-2].n)->u.sval.u.string == create_string) {
	if (TEST_COMPAT(7, 6)) {
	  yywarning("Having both an implicit and an explicit create() "
		    "was not supported in Pike 7.6 and before.");
	}
	/* Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  Pike_compiler->varargs = 1;
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
	      Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    struct identifier *id =
	      Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(empty_pike_string, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}
	(yyval.number) = e;
      }
    }
  }
#line 4344 "y.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 772 "language.yacc" /* yacc.c:1646  */
    {
    int e;

    /* Adjust opt_flags in case we've got an optional_constant. */
    Pike_compiler->compiler_frame->opt_flags = (yyvsp[-7].number);

    /* construct the function type */
    push_finished_type(Pike_compiler->compiler_frame->current_type);

    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    Pike_compiler->compiler_frame->current_return_type = compiler_pop_type();

    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e = (yyvsp[-2].number) + (yyvsp[-1].number) - 1;
    if(Pike_compiler->varargs &&
       (!(yyvsp[-2].number) || (Pike_compiler->num_create_args >= 0)))
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    if (Pike_compiler->current_attributes) {
      node *n = Pike_compiler->current_attributes;
      while (n) {
	push_type_attribute(CDR(n)->u.sval.u.string);
	n = CAR(n);
      }
    }

    {
      struct pike_type *s=compiler_pop_type();
      int i = isidentifier((yyvsp[-5].n)->u.sval.u.string);

      if (Pike_compiler->compiler_pass != 1) {
	if (i < 0) {
	  my_yyerror("Identifier %S lost after first pass.",
		     (yyvsp[-5].n)->u.sval.u.string);
	}
      }

      (yyval.n) = mktypenode(s);
      free_type(s);
    }


/*    if(Pike_compiler->compiler_pass==1) */
    {
      /* FIXME:
       * set current_function_number for local functions as well
       */
      Pike_compiler->compiler_frame->current_function_number=
	define_function((yyvsp[-5].n)->u.sval.u.string,
			(yyval.n)->u.sval.u.type,
			(yyvsp[-10].number) & (~ID_EXTERN),
			IDENTIFIER_PIKE_FUNCTION |
			(Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			0,
			(yyvsp[-7].number));

      Pike_compiler->varargs=0;
    }
  }
#line 4422 "y.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 846 "language.yacc" /* yacc.c:1646  */
    {
    int e;
    if((yyvsp[0].n))
    {
      int f;
      node *check_args = NULL;
      struct compilation *c = THIS_COMPILATION;
      struct pike_string *save_file = c->lex.current_file;
      int save_line  = c->lex.current_line;
      int num_required_args = 0;
      struct identifier *i;
      c->lex.current_file = (yyvsp[-7].n)->current_file;
      c->lex.current_line = (yyvsp[-7].n)->line_number;

      if (((yyvsp[-12].number) & ID_EXTERN) && (Pike_compiler->compiler_pass == 1)) {
	yywarning("Extern declared function definition.");
      }

      for(e=0; e<(yyvsp[-4].number)+(yyvsp[-3].number); e++)
      {
	if((e >= (yyvsp[-4].number)) &&
	   (!Pike_compiler->compiler_frame->variable[e].name ||
	    !Pike_compiler->compiler_frame->variable[e].name->len))
	{
	  my_yyerror("Missing name for argument %d.", e - (yyvsp[-4].number));
	} else {
	  if (Pike_compiler->compiler_pass == 2) {
	      /* FIXME: Should probably use some other flag. */
	      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
		  (Pike_compiler->compiler_frame->variable[e].type !=
		   mixed_type_string)) {
		node *local_node;

		/* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

		local_node = mkcastnode(mixed_type_string, mklocalnode(e, 0));

		/* NOTE: The cast to mixed above is needed to avoid generating
		 *       compilation errors, as well as avoiding optimizations
		 *       in mksoftcastnode().
		 */
		check_args =
		  mknode(F_COMMA_EXPR, check_args,
			 mksoftcastnode(Pike_compiler->compiler_frame->variable[e].type,
					local_node));
	      }
	  }
	}
      }

      if ((yyvsp[-4].number)) {
	/* Hook in the initializers for the create arguments. */
	for (e = (yyvsp[-4].number); e--;) {
	  (yyvsp[0].n) = mknode(F_COMMA_EXPR,
		       mknode(F_POP_VALUE,
			      mknode(F_ASSIGN, mklocalnode(e, 0),
				     mkidentifiernode(e)), NULL),
		       (yyvsp[0].n));
	}
      }

      {
	int l = (yyvsp[0].n)->line_number;
	struct pike_string *f = (yyvsp[0].n)->current_file;
	if (check_args) {
	  /* Prepend the arg checking code. */
	  (yyvsp[0].n) = mknode(F_COMMA_EXPR, mknode(F_POP_VALUE, check_args, NULL), (yyvsp[0].n));
	}
	c->lex.current_line = l;
	c->lex.current_file = f;
      }

      f=dooptcode((yyvsp[-7].n)->u.sval.u.string, (yyvsp[0].n), (yyvsp[-1].n)->u.sval.u.type, (yyvsp[-12].number));

      i = ID_FROM_INT(Pike_compiler->new_program, f);
      i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

#ifdef PIKE_DEBUG
      if(Pike_interpreter.recoveries &&
	 ((Pike_sp - Pike_interpreter.evaluator_stack) <
	  Pike_interpreter.recoveries->stack_pointer))
	Pike_fatal("Stack error (underflow)\n");

      if((Pike_compiler->compiler_pass == 1) &&
	 (f != Pike_compiler->compiler_frame->current_function_number)) {
	fprintf(stderr, "define_function()/do_opt_code() failed for symbol %s\n",
		(yyvsp[-7].n)->u.sval.u.string->str);
	dump_program_desc(Pike_compiler->new_program);
	Pike_fatal("define_function screwed up! %d != %d\n",
	      f, Pike_compiler->compiler_frame->current_function_number);
      }
#endif

      c->lex.current_line = save_line;
      c->lex.current_file = save_file;
    } else {
      /* Prototype; don't warn about unused arguments. */
      for (e = Pike_compiler->compiler_frame->current_number_of_locals; e--;) {
	Pike_compiler->compiler_frame->variable[e].flags |= LOCAL_VAR_IS_USED;
      }
    }
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-6].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-6].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-7].n));
    free_node((yyvsp[-2].n));
    free_node((yyvsp[-1].n));
  }
#line 4541 "y.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 963 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-2].n));
  }
#line 4558 "y.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 976 "language.yacc" /* yacc.c:1646  */
    {
    compiler_discard_type();
  }
#line 4566 "y.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 980 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[0].n)) free_node((yyvsp[0].n));
  }
#line 4574 "y.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 984 "language.yacc" /* yacc.c:1646  */
    {}
#line 4580 "y.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 985 "language.yacc" /* yacc.c:1646  */
    {}
#line 4586 "y.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 986 "language.yacc" /* yacc.c:1646  */
    {}
#line 4592 "y.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 987 "language.yacc" /* yacc.c:1646  */
    { free_node((yyvsp[0].n)); }
#line 4598 "y.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 988 "language.yacc" /* yacc.c:1646  */
    { free_node((yyvsp[0].n)); }
#line 4604 "y.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 989 "language.yacc" /* yacc.c:1646  */
    {}
#line 4610 "y.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 991 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file");
  }
#line 4620 "y.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 997 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerrok;
/*     if(Pike_compiler->num_parse_error>5) YYACCEPT; */
  }
#line 4630 "y.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 1003 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerror("Missing ';'.");
   /* yychar = '}';	*/ /* Put the '}' back on the input stream */
  }
#line 4640 "y.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 1010 "language.yacc" /* yacc.c:1646  */
    {
      (yyval.number)=THIS_COMPILATION->lex.pragmas;
      THIS_COMPILATION->lex.pragmas|=(yyvsp[-1].number);
    }
#line 4649 "y.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 1016 "language.yacc" /* yacc.c:1646  */
    {
      THIS_COMPILATION->lex.pragmas=(yyvsp[-2].number);
    }
#line 4657 "y.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 1021 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=1; }
#line 4663 "y.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 1023 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Range indicator ('..') where elipsis ('...') expected.");
    (yyval.number)=1;
  }
#line 4672 "y.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 1027 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 4678 "y.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 1031 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 4684 "y.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 1032 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 4690 "y.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 1036 "language.yacc" /* yacc.c:1646  */
    {
    int i;
    if(Pike_compiler->varargs) yyerror("Can't define more arguments after ...");

    if((yyvsp[-1].number))
    {
      push_type(T_ARRAY);
      Pike_compiler->varargs=1;
    }

    if(!(yyvsp[0].n))
    {
      (yyvsp[0].n)=mkstrnode(empty_pike_string);
    }

    if((yyvsp[0].n)->u.sval.u.string->len &&
       islocal((yyvsp[0].n)->u.sval.u.string) >= 0)
      my_yyerror("Variable %S appears twice in argument list.",
		 (yyvsp[0].n)->u.sval.u.string);

    i = add_local_name((yyvsp[0].n)->u.sval.u.string, compiler_pop_type(),0);
    if (i >= 0) {
      /* Don't warn about unused arguments. */
      Pike_compiler->compiler_frame->variable[i].flags |= LOCAL_VAR_IS_USED;
    }
    free_node((yyvsp[0].n));
  }
#line 4722 "y.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 1066 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[0].n));
    (yyval.number)=(yyvsp[-1].number);
  }
#line 4731 "y.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 1072 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 4737 "y.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 1076 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = 1; }
#line 4743 "y.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 1077 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + 1; }
#line 4749 "y.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 1079 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected ':' in argument list.");
    (yyval.number) = (yyvsp[-2].number) + 1;
  }
#line 4758 "y.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 1087 "language.yacc" /* yacc.c:1646  */
    {
      (yyval.number) = ID_FINAL | ID_INLINE;
      if( !(THIS_COMPILATION->lex.pragmas & ID_NO_DEPRECATION_WARNINGS) &&
          !TEST_COMPAT(7, 6) && Pike_compiler->compiler_pass==1 )
        yywarning("Keyword nomask is deprecated in favor for 'final'.");
    }
#line 4769 "y.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 1093 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_FINAL | ID_INLINE; }
#line 4775 "y.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 1094 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number) = ID_PROTECTED;
    if( !(THIS_COMPILATION->lex.pragmas & ID_NO_DEPRECATION_WARNINGS) &&
        !TEST_COMPAT(7, 8) && Pike_compiler->compiler_pass==1 )
      yywarning("Keyword static is deprecated in favor for 'protected'.");
    }
#line 4786 "y.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 1100 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_EXTERN; }
#line 4792 "y.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 1101 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_OPTIONAL; }
#line 4798 "y.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 1102 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_PRIVATE | ID_PROTECTED; }
#line 4804 "y.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 1103 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_INLINE; }
#line 4810 "y.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 1104 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_PUBLIC; }
#line 4816 "y.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 1105 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_PROTECTED; }
#line 4822 "y.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 1106 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_INLINE; }
#line 4828 "y.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 1107 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = ID_VARIANT; }
#line 4834 "y.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 1111 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "nomask"; }
#line 4840 "y.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 1112 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "final"; }
#line 4846 "y.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 1113 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "static"; }
#line 4852 "y.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 1114 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "extern"; }
#line 4858 "y.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 1115 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "private"; }
#line 4864 "y.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 1116 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "local"; }
#line 4870 "y.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 1117 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "public"; }
#line 4876 "y.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 1118 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "protected"; }
#line 4882 "y.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 1119 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "inline"; }
#line 4888 "y.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 1120 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "optional"; }
#line 4894 "y.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 1121 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "variant"; }
#line 4900 "y.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 1125 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "void"; }
#line 4906 "y.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 1126 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "mixed"; }
#line 4912 "y.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 1127 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "array"; }
#line 4918 "y.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 1128 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "__attribute__"; }
#line 4924 "y.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 1129 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "__deprecated__"; }
#line 4930 "y.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 1130 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "mapping"; }
#line 4936 "y.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 1131 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "multiset"; }
#line 4942 "y.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 1132 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "object"; }
#line 4948 "y.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 1133 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "function"; }
#line 4954 "y.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 1134 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "__func__"; }
#line 4960 "y.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 1135 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "program"; }
#line 4966 "y.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 1136 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "string"; }
#line 4972 "y.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 1137 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "float"; }
#line 4978 "y.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 1138 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "int"; }
#line 4984 "y.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 1139 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "enum"; }
#line 4990 "y.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 1140 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "typedef"; }
#line 4996 "y.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 1144 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "if"; }
#line 5002 "y.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 1145 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "do"; }
#line 5008 "y.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 1146 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "for"; }
#line 5014 "y.tab.c" /* yacc.c:1646  */
    break;

  case 129:
#line 1147 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "while"; }
#line 5020 "y.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 1148 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "else"; }
#line 5026 "y.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 1149 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "foreach"; }
#line 5032 "y.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 1150 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "catch"; }
#line 5038 "y.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 1151 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "gauge"; }
#line 5044 "y.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 1152 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "class"; }
#line 5050 "y.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 1153 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "break"; }
#line 5056 "y.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 1154 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "case"; }
#line 5062 "y.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 1155 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "constant"; }
#line 5068 "y.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 1156 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "continue"; }
#line 5074 "y.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 1157 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "default"; }
#line 5080 "y.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 1158 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "import"; }
#line 5086 "y.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 1159 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "inherit"; }
#line 5092 "y.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 1160 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "lambda"; }
#line 5098 "y.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 1161 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "predef"; }
#line 5104 "y.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 1162 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "return"; }
#line 5110 "y.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 1163 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "sscanf"; }
#line 5116 "y.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 1164 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "switch"; }
#line 5122 "y.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 1165 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "typeof"; }
#line 5128 "y.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 1166 "language.yacc" /* yacc.c:1646  */
    { (yyval.str) = "global"; }
#line 5134 "y.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 1173 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *tmp=make_shared_string((yyvsp[0].str));
    (yyval.n)=mkstrnode(tmp);
    free_string(tmp);
  }
#line 5144 "y.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 1181 "language.yacc" /* yacc.c:1646  */
    {
   (yyval.number)=Pike_compiler->current_modifiers=(yyvsp[0].number) |
     (THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
 }
#line 5153 "y.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 1187 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 5159 "y.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 1188 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number) | (yyvsp[0].number); }
#line 5165 "y.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 1192 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = (yyvsp[-2].n);
  }
#line 5173 "y.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 1196 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    (yyval.n) = mkstrnode(deprecated_string);
  }
#line 5183 "y.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 1202 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    (yyval.n) = mkstrnode(deprecated_string);
  }
#line 5193 "y.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 1210 "language.yacc" /* yacc.c:1646  */
    {
    if (Pike_compiler->current_attributes) {
      free_node(Pike_compiler->current_attributes);
    }
    if ((Pike_compiler->current_attributes =
	 THIS_COMPILATION->lex.attributes)) {
      add_ref(Pike_compiler->current_attributes);
    }
  }
#line 5207 "y.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 1220 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[0].n)) {
      Pike_compiler->current_attributes =
	mknode(F_ARG_LIST, Pike_compiler->current_attributes, (yyvsp[0].n));
    }
  }
#line 5218 "y.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 1228 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 5224 "y.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 1232 "language.yacc" /* yacc.c:1646  */
    {
      struct pike_type *s = compiler_pop_type();
      (yyval.n) = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 5236 "y.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 1242 "language.yacc" /* yacc.c:1646  */
    {
      struct pike_type *s = compiler_pop_type();
      (yyval.n) = mktypenode(s);
      free_type(s);
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 5248 "y.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 1254 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *s = compiler_pop_type();
    (yyval.n) = mktypenode(s);
#ifdef PIKE_DEBUG
    if ((yyval.n)->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, (yyval.n)->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
#line 5263 "y.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 1267 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *s = compiler_pop_type();
    (yyval.n) = mktypenode(s);
#ifdef PIKE_DEBUG
    if ((yyval.n)->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, (yyval.n)->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
#line 5278 "y.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 1280 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *s = compiler_pop_type();
    (yyval.n) = mktypenode(s);
#ifdef PIKE_DEBUG
    if ((yyval.n)->u.sval.u.type != s) {
      Pike_fatal("mktypenode(%p) created node with %p\n", s, (yyval.n)->u.sval.u.type);
    }
#endif /* PIKE_DEBUG */
    free_type(s);
  }
#line 5293 "y.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 1292 "language.yacc" /* yacc.c:1646  */
    { push_type(T_OR); }
#line 5299 "y.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 1296 "language.yacc" /* yacc.c:1646  */
    { push_type(T_OR); }
#line 5305 "y.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 1303 "language.yacc" /* yacc.c:1646  */
    { push_type(T_FLOAT); }
#line 5311 "y.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 1304 "language.yacc" /* yacc.c:1646  */
    { push_type(T_VOID); }
#line 5317 "y.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 1305 "language.yacc" /* yacc.c:1646  */
    { push_type(T_MIXED); }
#line 5323 "y.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 1306 "language.yacc" /* yacc.c:1646  */
    {}
#line 5329 "y.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 1307 "language.yacc" /* yacc.c:1646  */
    {}
#line 5335 "y.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 1308 "language.yacc" /* yacc.c:1646  */
    {}
#line 5341 "y.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 1309 "language.yacc" /* yacc.c:1646  */
    {}
#line 5347 "y.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 1310 "language.yacc" /* yacc.c:1646  */
    {}
#line 5353 "y.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 1311 "language.yacc" /* yacc.c:1646  */
    { push_type(T_PROGRAM); }
#line 5359 "y.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 1312 "language.yacc" /* yacc.c:1646  */
    { push_type(T_ARRAY); }
#line 5365 "y.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 1313 "language.yacc" /* yacc.c:1646  */
    { push_type(T_MULTISET); }
#line 5371 "y.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 1315 "language.yacc" /* yacc.c:1646  */
    {
    push_type_attribute((yyvsp[-3].n)->u.sval.u.string);
    free_node((yyvsp[-3].n));
  }
#line 5380 "y.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 1320 "language.yacc" /* yacc.c:1646  */
    {
    push_type(T_MIXED);
    push_type_attribute((yyvsp[-2].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
  }
#line 5390 "y.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1326 "language.yacc" /* yacc.c:1646  */
    {
    push_type(T_MIXED);
  }
#line 5398 "y.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1330 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type_attribute(deprecated_string);
  }
#line 5408 "y.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1336 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *deprecated_string;
    MAKE_CONST_STRING(deprecated_string, "deprecated");
    push_type(T_MIXED);
    push_type_attribute(deprecated_string);
  }
#line 5419 "y.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1345 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[0].n)) {
      fix_type_field((yyvsp[0].n));

      if (!pike_types_le((yyvsp[0].n)->type, typeable_type_string) &&
	  (THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	yytype_report(REPORT_WARNING,
		      (yyvsp[0].n)->current_file, (yyvsp[0].n)->line_number, typeable_type_string,
		      (yyvsp[0].n)->current_file, (yyvsp[0].n)->line_number, (yyvsp[0].n)->type,
		      0, "Invalid type.");
      }
    }

    resolv_constant((yyvsp[0].n));

    if (TYPEOF(Pike_sp[-1]) == T_TYPE) {
      /* "typedef" */
      push_finished_type(Pike_sp[-1].u.type);
    } else {
      /* object type */
      struct program *p = NULL;

      if (TYPEOF(Pike_sp[-1]) == T_OBJECT) {
	if(!(p = Pike_sp[-1].u.object->prog))
	{
	  pop_stack();
	  push_int(0);
	  yyerror("Destructed object used as program identifier.");
	}else{
	  int f = FIND_LFUN(p->inherits[SUBTYPEOF(Pike_sp[-1])].prog,
			    LFUN_CALL);
	  if(f!=-1)
	  {
	    SET_SVAL_SUBTYPE(Pike_sp[-1],
			     f + p->inherits[SUBTYPEOF(Pike_sp[-1])].
			     identifier_level);
	    SET_SVAL_TYPE(Pike_sp[-1], T_FUNCTION);
	  }else{
	    extern void f_object_program(INT32);
	    if (Pike_compiler->compiler_pass == 2)
	      yywarning("Using object as program identifier.");
	    f_object_program(1);
	  }
	}
      }

      switch(TYPEOF(Pike_sp[-1])) {
	case T_FUNCTION:
	if((p = program_from_function(Pike_sp-1))) {
	  push_object_type(0, p?(p->id):0);
	  break;
	} else {
	  /* Attempt to get the return type for the function. */
	  struct pike_type *a, *b;
	  a = get_type_of_svalue(Pike_sp-1);
	  /* Note: check_splice_call() below eats a reference from a.
	   * Note: CALL_INHIBIT_WARNINGS is needed since we don't
	   *       provide a function name (and we don't want
	   *       warnings here anyway).
	   */
	  a = check_splice_call(NULL, a, 0, mixed_type_string, NULL,
				CALL_INHIBIT_WARNINGS);
	  if (a) {
	    b = new_get_return_type(a, 0);
	    free_type(a);
	    if (b) {
	      push_finished_type(b);
	      free_type(b);
	      break;
	    }
	  }
	}
	/* FALL_THROUGH */

      default:
	if (Pike_compiler->compiler_pass!=1)
	  my_yyerror("Illegal program identifier: %O.", Pike_sp-1);
	pop_stack();
	push_int(0);
	push_object_type(0, 0);
	break;

      case T_PROGRAM:
	p = Pike_sp[-1].u.program;
	push_object_type(0, p?(p->id):0);
	break;
      }
    }
    /* Attempt to name the type. */
    if (Pike_compiler->last_identifier) {
      push_type_name(Pike_compiler->last_identifier);
    }
    pop_stack();
    free_node((yyvsp[0].n));
  }
#line 5519 "y.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1443 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mkintnode(MAX_INT_TYPE);
  }
#line 5527 "y.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1448 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (((yyvsp[0].n)->token != F_CONSTANT) || (TYPEOF((yyvsp[0].n)->u.sval) != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    (yyval.n) = mkintnode(-((yyvsp[0].n)->u.sval.u.integer));
    free_node((yyvsp[0].n));
  }
#line 5541 "y.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1460 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mkintnode(MIN_INT_TYPE);
  }
#line 5549 "y.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1465 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (((yyvsp[0].n)->token != F_CONSTANT) || (TYPEOF((yyvsp[0].n)->u.sval) != T_INT)) {
      Pike_fatal("Unexpected number in negative int-range.\n");
    }
#endif /* PIKE_DEBUG */
    (yyval.n) = mkintnode(-((yyvsp[0].n)->u.sval.u.integer));
    free_node((yyvsp[0].n));
  }
#line 5563 "y.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1478 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Elipsis ('...') where range indicator ('..') expected.");
  }
#line 5571 "y.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1484 "language.yacc" /* yacc.c:1646  */
    {
    push_int_type(MIN_INT_TYPE, MAX_INT_TYPE);
  }
#line 5579 "y.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1488 "language.yacc" /* yacc.c:1646  */
    {
      push_int_type( 0, (1<<(yyvsp[-1].n)->u.sval.u.integer)-1 );
      free_node( (yyvsp[-1].n) );
  }
#line 5588 "y.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1493 "language.yacc" /* yacc.c:1646  */
    {
    INT_TYPE min = MIN_INT_TYPE;
    INT_TYPE max = MAX_INT_TYPE;

    /* FIXME: Check that $4 is >= $2. */
    if((yyvsp[-1].n)->token == F_CONSTANT) {
      if (TYPEOF((yyvsp[-1].n)->u.sval) == T_INT) {
	max = (yyvsp[-1].n)->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&(yyvsp[-1].n)->u.sval)) {
	push_int(0);
	if (is_lt(&(yyvsp[-1].n)->u.sval, Pike_sp-1)) {
	  max = MIN_INT_TYPE;
	}
	pop_stack();
      }
    }

    if((yyvsp[-3].n)->token == F_CONSTANT) {
      if (TYPEOF((yyvsp[-3].n)->u.sval) == T_INT) {
	min = (yyvsp[-3].n)->u.sval.u.integer;
      } else if (is_bignum_object_in_svalue(&(yyvsp[-3].n)->u.sval)) {
	push_int(0);
	if (is_lt(Pike_sp-1, &(yyvsp[-3].n)->u.sval)) {
	  min = MAX_INT_TYPE;
	}
	pop_stack();
      }
    }

    push_int_type(min, max);

    free_node((yyvsp[-3].n));
    free_node((yyvsp[-1].n));
  }
#line 5627 "y.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1528 "language.yacc" /* yacc.c:1646  */
    {
    push_int_type(MIN_INT32, MAX_INT32);
    yyerror("Expected integer range.");
  }
#line 5636 "y.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1535 "language.yacc" /* yacc.c:1646  */
    {
    push_type(T_STRING);
  }
#line 5644 "y.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1540 "language.yacc" /* yacc.c:1646  */
    { push_object_type(0, 0); }
#line 5650 "y.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1541 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
      (yyval.ptr) = Pike_sp;
#endif /* PIKE_DEBUG */
    }
#line 5660 "y.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1547 "language.yacc" /* yacc.c:1646  */
    {
    /* NOTE: On entry, there are two items on the stack:
     *   Pike_sp-2:	Name of the program reference (string).
     *   Pike_sp-1:	The resolved program (program|function|zero).
     */
    struct program *p=program_from_svalue(Pike_sp-1);

#ifdef PIKE_DEBUG
    if ((yyvsp[-3].ptr) != (Pike_sp - 2)) {
      Pike_fatal("Unexpected stack depth: %p != %p\n",
		 (yyvsp[-3].n), Pike_sp-2);
    }
#endif /* PIKE_DEBUG */

    if(!p) {
      if (Pike_compiler->compiler_pass!=1) {
	my_yyerror("Not a valid program specifier: %S", Pike_sp[-2].u.string);
      }
    }
    push_object_type(0, p?(p->id):0);
    /* Attempt to name the type. */
    if (TYPEOF(Pike_sp[-2]) == T_STRING) {
      push_type_name(Pike_sp[-2].u.string);
    }
    pop_n_elems(2);
  }
#line 5691 "y.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1575 "language.yacc" /* yacc.c:1646  */
    { push_object_type(0, 0); }
#line 5697 "y.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1578 "language.yacc" /* yacc.c:1646  */
    {
    push_object_type(0, 0);
    yyerror("Invalid program subtype.");
  }
#line 5706 "y.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1585 "language.yacc" /* yacc.c:1646  */
    {
    type_stack_mark();
  }
#line 5714 "y.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1589 "language.yacc" /* yacc.c:1646  */
    {
    /* Add the many type if there is none. */
    if ((yyvsp[-1].number))
    {
      if (!(yyvsp[-2].number)) {
	/* function_type_list ends with a comma, or is empty.
	 * FIXME: Should this be a syntax error or not?
	 */
	if (Pike_compiler->compiler_pass == 1) {
	  yyerror("Missing type before ... .");
	}
	push_type(T_MIXED);
      }
    }else{
      push_type(T_VOID);
    }
  }
#line 5736 "y.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1607 "language.yacc" /* yacc.c:1646  */
    {
    push_reverse_type(T_MANY);
    Pike_compiler->pike_type_mark_stackp--;
    while (*Pike_compiler->pike_type_mark_stackp+1 <
	   Pike_compiler->type_stackp) {
      push_reverse_type(T_FUNCTION);
    }
  }
#line 5749 "y.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1616 "language.yacc" /* yacc.c:1646  */
    {
   push_type(T_MIXED);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(T_ZERO);
   push_type(T_VOID);
   push_type(T_OR);

   push_type(T_MANY);
  }
#line 5765 "y.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1629 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 5771 "y.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1630 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=!(yyvsp[0].number); }
#line 5777 "y.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1633 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=1; }
#line 5783 "y.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1635 "language.yacc" /* yacc.c:1646  */
    {
  }
#line 5790 "y.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1641 "language.yacc" /* yacc.c:1646  */
    { push_type(T_MIXED); }
#line 5796 "y.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1645 "language.yacc" /* yacc.c:1646  */
    {
  }
#line 5803 "y.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1648 "language.yacc" /* yacc.c:1646  */
    {
  }
#line 5810 "y.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1651 "language.yacc" /* yacc.c:1646  */
    {
    push_reverse_type(T_MAPPING);
  }
#line 5818 "y.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1656 "language.yacc" /* yacc.c:1646  */
    {
    push_type(T_MIXED);
    push_type(T_MIXED);
    push_type(T_MAPPING);
  }
#line 5828 "y.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1669 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    node *n;
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    n = Pike_compiler->current_attributes;
    while(n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
    type=compiler_pop_type();
    define_variable((yyvsp[0].n)->u.sval.u.string, type,
		    Pike_compiler->current_modifiers);
    free_type(type);
    free_node((yyvsp[0].n));
  }
#line 5848 "y.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1684 "language.yacc" /* yacc.c:1646  */
    {}
#line 5854 "y.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1686 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    node *n;
    push_finished_type(Pike_compiler->compiler_frame->current_type);
    n = Pike_compiler->current_attributes;
    while(n) {
      push_type_attribute(CDR(n)->u.sval.u.string);
      n = CAR(n);
    }
    type=compiler_pop_type();
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared variable has initializer.");
    }
    (yyval.number)=define_variable((yyvsp[-1].n)->u.sval.u.string, type,
			       Pike_compiler->current_modifiers & (~ID_EXTERN));
    free_type(type);
  }
#line 5877 "y.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1705 "language.yacc" /* yacc.c:1646  */
    {
    if ((Pike_compiler->compiler_pass == 2) &&
	!TEST_COMPAT(7, 8) && ((yyvsp[0].n)) && ((yyvsp[0].n)->token == F_CONSTANT) &&
	!Pike_compiler->num_parse_error) {
      /* Check if it is zero, in which case we can throw it away.
       *
       * NB: The compat test is due to that this changes the semantics
       *     of calling __INIT() by hand.
       */
      if (SAFE_IS_ZERO(&(yyvsp[0].n)->u.sval) &&
	  !SUBTYPEOF((yyvsp[0].n)->u.sval) &&
	  !IDENTIFIER_IS_ALIAS(ID_FROM_INT(Pike_compiler->new_program,
					   (yyvsp[-1].number))->identifier_flags)) {
	/* NB: Inherited variables get converted into aliases by
	 *     define_variable, and we need to support clearing
	 *     of inherited variables.
	 */
	free_node((yyvsp[0].n));
	(yyvsp[0].n) = NULL;
      }
    }
    if ((yyvsp[0].n)) {
      Pike_compiler->init_node=mknode(F_COMMA_EXPR,Pike_compiler->init_node,
		       mkcastnode(void_type_string,
				  mknode(F_ASSIGN,(yyvsp[0].n),
					 mkidentifiernode((yyvsp[-1].number)))));
    }
    free_node((yyvsp[-3].n));
  }
#line 5911 "y.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1735 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[-2].n));
  }
#line 5919 "y.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1739 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected end of file in variable definition.");
    free_node((yyvsp[-2].n));
  }
#line 5928 "y.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1744 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[0].n));
  }
#line 5936 "y.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1751 "language.yacc" /* yacc.c:1646  */
    {
    int id;
    push_finished_type((yyvsp[-2].n)->u.sval.u.type);
    id = add_local_name((yyvsp[0].n)->u.sval.u.string, compiler_pop_type(),0);
    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      (yyval.n)=mknode(F_ASSIGN,mkintnode(0),mklocalnode(id,0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[0].n));
  }
#line 5952 "y.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1762 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 5958 "y.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1764 "language.yacc" /* yacc.c:1646  */
    {
    int id;
    push_finished_type((yyvsp[-4].n)->u.sval.u.type);
    id = add_local_name((yyvsp[-2].n)->u.sval.u.string, compiler_pop_type(),0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->variable[id].flags |= LOCAL_VAR_IS_USED;
      }
      (yyval.n)=mknode(F_ASSIGN,(yyvsp[0].n),mklocalnode(id,0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[-2].n));
  }
#line 5977 "y.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1779 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[0].n));
    (yyval.n)=0;
  }
#line 5986 "y.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1784 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[-2].n));
    /* No yyerok here since we aren't done yet. */
    (yyval.n)=0;
  }
#line 5996 "y.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1790 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected end of file in local variable definition.");
    free_node((yyvsp[-2].n));
    /* No yyerok here since we aren't done yet. */
    (yyval.n)=0;
  }
#line 6007 "y.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1799 "language.yacc" /* yacc.c:1646  */
    {
    int id;
    add_ref((yyvsp[-1].n)->u.sval.u.type);
    id = add_local_name((yyvsp[0].n)->u.sval.u.string, (yyvsp[-1].n)->u.sval.u.type, 0);
    if (id >= 0) {
      /* FIXME: Consider using mklocalnode(id, -1). */
      (yyval.n)=mknode(F_ASSIGN,mkintnode(0),mklocalnode(id,0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[0].n));
  }
#line 6023 "y.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1810 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6029 "y.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1812 "language.yacc" /* yacc.c:1646  */
    {
    int id;
    add_ref((yyvsp[-3].n)->u.sval.u.type);
    id = add_local_name((yyvsp[-2].n)->u.sval.u.string, (yyvsp[-3].n)->u.sval.u.type, 0);
    if (id >= 0) {
      if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
	/* Only warn about unused initialized variables in strict types mode. */
	Pike_compiler->compiler_frame->variable[id].flags |= LOCAL_VAR_IS_USED;
      }
      (yyval.n)=mknode(F_ASSIGN,(yyvsp[0].n), mklocalnode(id,0));
    } else
      (yyval.n) = 0;
    free_node((yyvsp[-2].n));
  }
#line 6048 "y.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1826 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 6054 "y.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1830 "language.yacc" /* yacc.c:1646  */
    {
    /* Used to hold line-number info */
    (yyval.n) = mkintnode(0);
  }
#line 6063 "y.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1837 "language.yacc" /* yacc.c:1646  */
    {
    (yyvsp[0].number)=Pike_compiler->num_used_modules;
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 6072 "y.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1842 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;

    if((yyval.number) == -1) /* if 'first block' */
      Pike_compiler->compiler_frame->last_block_level=0; /* all variables */
    else
      Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 6086 "y.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1852 "language.yacc" /* yacc.c:1646  */
    {
    unuse_modules(Pike_compiler->num_used_modules - (yyvsp[-5].number));
    pop_local_variables((yyvsp[-4].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-2].number);
    if ((yyvsp[-1].n)) COPY_LINE_NUMBER_INFO((yyvsp[-1].n), (yyvsp[-3].n));
    free_node ((yyvsp[-3].n));
    (yyval.n)=(yyvsp[-1].n);
  }
#line 6099 "y.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1865 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing '}'.");
    if ((yyvsp[-1].n)) {
      low_yyreport(REPORT_ERROR, (yyvsp[-1].n)->current_file, (yyvsp[-1].n)->line_number,
		   parser_system_string, 0, "Opening '{' was here.");
    }
    yyerror("Unexpected end of file.");
  }
#line 6112 "y.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1876 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6118 "y.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1877 "language.yacc" /* yacc.c:1646  */
    { yyerror("Unexpected end of file."); (yyval.n)=0; }
#line 6124 "y.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1882 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = (yyvsp[(-2) - (0)].n);
  }
#line 6132 "y.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1890 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-3].n)), (yyvsp[0].n)); }
#line 6138 "y.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1896 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-3].n)), (yyvsp[0].n)); }
#line 6144 "y.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1901 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;

    /* Ugly hack to make sure that $3 is optimized */
    {
      int tmp=Pike_compiler->compiler_pass;
      (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
      optimize_node((yyvsp[0].n));
      Pike_compiler->compiler_pass=tmp;
      type=(yyvsp[0].n)->u.node.a->type;
    }

    if(!is_const((yyvsp[0].n)))
    {
      if(Pike_compiler->compiler_pass==2)
	yyerror("Constant definition is not constant.");
    }else{
      ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
      if(tmp < 1)
      {
	yyerror("Error in constant definition.");
      }else{
	pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	if((yyvsp[0].n)) free_node((yyvsp[0].n));
	(yyvsp[0].n)=mksvaluenode(Pike_sp-1);
	type=(yyvsp[0].n)->type;
	pop_stack();
      }
    }
    if(!type) type = mixed_type_string;
    add_ref(type);
    low_add_local_name(Pike_compiler->compiler_frame, /*->previous,*/
		       (yyvsp[-2].n)->u.sval.u.string,
		       type, (yyvsp[0].n));
    /* Note: Intentionally not marked as used. */
    free_node((yyvsp[-2].n));
  }
#line 6186 "y.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1938 "language.yacc" /* yacc.c:1646  */
    { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 6192 "y.tab.c" /* yacc.c:1646  */
    break;

  case 264:
#line 1939 "language.yacc" /* yacc.c:1646  */
    { if ((yyvsp[0].n)) free_node((yyvsp[0].n)); }
#line 6198 "y.tab.c" /* yacc.c:1646  */
    break;

  case 268:
#line 1947 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 6204 "y.tab.c" /* yacc.c:1646  */
    break;

  case 269:
#line 1949 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 6213 "y.tab.c" /* yacc.c:1646  */
    break;

  case 270:
#line 1953 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ';'."); }
#line 6219 "y.tab.c" /* yacc.c:1646  */
    break;

  case 271:
#line 1957 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6225 "y.tab.c" /* yacc.c:1646  */
    break;

  case 272:
#line 1959 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(F_COMMA_EXPR, (yyvsp[-1].n), mkcastnode(void_type_string, (yyvsp[0].n)));
  }
#line 6233 "y.tab.c" /* yacc.c:1646  */
    break;

  case 275:
#line 1967 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6239 "y.tab.c" /* yacc.c:1646  */
    break;

  case 278:
#line 1970 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6245 "y.tab.c" /* yacc.c:1646  */
    break;

  case 282:
#line 1974 "language.yacc" /* yacc.c:1646  */
    { reset_type_stack(); (yyval.n)=0; yyerrok; }
#line 6251 "y.tab.c" /* yacc.c:1646  */
    break;

  case 283:
#line 1976 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
    (yyval.n)=0;
  }
#line 6262 "y.tab.c" /* yacc.c:1646  */
    break;

  case 284:
#line 1983 "language.yacc" /* yacc.c:1646  */
    {
    reset_type_stack();
    yyerror("Missing ';'.");
/*    yychar = '}'; */	/* Put the '}' back on the input stream. */
    (yyval.n)=0;
  }
#line 6273 "y.tab.c" /* yacc.c:1646  */
    break;

  case 285:
#line 1989 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 6279 "y.tab.c" /* yacc.c:1646  */
    break;

  case 286:
#line 1993 "language.yacc" /* yacc.c:1646  */
    {
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
#line 6287 "y.tab.c" /* yacc.c:1646  */
    break;

  case 295:
#line 2007 "language.yacc" /* yacc.c:1646  */
    {
    Pike_compiler->compiler_frame->opt_flags &= ~OPT_CUSTOM_LABELS;
  }
#line 6295 "y.tab.c" /* yacc.c:1646  */
    break;

  case 296:
#line 2011 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(Pike_compiler->compiler_frame->opt_flags & OPT_CUSTOM_LABELS ?
		F_CUSTOM_STMT_LABEL : F_NORMAL_STMT_LABEL,
		(yyvsp[-3].n), (yyvsp[0].n));

    /* FIXME: This won't be correct if the node happens to be shared.
     * That's an issue to be solved with shared nodes in general,
     * though. */
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
  }
#line 6310 "y.tab.c" /* yacc.c:1646  */
    break;

  case 298:
#line 2024 "language.yacc" /* yacc.c:1646  */
    {(yyval.n) = 0;}
#line 6316 "y.tab.c" /* yacc.c:1646  */
    break;

  case 299:
#line 2027 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_BREAK,(yyvsp[0].n),0); }
#line 6322 "y.tab.c" /* yacc.c:1646  */
    break;

  case 300:
#line 2028 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_DEFAULT,0,0); }
#line 6328 "y.tab.c" /* yacc.c:1646  */
    break;

  case 301:
#line 2030 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_DEFAULT,0,0); yyerror("Expected ':' after default.");
  }
#line 6336 "y.tab.c" /* yacc.c:1646  */
    break;

  case 302:
#line 2035 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_CONTINUE,(yyvsp[0].n),0); }
#line 6342 "y.tab.c" /* yacc.c:1646  */
    break;

  case 303:
#line 2038 "language.yacc" /* yacc.c:1646  */
    {
    push_compiler_frame(SCOPE_LOCAL);

    (yyval.ptr) = Pike_compiler->compiler_frame;
  }
#line 6352 "y.tab.c" /* yacc.c:1646  */
    break;

  case 304:
#line 2046 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *name;
    (yyval.n)=mkstrnode(name = get_new_name(NULL));
    free_string(name);
  }
#line 6362 "y.tab.c" /* yacc.c:1646  */
    break;

  case 305:
#line 2054 "language.yacc" /* yacc.c:1646  */
    {
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);
  }
#line 6374 "y.tab.c" /* yacc.c:1646  */
    break;

  case 306:
#line 2062 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *name = (yyvsp[-3].n)->u.sval.u.string;
    struct pike_type *type;
    int e;

    (yyval.number) = Pike_compiler->varargs;
    Pike_compiler->varargs = 0;

    if (Pike_compiler->compiler_pass == 1) {
      /* Define a tentative prototype for the lambda. */
      push_finished_type(mixed_type_string);
      e=(yyvsp[0].number)-1;
      if((yyval.number))
      {
	push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	e--;
	pop_type_stack(T_ARRAY);
      }else{
	push_type(T_VOID);
      }
      Pike_compiler->varargs=0;
      push_type(T_MANY);
      for(; e>=0; e--) {
	push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	push_type(T_FUNCTION);
      }
      type=compiler_pop_type();
      Pike_compiler->compiler_frame->current_function_number =
	define_function(name, type,
			ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			IDENTIFIER_PIKE_FUNCTION, NULL,
			(unsigned INT16)
			(Pike_compiler->compiler_frame->opt_flags));
      free_type(type);
    } else {
      /* In pass 2 we just reuse the type from pass 1. */
      Pike_compiler->compiler_frame->current_function_number =
	isidentifier(name);
    }
  }
#line 6419 "y.tab.c" /* yacc.c:1646  */
    break;

  case 307:
#line 2103 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    int f,e;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = (yyvsp[-6].n)->current_file;
    c->lex.current_line = (yyvsp[-6].n)->line_number;

    debug_malloc_touch((yyvsp[0].n));
    (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));
    if (Pike_compiler->compiler_pass == 2) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type((yyvsp[0].n));
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }

    e=(yyvsp[-2].number)-1;
    if((yyvsp[-1].number))
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    Pike_compiler->varargs=0;
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    type=compiler_pop_type();

    name = (yyvsp[-5].n)->u.sval.u.string;

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n%d:   type: ",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1,
	    Pike_compiler->compiler_pass);
    simple_describe_type(type);
    fprintf(stderr, "\n");
#endif /* LAMBDA_DEBUG */

    f=dooptcode(name,
		(yyvsp[0].n),
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

#ifdef PIKE_DEBUG
    if (f != Pike_compiler->compiler_frame->current_function_number) {
      Pike_fatal("Lost track of lambda %s.\n", name->str);
    }
#endif /* PIKE_DEBUG */

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d:   lexical_scope: 0x%08x\n",
	    Pike_compiler->compiler_pass,
	    Pike_compiler->compiler_frame->lexical_scope);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      (yyval.n) = mktrampolinenode(f, Pike_compiler->compiler_frame->previous);
    } else {
      (yyval.n) = mkidentifiernode(f);
    }
    free_type(type);
    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node((yyvsp[-5].n));
    free_node ((yyvsp[-6].n));
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-4].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-4].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
#line 6519 "y.tab.c" /* yacc.c:1646  */
    break;

  case 308:
#line 2199 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    (yyval.n) = mkintnode(0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
    free_node((yyvsp[-2].n));
    free_node((yyvsp[-3].n));
  }
#line 6539 "y.tab.c" /* yacc.c:1646  */
    break;

  case 309:
#line 2217 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *name;
    struct pike_type *type;
    int id,e;
    node *n;
    struct identifier *i=0;

    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   (yyvsp[-3].n)->u.sval.u.type);


    /***/
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e=(yyvsp[0].number)-1;
    if(Pike_compiler->varargs)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
    push_type(T_FUNCTION);
    }

    type=compiler_pop_type();
    /***/

    name = get_new_name((yyvsp[-2].n)->u.sval.u.string);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_pass > 1)
    {
      id=isidentifier(name);
    }else{
      id=define_function(name,
			 type,
			 ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			 IDENTIFIER_PIKE_FUNCTION |
			 (Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			 0,
			 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    }
    Pike_compiler->varargs=0;
    Pike_compiler->compiler_frame->current_function_number=id;

    n=0;
    if(Pike_compiler->compiler_pass > 1 &&
       (i=ID_FROM_INT(Pike_compiler->new_program, id)))
    {
      if(i->identifier_flags & IDENTIFIER_SCOPED)
	n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
      else
	n = mkidentifiernode(id);
    }

    low_add_local_name(Pike_compiler->compiler_frame->previous,
		       (yyvsp[-2].n)->u.sval.u.string, type, n);

    (yyval.number)=id;
    free_string(name);
  }
#line 6619 "y.tab.c" /* yacc.c:1646  */
    break;

  case 310:
#line 2293 "language.yacc" /* yacc.c:1646  */
    {
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program, (yyvsp[-1].number));
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = (yyvsp[-4].n)->current_file;
    c->lex.current_line = (yyvsp[-4].n)->line_number;

    (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));

    debug_malloc_touch((yyvsp[0].n));
    dooptcode(i->name,
	      (yyvsp[0].n),
	      i->type,
	      ID_PROTECTED | ID_PRIVATE | ID_INLINE);

    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-4].n));

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->variable[localid].def)
    {
      (yyval.n)=copy_node(Pike_compiler->compiler_frame->variable[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope &
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
	(yyval.n) = mktrampolinenode((yyvsp[-1].number),Pike_compiler->compiler_frame);
      }else{
	(yyval.n) = mkidentifiernode((yyvsp[-1].number));
      }
    }
  }
#line 6675 "y.tab.c" /* yacc.c:1646  */
    break;

  case 311:
#line 2345 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    (yyval.n)=mkintnode(0);
  }
#line 6692 "y.tab.c" /* yacc.c:1646  */
    break;

  case 312:
#line 2360 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *name;
    struct pike_type *type;
    int id,e;
    node *n;
    struct identifier *i=0;

    /***/
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);

    push_finished_type((yyvsp[-4].n)->u.sval.u.type);

    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    Pike_compiler->compiler_frame->current_return_type=compiler_pop_type();

    /***/
    push_finished_type(Pike_compiler->compiler_frame->current_return_type);

    e=(yyvsp[0].number)-1;
    if(Pike_compiler->varargs)
    {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      e--;
      pop_type_stack(T_ARRAY);
    }else{
      push_type(T_VOID);
    }
    push_type(T_MANY);
    for(; e>=0; e--) {
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
      push_type(T_FUNCTION);
    }

    type=compiler_pop_type();
    /***/

    name = get_new_name((yyvsp[-2].n)->u.sval.u.string);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    if(Pike_compiler->compiler_pass > 1)
    {
      id=isidentifier(name);
    }else{
      id=define_function(name,
			 type,
			 ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED,
			 IDENTIFIER_PIKE_FUNCTION|
			 (Pike_compiler->varargs?IDENTIFIER_VARARGS:0),
			 0,
			 OPT_SIDE_EFFECT|OPT_EXTERNAL_DEPEND);
    }
    Pike_compiler->varargs=0;
    Pike_compiler->compiler_frame->current_function_number=id;

    n=0;
    if(Pike_compiler->compiler_pass > 1 &&
       (i=ID_FROM_INT(Pike_compiler->new_program, id)))
    {
      if(i->identifier_flags & IDENTIFIER_SCOPED)
	n = mktrampolinenode(id, Pike_compiler->compiler_frame->previous);
      else
	n = mkidentifiernode(id);
    }

    low_add_local_name(Pike_compiler->compiler_frame->previous,
		       (yyvsp[-2].n)->u.sval.u.string, type, n);
    (yyval.number)=id;
    free_string(name);
  }
#line 6773 "y.tab.c" /* yacc.c:1646  */
    break;

  case 313:
#line 2437 "language.yacc" /* yacc.c:1646  */
    {
    int localid;
    struct identifier *i=ID_FROM_INT(Pike_compiler->new_program, (yyvsp[-1].number));
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = (yyvsp[-4].n)->current_file;
    c->lex.current_line = (yyvsp[-4].n)->line_number;

    debug_malloc_touch((yyvsp[0].n));
    (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),mknode(F_RETURN,mkintnode(0),0));


    debug_malloc_touch((yyvsp[0].n));
    dooptcode(i->name,
	      (yyvsp[0].n),
	      i->type,
	      ID_PROTECTED | ID_PRIVATE | ID_INLINE);

    i->opt_flags = Pike_compiler->compiler_frame->opt_flags;

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-4].n));

    /* WARNING: If the local function adds more variables we are screwed */
    /* WARNING2: if add_local_name stops adding local variables at the end,
     *           this has to be fixed.
     */

    localid=Pike_compiler->compiler_frame->current_number_of_locals-1;
    if(Pike_compiler->compiler_frame->variable[localid].def)
    {
      (yyval.n)=copy_node(Pike_compiler->compiler_frame->variable[localid].def);
    }else{
      if(Pike_compiler->compiler_frame->lexical_scope &
	 (SCOPE_SCOPE_USED | SCOPE_SCOPED))
      {
        (yyval.n) = mktrampolinenode((yyvsp[-1].number),Pike_compiler->compiler_frame);
      }else{
        (yyval.n) = mkidentifiernode((yyvsp[-1].number));
      }
    }
  }
#line 6831 "y.tab.c" /* yacc.c:1646  */
    break;

  case 314:
#line 2491 "language.yacc" /* yacc.c:1646  */
    {
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-1].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-1].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
    free_node((yyvsp[-2].n));
    (yyval.n)=mkintnode(0);
  }
#line 6849 "y.tab.c" /* yacc.c:1646  */
    break;

  case 315:
#line 2507 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    int ref_no;

    if (Pike_compiler->num_create_args < 0) {
      yyerror("Can't define more variables after ...");
    }

    push_finished_type(Pike_compiler->compiler_frame->current_type);
    if ((yyvsp[-1].number)) {
      push_type(T_ARRAY);
    }
    type=compiler_pop_type();

    /* Add the identifier globally.
     * Note: Since these are the first identifiers (and references)
     *       to be added to the program, they will be numbered in
     *       sequence starting at 0 (zero). This means that the
     *       counter num_create_args is sufficient extra information
     *       to be able to keep track of them.
     */
    ref_no = define_variable((yyvsp[0].n)->u.sval.u.string, type,
			     Pike_compiler->current_modifiers);
    free_type(type);

    if (Pike_compiler->num_create_args != ref_no) {
      my_yyerror("Multiple definitions of create variable %S (%d != %d).",
		 (yyvsp[0].n)->u.sval.u.string,
		 Pike_compiler->num_create_args, ref_no);
    }
    if ((yyvsp[-1].number)) {
      /* Encode varargs marker as negative number of args. */
      Pike_compiler->num_create_args = -(ref_no + 1);
    } else {
      Pike_compiler->num_create_args = ref_no + 1;
    }

    /* free_type(type); */
    free_node((yyvsp[0].n));
    (yyval.number)=0;
  }
#line 6895 "y.tab.c" /* yacc.c:1646  */
    break;

  case 316:
#line 2548 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 6901 "y.tab.c" /* yacc.c:1646  */
    break;

  case 317:
#line 2551 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = 1; }
#line 6907 "y.tab.c" /* yacc.c:1646  */
    break;

  case 318:
#line 2552 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + 1; }
#line 6913 "y.tab.c" /* yacc.c:1646  */
    break;

  case 319:
#line 2554 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected ':' in create argument list.");
    (yyval.number) = (yyvsp[-2].number) + 1;
  }
#line 6922 "y.tab.c" /* yacc.c:1646  */
    break;

  case 320:
#line 2560 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 6928 "y.tab.c" /* yacc.c:1646  */
    break;

  case 322:
#line 2564 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = 0; }
#line 6934 "y.tab.c" /* yacc.c:1646  */
    break;

  case 323:
#line 2566 "language.yacc" /* yacc.c:1646  */
    {
    /* NOTE: One more than the number of arguments, so that we
<     *       can detect the case of no parenthesis below. */
    (yyval.number) = (yyvsp[-1].number) + 1;
    free_node((yyvsp[0].n));
  }
#line 6945 "y.tab.c" /* yacc.c:1646  */
    break;

  case 324:
#line 2574 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = NULL; }
#line 6951 "y.tab.c" /* yacc.c:1646  */
    break;

  case 326:
#line 2575 "language.yacc" /* yacc.c:1646  */
    { yyerrok; }
#line 6957 "y.tab.c" /* yacc.c:1646  */
    break;

  case 327:
#line 2577 "language.yacc" /* yacc.c:1646  */
    {
		  yyerror("End of file where program definition expected.");
		}
#line 6965 "y.tab.c" /* yacc.c:1646  */
    break;

  case 328:
#line 2584 "language.yacc" /* yacc.c:1646  */
    {
    if(!(yyvsp[0].n))
    {
      struct pike_string *s;
      char buffer[42];
      sprintf(buffer,"__class_%ld_%ld_line_%d",
	      (long)Pike_compiler->new_program->id,
	      (long)Pike_compiler->local_class_counter++,
	      (int) (yyvsp[-1].n)->line_number);
      s=make_shared_string(buffer);
      (yyvsp[0].n)=mkstrnode(s);
      free_string(s);
      (yyvsp[-3].number)|=ID_PROTECTED | ID_PRIVATE | ID_INLINE;
    }
    /* fprintf(stderr, "LANGUAGE.YACC: CLASS start\n"); */
    if(Pike_compiler->compiler_pass==1)
    {
      if ((yyvsp[-3].number) & ID_EXTERN) {
	yywarning("Extern declared class definition.");
      }
      low_start_new_program(0, 1, (yyvsp[0].n)->u.sval.u.string,
			    (yyvsp[-3].number),
			    &(yyval.number));

      /* fprintf(stderr, "Pass 1: Program %s has id %d\n",
	 $4->u.sval.u.string->str, Pike_compiler->new_program->id); */

      store_linenumber((yyvsp[-1].n)->line_number, (yyvsp[-1].n)->current_file);
      debug_malloc_name(Pike_compiler->new_program,
			(yyvsp[-1].n)->current_file->str,
			(yyvsp[-1].n)->line_number);
    }else{
      int i;
      struct identifier *id;
      int tmp=Pike_compiler->compiler_pass;
      i=isidentifier((yyvsp[0].n)->u.sval.u.string);
      if(i<0)
      {
	/* Seriously broken... */
	yyerror("Pass 2: program not defined!");
	low_start_new_program(0, 2, 0,
			      (yyvsp[-3].number),
			      &(yyval.number));
      }else{
	id=ID_FROM_INT(Pike_compiler->new_program, i);
	if(IDENTIFIER_IS_CONSTANT(id->identifier_flags))
	{
	  struct svalue *s;
	  if ((id->func.const_info.offset >= 0) &&
	      (TYPEOF(*(s = &PROG_FROM_INT(Pike_compiler->new_program,i)->
			constants[id->func.const_info.offset].sval)) ==
	       T_PROGRAM))
	  {
	    low_start_new_program(s->u.program, 2,
				  (yyvsp[0].n)->u.sval.u.string,
				  (yyvsp[-3].number),
				  &(yyval.number));

	    /* fprintf(stderr, "Pass 2: Program %s has id %d\n",
	       $4->u.sval.u.string->str, Pike_compiler->new_program->id); */

	  }else{
	    yyerror("Pass 2: constant redefined!");
	    low_start_new_program(0, 2, 0,
				  (yyvsp[-3].number),
				  &(yyval.number));
	  }
	}else{
	  yyerror("Pass 2: class constant no longer constant!");
	  low_start_new_program(0, 2, 0,
				(yyvsp[-3].number),
				&(yyval.number));
	}
      }
      Pike_compiler->compiler_pass=tmp;
    }
  }
#line 7047 "y.tab.c" /* yacc.c:1646  */
    break;

  case 329:
#line 2661 "language.yacc" /* yacc.c:1646  */
    {
    /* Clear scoped modifiers. */
    (yyval.number) = THIS_COMPILATION->lex.pragmas;
    THIS_COMPILATION->lex.pragmas &= ~ID_MODIFIER_MASK;
  }
#line 7057 "y.tab.c" /* yacc.c:1646  */
    break;

  case 330:
#line 2667 "language.yacc" /* yacc.c:1646  */
    {
    struct program *p;

    /* Check if we have create arguments but no locally defined create(). */
    if ((yyvsp[-1].number)) {
      struct pike_string *create_string = NULL;
      struct reference *ref = NULL;
      struct identifier *id = NULL;
      int ref_id;
      MAKE_CONST_STRING(create_string, "create");
      if (((ref_id = isidentifier(create_string)) < 0) ||
	  (ref = PTR_FROM_INT(Pike_compiler->new_program, ref_id))->inherit_offset ||
	  ((id = ID_FROM_PTR(Pike_compiler->new_program, ref))->func.offset == -1)) {
	int e;
	struct pike_type *type = NULL;
	int nargs = Pike_compiler->num_create_args;

	push_compiler_frame(SCOPE_LOCAL);

	/* Init: Prepend the create arguments. */
	if (Pike_compiler->num_create_args < 0) {
	  for (e = 0; e < -Pike_compiler->num_create_args; e++) {
	    id = Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(id->name, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	} else {
	  for (e = 0; e < Pike_compiler->num_create_args; e++) {
	    id = Pike_compiler->new_program->identifiers + e;
	    add_ref(id->type);
	    add_local_name(id->name, id->type, 0);
	    /* Note: add_local_name() above will return e. */
	    Pike_compiler->compiler_frame->variable[e].flags |=
	      LOCAL_VAR_IS_USED;
	  }
	}

	/* First: Deduce the type for the create() function. */
	push_type(T_VOID); /* Return type. */

	if ((e = nargs) < 0) {
	  /* Varargs */
	  e = nargs = -nargs;
	  push_finished_type(Pike_compiler->compiler_frame->variable[--e].type);
	  pop_type_stack(T_ARRAY); /* Pop one level of array. */
	} else {
	  /* Not varargs. */
	  push_type(T_VOID);
	}
	push_type(T_MANY);
	while(e--) {
	  push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
	  push_type(T_FUNCTION);
	}

	type = compiler_pop_type();

	/* Second: Declare the function. */

	Pike_compiler->compiler_frame->current_function_number=
	  define_function(create_string, type,
			  ID_INLINE | ID_PROTECTED,
			  IDENTIFIER_PIKE_FUNCTION |
			  (Pike_compiler->num_create_args < 0?IDENTIFIER_VARARGS:0),
			  0,
			  OPT_SIDE_EFFECT);

	if (Pike_compiler->compiler_pass == 2) {
	  node *create_code = NULL;
	  int f;

	  /* Third: Generate the initialization code.
	   *
	   * global_arg = [type]local_arg;
	   * [,..]
	   */

	  for(e=0; e<nargs; e++)
	  {
	    if(!Pike_compiler->compiler_frame->variable[e].name ||
	       !Pike_compiler->compiler_frame->variable[e].name->len)
	    {
	      my_yyerror("Missing name for argument %d.",e);
	    } else {
	      node *local_node = mklocalnode(e, 0);

	      /* FIXME: Should probably use some other flag. */
	      if ((runtime_options & RUNTIME_CHECK_TYPES) &&
		  (Pike_compiler->compiler_pass == 2) &&
		  (Pike_compiler->compiler_frame->variable[e].type !=
		   mixed_type_string)) {
		/* fprintf(stderr, "Creating soft cast node for local #%d\n", e);*/

		local_node = mkcastnode(mixed_type_string, local_node);

		/* NOTE: The cast to mixed above is needed to avoid generating
		 *       compilation errors, as well as avoiding optimizations
		 *       in mksoftcastnode().
		 */
		local_node = mksoftcastnode(Pike_compiler->compiler_frame->
					    variable[e].type, local_node);
	      }
	      create_code =
		mknode(F_COMMA_EXPR, create_code,
		       mknode(F_ASSIGN, local_node,
			      mkidentifiernode(e)));
	    }
	  }

	  /* Fourth: Add a return 0; at the end. */

	  create_code = mknode(F_COMMA_EXPR,
			       mknode(F_POP_VALUE, create_code, NULL),
			       mknode(F_RETURN, mkintnode(0), NULL));

	  /* Fifth: Define the function. */

	  f=dooptcode(create_string, create_code, type, ID_PROTECTED);

#ifdef PIKE_DEBUG
	  if(Pike_interpreter.recoveries &&
	     Pike_sp-Pike_interpreter.evaluator_stack < Pike_interpreter.recoveries->stack_pointer)
	    Pike_fatal("Stack error (underflow)\n");

	  if(Pike_compiler->compiler_pass == 1 &&
	     f!=Pike_compiler->compiler_frame->current_function_number)
	    Pike_fatal("define_function screwed up! %d != %d\n",
		       f, Pike_compiler->compiler_frame->current_function_number);
#endif
	}

	/* Done. */

	free_type(type);
	pop_compiler_frame();
      }
    }

    if(Pike_compiler->compiler_pass == 1)
      p=end_first_pass(0);
    else
      p=end_first_pass(1);

    /* fprintf(stderr, "LANGUAGE.YACC: CLASS end\n"); */

    if(p) {
      /* Update the type for the program constant,
       * since we might have a lfun::create(). */
      struct identifier *i;
      struct svalue sv;
      SET_SVAL(sv, T_PROGRAM, 0, program, p);
      i = ID_FROM_INT(Pike_compiler->new_program, (yyvsp[-3].number));
      free_type(i->type);
      i->type = get_type_of_svalue(&sv);
      free_program(p);
    } else if (!Pike_compiler->num_parse_error) {
      /* Make sure code in this class is aware that something went wrong. */
      Pike_compiler->num_parse_error = 1;
    }

    (yyval.n)=mkidentifiernode((yyvsp[-3].number));

    free_node((yyvsp[-5].n));
    free_node((yyvsp[-4].n));
    check_tree((yyval.n),0);
    THIS_COMPILATION->lex.pragmas = (yyvsp[-2].number);
  }
#line 7232 "y.tab.c" /* yacc.c:1646  */
    break;

  case 332:
#line 2840 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = 0; }
#line 7238 "y.tab.c" /* yacc.c:1646  */
    break;

  case 333:
#line 2843 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = 0; }
#line 7244 "y.tab.c" /* yacc.c:1646  */
    break;

  case 334:
#line 2844 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = (yyvsp[0].n); }
#line 7250 "y.tab.c" /* yacc.c:1646  */
    break;

  case 336:
#line 2850 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-1].n)) {
      if ((yyvsp[0].n)) {
	/* Explicit enum value. */

	/* This can be made more lenient in the future */

	/* Ugly hack to make sure that $2 is optimized */
	{
	  int tmp=Pike_compiler->compiler_pass;
	  (yyvsp[0].n)=mknode(F_COMMA_EXPR,(yyvsp[0].n),0);
	  Pike_compiler->compiler_pass=tmp;
	}

	if(!is_const((yyvsp[0].n)))
	{
	  if(Pike_compiler->compiler_pass==2)
	    yyerror("Enum definition is not constant.");
	  push_int(0);
	} else {
	  if(!Pike_compiler->num_parse_error)
	  {
	    ptrdiff_t tmp=eval_low((yyvsp[0].n),1);
	    if(tmp < 1)
	    {
	      yyerror("Error in enum definition.");
	      push_int(0);
	    }else{
	      pop_n_elems(DO_NOT_WARN((INT32)(tmp - 1)));
	    }
	  } else {
	    push_int(0);
	  }
	}
	free_node((yyvsp[0].n));
	free_node((yyvsp[-2].n));
	(yyvsp[-2].n) = mkconstantsvaluenode(Pike_sp-1);
      } else {
	/* Implicit enum value. */
	(yyvsp[-2].n) = safe_inc_enum((yyvsp[-2].n));
	push_svalue(&(yyvsp[-2].n)->u.sval);
      }
      add_constant((yyvsp[-1].n)->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      /* Update the type. */
      {
	struct pike_type *current = pop_unfinished_type();
	struct pike_type *new = get_type_of_svalue(Pike_sp-1);
	struct pike_type *res = or_pike_types(new, current, 3);
	free_type(current);
	free_type(new);
	type_stack_mark();
	push_finished_type(res);
	free_type(res);
      }
      pop_stack();
      free_node((yyvsp[-1].n));
    } else if ((yyvsp[0].n)) {
      free_node((yyvsp[0].n));
    }
  }
#line 7316 "y.tab.c" /* yacc.c:1646  */
    break;

  case 337:
#line 2915 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = (yyvsp[(-2) - (0)].n);
  }
#line 7324 "y.tab.c" /* yacc.c:1646  */
    break;

  case 339:
#line 2922 "language.yacc" /* yacc.c:1646  */
    { (yyvsp[-4].n) = (yyvsp[-1].n); }
#line 7330 "y.tab.c" /* yacc.c:1646  */
    break;

  case 341:
#line 2928 "language.yacc" /* yacc.c:1646  */
    {
    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared enum.");
    }

    type_stack_mark();
    push_type(T_ZERO);	/* Joined type so far. */
  }
#line 7344 "y.tab.c" /* yacc.c:1646  */
    break;

  case 342:
#line 2938 "language.yacc" /* yacc.c:1646  */
    {
    push_int(-1);	/* Previous value. */
    (yyval.n) = mkconstantsvaluenode(Pike_sp-1);
    pop_stack();
  }
#line 7354 "y.tab.c" /* yacc.c:1646  */
    break;

  case 343:
#line 2943 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = NULL; }
#line 7360 "y.tab.c" /* yacc.c:1646  */
    break;

  case 344:
#line 2944 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *t = pop_unfinished_type();
    free_node((yyvsp[-3].n));
    if ((yyvsp[-5].n)) {
      ref_push_type_value(t);
      add_constant((yyvsp[-5].n)->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node((yyvsp[-5].n));
    }
    (yyval.n) = mktypenode(t);
    free_type(t);
  }
#line 7378 "y.tab.c" /* yacc.c:1646  */
    break;

  case 345:
#line 2960 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *t = compiler_pop_type();

    if ((Pike_compiler->current_modifiers & ID_EXTERN) &&
	(Pike_compiler->compiler_pass == 1)) {
      yywarning("Extern declared typedef.");
    }

    if ((yyvsp[-1].n)) {
      ref_push_type_value(t);
      add_constant((yyvsp[-1].n)->u.sval.u.string, Pike_sp-1,
		   (Pike_compiler->current_modifiers & ~ID_EXTERN) | ID_INLINE);
      pop_stack();
      free_node((yyvsp[-1].n));
    }
    free_type(t);
  }
#line 7400 "y.tab.c" /* yacc.c:1646  */
    break;

  case 346:
#line 2980 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7408 "y.tab.c" /* yacc.c:1646  */
    break;

  case 347:
#line 2984 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7418 "y.tab.c" /* yacc.c:1646  */
    break;

  case 348:
#line 2990 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode('?', (yyvsp[-3].n),
		mknode(':',
		       mkcastnode(void_type_string, (yyvsp[-1].n)),
		       mkcastnode(void_type_string, (yyvsp[0].n))));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    (yyval.n) = mkcastnode(void_type_string, (yyval.n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    free_node ((yyvsp[-6].n));
    pop_local_variables((yyvsp[-7].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-5].number);
  }
#line 7435 "y.tab.c" /* yacc.c:1646  */
    break;

  case 350:
#line 3005 "language.yacc" /* yacc.c:1646  */
    { yyerror("Missing ')'."); }
#line 7441 "y.tab.c" /* yacc.c:1646  */
    break;

  case 351:
#line 3007 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 7450 "y.tab.c" /* yacc.c:1646  */
    break;

  case 352:
#line 3013 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7456 "y.tab.c" /* yacc.c:1646  */
    break;

  case 353:
#line 3014 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 7462 "y.tab.c" /* yacc.c:1646  */
    break;

  case 354:
#line 3018 "language.yacc" /* yacc.c:1646  */
    {
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES) && (yyvsp[0].n)) {
      if ((yyvsp[0].n)->token == F_ARRAY_LVALUE) {
	mark_lvalues_as_used(CAR((yyvsp[0].n)));
      } else if (((yyvsp[0].n)->token == F_LOCAL) && !((yyvsp[0].n)->u.integer.b)) {
	Pike_compiler->compiler_frame->variable[(yyvsp[0].n)->u.integer.a].flags |=
	  LOCAL_VAR_IS_USED;
      }
    }
  }
#line 7477 "y.tab.c" /* yacc.c:1646  */
    break;

  case 355:
#line 3028 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7483 "y.tab.c" /* yacc.c:1646  */
    break;

  case 357:
#line 3032 "language.yacc" /* yacc.c:1646  */
    { yyerror("Unexpected end of file."); (yyval.n)=0; }
#line 7489 "y.tab.c" /* yacc.c:1646  */
    break;

  case 358:
#line 3033 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7495 "y.tab.c" /* yacc.c:1646  */
    break;

  case 359:
#line 3037 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7501 "y.tab.c" /* yacc.c:1646  */
    break;

  case 361:
#line 3041 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 7507 "y.tab.c" /* yacc.c:1646  */
    break;

  case 362:
#line 3043 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(':',(yyvsp[-2].n),(yyvsp[0].n)); }
#line 7513 "y.tab.c" /* yacc.c:1646  */
    break;

  case 363:
#line 3047 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7521 "y.tab.c" /* yacc.c:1646  */
    break;

  case 364:
#line 3051 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7531 "y.tab.c" /* yacc.c:1646  */
    break;

  case 365:
#line 3057 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-2].n)) {
      (yyval.n)=mknode(F_FOREACH,
		mknode(F_VAL_LVAL,(yyvsp[-3].n),(yyvsp[-2].n)),
		(yyvsp[0].n));
    } else {
      /* Error in lvalue */
      (yyval.n)=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-3].n)), (yyvsp[0].n));
    }
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    free_node ((yyvsp[-6].n));
    pop_local_variables((yyvsp[-7].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-5].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 7551 "y.tab.c" /* yacc.c:1646  */
    break;

  case 366:
#line 3076 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_DO,(yyvsp[-5].n),(yyvsp[-2].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-6].n));
    free_node ((yyvsp[-6].n));
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 7562 "y.tab.c" /* yacc.c:1646  */
    break;

  case 367:
#line 3083 "language.yacc" /* yacc.c:1646  */
    {
    free_node ((yyvsp[-3].n));
    (yyval.n)=0;
    yyerror("Missing '(' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
#line 7573 "y.tab.c" /* yacc.c:1646  */
    break;

  case 368:
#line 3090 "language.yacc" /* yacc.c:1646  */
    {
    free_node ((yyvsp[-2].n));
    (yyval.n)=0;
    yyerror("Missing 'while' in do-while loop.");
    yyerror("Unexpected end of file.");
  }
#line 7584 "y.tab.c" /* yacc.c:1646  */
    break;

  case 370:
#line 3100 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ';'.");
    yyerror("Unexpected end of file.");
  }
#line 7593 "y.tab.c" /* yacc.c:1646  */
    break;

  case 371:
#line 3107 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7601 "y.tab.c" /* yacc.c:1646  */
    break;

  case 372:
#line 3111 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7611 "y.tab.c" /* yacc.c:1646  */
    break;

  case 373:
#line 3118 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-6].n)),
	      mknode(F_FOR,(yyvsp[-4].n),mknode(':',(yyvsp[0].n),(yyvsp[-2].n))));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-9].n));
    free_node ((yyvsp[-9].n));
    pop_local_variables((yyvsp[-10].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-8].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 7625 "y.tab.c" /* yacc.c:1646  */
    break;

  case 374:
#line 3131 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7633 "y.tab.c" /* yacc.c:1646  */
    break;

  case 375:
#line 3135 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7643 "y.tab.c" /* yacc.c:1646  */
    break;

  case 376:
#line 3141 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_FOR,(yyvsp[-2].n),mknode(':',(yyvsp[0].n),NULL));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-5].n));
    free_node ((yyvsp[-5].n));
    pop_local_variables((yyvsp[-6].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-4].number);
    Pike_compiler->compiler_frame->opt_flags |= OPT_CUSTOM_LABELS;
  }
#line 7656 "y.tab.c" /* yacc.c:1646  */
    break;

  case 377:
#line 3151 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkintnode(1); }
#line 7662 "y.tab.c" /* yacc.c:1646  */
    break;

  case 379:
#line 3156 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 7670 "y.tab.c" /* yacc.c:1646  */
    break;

  case 380:
#line 3160 "language.yacc" /* yacc.c:1646  */
    {
    /* Trick to store more than one number on compiler stack - Hubbe */
    (yyval.number)=Pike_compiler->compiler_frame->last_block_level;
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-1].number);
  }
#line 7680 "y.tab.c" /* yacc.c:1646  */
    break;

  case 381:
#line 3166 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_SWITCH,(yyvsp[-2].n),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-5].n));
    free_node ((yyvsp[-5].n));
    pop_local_variables((yyvsp[-6].number));
    Pike_compiler->compiler_frame->last_block_level=(yyvsp[-4].number);
  }
#line 7692 "y.tab.c" /* yacc.c:1646  */
    break;

  case 382:
#line 3176 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_CASE,(yyvsp[-1].n),0);
  }
#line 7700 "y.tab.c" /* yacc.c:1646  */
    break;

  case 383:
#line 3180 "language.yacc" /* yacc.c:1646  */
    {
     (yyval.n)=mknode(F_CASE_RANGE,(yyvsp[-3].n),(yyvsp[-1].n));
  }
#line 7708 "y.tab.c" /* yacc.c:1646  */
    break;

  case 384:
#line 3184 "language.yacc" /* yacc.c:1646  */
    {
     (yyval.n)=mknode(F_CASE_RANGE,0,(yyvsp[-1].n));
  }
#line 7716 "y.tab.c" /* yacc.c:1646  */
    break;

  case 386:
#line 3191 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ':'.");
  }
#line 7724 "y.tab.c" /* yacc.c:1646  */
    break;

  case 387:
#line 3195 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ':'.");
  }
#line 7732 "y.tab.c" /* yacc.c:1646  */
    break;

  case 388:
#line 3199 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ':'.");
    yyerror("Unexpected end of file.");
  }
#line 7741 "y.tab.c" /* yacc.c:1646  */
    break;

  case 389:
#line 3206 "language.yacc" /* yacc.c:1646  */
    {
    if(!match_types(Pike_compiler->compiler_frame->current_return_type,
		    void_type_string))
    {
      yytype_error("Must return a value for a non-void function.",
		   Pike_compiler->compiler_frame->current_return_type,
		   void_type_string, 0);
    }
    (yyval.n)=mknode(F_RETURN,mkintnode(0),0);
  }
#line 7756 "y.tab.c" /* yacc.c:1646  */
    break;

  case 390:
#line 3217 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_RETURN,(yyvsp[-1].n),0);
  }
#line 7764 "y.tab.c" /* yacc.c:1646  */
    break;

  case 391:
#line 3222 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7770 "y.tab.c" /* yacc.c:1646  */
    break;

  case 392:
#line 3223 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkcastnode(void_type_string, (yyvsp[0].n));  }
#line 7776 "y.tab.c" /* yacc.c:1646  */
    break;

  case 393:
#line 3226 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkcastnode(void_type_string, (yyvsp[0].n));  }
#line 7782 "y.tab.c" /* yacc.c:1646  */
    break;

  case 394:
#line 3228 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7788 "y.tab.c" /* yacc.c:1646  */
    break;

  case 397:
#line 3233 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7794 "y.tab.c" /* yacc.c:1646  */
    break;

  case 399:
#line 3237 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); free_node((yyvsp[-1].n)); }
#line 7800 "y.tab.c" /* yacc.c:1646  */
    break;

  case 400:
#line 3238 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); free_node((yyvsp[-1].n)); }
#line 7806 "y.tab.c" /* yacc.c:1646  */
    break;

  case 401:
#line 3239 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); free_node((yyvsp[-1].n)); }
#line 7812 "y.tab.c" /* yacc.c:1646  */
    break;

  case 402:
#line 3240 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); free_node((yyvsp[-1].n)); }
#line 7818 "y.tab.c" /* yacc.c:1646  */
    break;

  case 404:
#line 3246 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(F_COMMA_EXPR, mkcastnode(void_type_string, (yyvsp[-2].n)), (yyvsp[0].n));
  }
#line 7826 "y.tab.c" /* yacc.c:1646  */
    break;

  case 406:
#line 3252 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_PUSH_ARRAY,(yyvsp[0].n),0); }
#line 7832 "y.tab.c" /* yacc.c:1646  */
    break;

  case 408:
#line 3255 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_ASSIGN,(yyvsp[0].n),(yyvsp[-2].n)); }
#line 7838 "y.tab.c" /* yacc.c:1646  */
    break;

  case 409:
#line 3256 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); reset_type_stack(); yyerrok; }
#line 7844 "y.tab.c" /* yacc.c:1646  */
    break;

  case 410:
#line 3257 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 7850 "y.tab.c" /* yacc.c:1646  */
    break;

  case 411:
#line 3259 "language.yacc" /* yacc.c:1646  */
    {
    if (!(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used((yyvsp[-3].n));
    }
    (yyval.n)=mknode(F_ASSIGN,(yyvsp[0].n),mknode(F_ARRAY_LVALUE,(yyvsp[-3].n),0));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 7863 "y.tab.c" /* yacc.c:1646  */
    break;

  case 412:
#line 3267 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode((yyvsp[-1].number),(yyvsp[-2].n),(yyvsp[0].n)); }
#line 7869 "y.tab.c" /* yacc.c:1646  */
    break;

  case 413:
#line 3268 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); reset_type_stack(); yyerrok; }
#line 7875 "y.tab.c" /* yacc.c:1646  */
    break;

  case 414:
#line 3269 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[0].n); }
#line 7881 "y.tab.c" /* yacc.c:1646  */
    break;

  case 415:
#line 3271 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode((yyvsp[-1].number),mknode(F_ARRAY_LVALUE,(yyvsp[-3].n),0),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 7891 "y.tab.c" /* yacc.c:1646  */
    break;

  case 416:
#line 3277 "language.yacc" /* yacc.c:1646  */
    {
      (yyval.n)=(yyvsp[-2].n); free_node ((yyvsp[-3].n)); reset_type_stack(); yyerrok;
    }
#line 7899 "y.tab.c" /* yacc.c:1646  */
    break;

  case 418:
#line 3284 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode('?',(yyvsp[-4].n),mknode(':',(yyvsp[-2].n),(yyvsp[0].n))); }
#line 7905 "y.tab.c" /* yacc.c:1646  */
    break;

  case 419:
#line 3287 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_AND_EQ; }
#line 7911 "y.tab.c" /* yacc.c:1646  */
    break;

  case 420:
#line 3288 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_OR_EQ; }
#line 7917 "y.tab.c" /* yacc.c:1646  */
    break;

  case 421:
#line 3289 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_XOR_EQ; }
#line 7923 "y.tab.c" /* yacc.c:1646  */
    break;

  case 422:
#line 3290 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_LSH_EQ; }
#line 7929 "y.tab.c" /* yacc.c:1646  */
    break;

  case 423:
#line 3291 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_RSH_EQ; }
#line 7935 "y.tab.c" /* yacc.c:1646  */
    break;

  case 424:
#line 3292 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_ADD_EQ; }
#line 7941 "y.tab.c" /* yacc.c:1646  */
    break;

  case 425:
#line 3293 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_SUB_EQ; }
#line 7947 "y.tab.c" /* yacc.c:1646  */
    break;

  case 426:
#line 3294 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_MULT_EQ; }
#line 7953 "y.tab.c" /* yacc.c:1646  */
    break;

  case 427:
#line 3295 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_MOD_EQ; }
#line 7959 "y.tab.c" /* yacc.c:1646  */
    break;

  case 428:
#line 3296 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=F_DIV_EQ; }
#line 7965 "y.tab.c" /* yacc.c:1646  */
    break;

  case 429:
#line 3299 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=0; }
#line 7971 "y.tab.c" /* yacc.c:1646  */
    break;

  case 430:
#line 3299 "language.yacc" /* yacc.c:1646  */
    { (yyval.number)=1; }
#line 7977 "y.tab.c" /* yacc.c:1646  */
    break;

  case 431:
#line 3301 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7983 "y.tab.c" /* yacc.c:1646  */
    break;

  case 434:
#line 3307 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n)); }
#line 7989 "y.tab.c" /* yacc.c:1646  */
    break;

  case 435:
#line 3310 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 7995 "y.tab.c" /* yacc.c:1646  */
    break;

  case 438:
#line 3316 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[0].n)) {
      (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n));
    } else {
      /* Error in assoc_pair */
      (yyval.n)=(yyvsp[-2].n);
    }
  }
#line 8008 "y.tab.c" /* yacc.c:1646  */
    break;

  case 440:
#line 3328 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_ARG_LIST,(yyvsp[-2].n),(yyvsp[0].n));
  }
#line 8016 "y.tab.c" /* yacc.c:1646  */
    break;

  case 441:
#line 3331 "language.yacc" /* yacc.c:1646  */
    { free_node((yyvsp[-2].n)); (yyval.n)=0; }
#line 8022 "y.tab.c" /* yacc.c:1646  */
    break;

  case 443:
#line 3335 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_LOR,(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8028 "y.tab.c" /* yacc.c:1646  */
    break;

  case 444:
#line 3336 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_LAND,(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8034 "y.tab.c" /* yacc.c:1646  */
    break;

  case 445:
#line 3337 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`|",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8040 "y.tab.c" /* yacc.c:1646  */
    break;

  case 446:
#line 3338 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`^",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8046 "y.tab.c" /* yacc.c:1646  */
    break;

  case 447:
#line 3339 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`&",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8052 "y.tab.c" /* yacc.c:1646  */
    break;

  case 448:
#line 3340 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`==",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8058 "y.tab.c" /* yacc.c:1646  */
    break;

  case 449:
#line 3341 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`!=",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8064 "y.tab.c" /* yacc.c:1646  */
    break;

  case 450:
#line 3342 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`>",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8070 "y.tab.c" /* yacc.c:1646  */
    break;

  case 451:
#line 3343 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`>=",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8076 "y.tab.c" /* yacc.c:1646  */
    break;

  case 452:
#line 3344 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`<",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8082 "y.tab.c" /* yacc.c:1646  */
    break;

  case 453:
#line 3345 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`<=",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8088 "y.tab.c" /* yacc.c:1646  */
    break;

  case 454:
#line 3346 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`<<",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8094 "y.tab.c" /* yacc.c:1646  */
    break;

  case 455:
#line 3347 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`>>",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8100 "y.tab.c" /* yacc.c:1646  */
    break;

  case 456:
#line 3348 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`+",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8106 "y.tab.c" /* yacc.c:1646  */
    break;

  case 457:
#line 3349 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`-",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8112 "y.tab.c" /* yacc.c:1646  */
    break;

  case 458:
#line 3350 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`*",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8118 "y.tab.c" /* yacc.c:1646  */
    break;

  case 459:
#line 3351 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`%",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8124 "y.tab.c" /* yacc.c:1646  */
    break;

  case 460:
#line 3352 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`/",(yyvsp[-2].n),(yyvsp[0].n)); }
#line 8130 "y.tab.c" /* yacc.c:1646  */
    break;

  case 480:
#line 3375 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mkcastnode((yyvsp[-1].n)->u.sval.u.type, (yyvsp[0].n));
    free_node((yyvsp[-1].n));
  }
#line 8139 "y.tab.c" /* yacc.c:1646  */
    break;

  case 481:
#line 3380 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mksoftcastnode((yyvsp[-1].n)->u.sval.u.type, (yyvsp[0].n));
    free_node((yyvsp[-1].n));
  }
#line 8148 "y.tab.c" /* yacc.c:1646  */
    break;

  case 482:
#line 3384 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_INC,(yyvsp[0].n),0); }
#line 8154 "y.tab.c" /* yacc.c:1646  */
    break;

  case 483:
#line 3385 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_DEC,(yyvsp[0].n),0); }
#line 8160 "y.tab.c" /* yacc.c:1646  */
    break;

  case 484:
#line 3386 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`!",(yyvsp[0].n),0); }
#line 8166 "y.tab.c" /* yacc.c:1646  */
    break;

  case 485:
#line 3387 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`~",(yyvsp[0].n),0); }
#line 8172 "y.tab.c" /* yacc.c:1646  */
    break;

  case 486:
#line 3388 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkopernode("`-",(yyvsp[0].n),0); }
#line 8178 "y.tab.c" /* yacc.c:1646  */
    break;

  case 488:
#line 3392 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_POST_INC,(yyvsp[-1].n),0); }
#line 8184 "y.tab.c" /* yacc.c:1646  */
    break;

  case 489:
#line 3393 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknode(F_POST_DEC,(yyvsp[-1].n),0); }
#line 8190 "y.tab.c" /* yacc.c:1646  */
    break;

  case 490:
#line 3415 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 8196 "y.tab.c" /* yacc.c:1646  */
    break;

  case 491:
#line 3419 "language.yacc" /* yacc.c:1646  */
    {
    debug_malloc_touch(Pike_compiler->compiler_frame->current_return_type);
    if(Pike_compiler->compiler_frame->current_return_type)
      free_type(Pike_compiler->compiler_frame->current_return_type);
    copy_pike_type(Pike_compiler->compiler_frame->current_return_type,
		   any_type_string);

    /* block code */
    (yyvsp[-2].number)=Pike_compiler->num_used_modules;
    (yyval.number)=Pike_compiler->compiler_frame->current_number_of_locals;
  }
#line 8212 "y.tab.c" /* yacc.c:1646  */
    break;

  case 492:
#line 3431 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *type;
    int f/*, e */;
    struct pike_string *name;
    struct compilation *c = THIS_COMPILATION;
    struct pike_string *save_file = c->lex.current_file;
    int save_line = c->lex.current_line;
    c->lex.current_file = (yyvsp[-4].n)->current_file;
    c->lex.current_line = (yyvsp[-4].n)->line_number;

    /* block code */
    unuse_modules(Pike_compiler->num_used_modules - (yyvsp[-5].number));
    pop_local_variables((yyvsp[-2].number));

    debug_malloc_touch((yyvsp[-1].n));
    (yyvsp[-1].n)=mknode(F_COMMA_EXPR,(yyvsp[-1].n),mknode(F_RETURN,mkintnode(0),0));
    if (Pike_compiler->compiler_pass == 2) {
      /* Doing this in pass 1 might induce too strict checks on types
       * in cases where we got placeholders. */
      type=find_return_type((yyvsp[-1].n));
      if (type) {
	push_finished_type(type);
	free_type(type);
      } else {
	yywarning("Failed to determine return type for implicit lambda.");
	push_type(T_ZERO);
      }
    } else {
      /* Tentative return type. */
      push_type(T_MIXED);
    }

    push_type(T_VOID);
    push_type(T_MANY);
/*
    e=$5-1;
    for(; e>=0; e--)
      push_finished_type(Pike_compiler->compiler_frame->variable[e].type);
*/

    type=compiler_pop_type();

    name = get_new_name(NULL);

#ifdef LAMBDA_DEBUG
    fprintf(stderr, "%d: IMPLICIT LAMBDA: %s 0x%08lx 0x%08lx\n",
	    Pike_compiler->compiler_pass, name->str,
	    (long)Pike_compiler->new_program->id,
	    Pike_compiler->local_class_counter-1);
#endif /* LAMBDA_DEBUG */

    f=dooptcode(name,
		(yyvsp[-1].n),
		type,
		ID_PROTECTED | ID_PRIVATE | ID_INLINE | ID_USED);

    if(Pike_compiler->compiler_frame->lexical_scope & SCOPE_SCOPED) {
      (yyval.n) = mktrampolinenode(f,Pike_compiler->compiler_frame->previous);
    } else {
      (yyval.n) = mkidentifiernode(f);
    }

    c->lex.current_line = save_line;
    c->lex.current_file = save_file;
    free_node ((yyvsp[-4].n));
    free_string(name);
    free_type(type);
#ifdef PIKE_DEBUG
    if (Pike_compiler->compiler_frame != (yyvsp[-3].ptr)) {
      Pike_fatal("Lost track of compiler_frame!\n"
		 "  Got: %p (Expected: %p) Previous: %p\n",
		 Pike_compiler->compiler_frame, (yyvsp[-3].ptr),
		 Pike_compiler->compiler_frame->previous);
    }
#endif
    pop_compiler_frame();
  }
#line 8294 "y.tab.c" /* yacc.c:1646  */
    break;

  case 493:
#line 3512 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mkapplynode((yyvsp[-4].n), mknode(F_ARG_LIST, (yyvsp[-2].n), (yyvsp[0].n)));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-3].n));
    free_node ((yyvsp[-3].n));
  }
#line 8304 "y.tab.c" /* yacc.c:1646  */
    break;

  case 494:
#line 3518 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mkapplynode((yyvsp[-4].n), (yyvsp[0].n));
    free_node ((yyvsp[-3].n));
    yyerrok;
  }
#line 8314 "y.tab.c" /* yacc.c:1646  */
    break;

  case 495:
#line 3524 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 8325 "y.tab.c" /* yacc.c:1646  */
    break;

  case 496:
#line 3531 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 8335 "y.tab.c" /* yacc.c:1646  */
    break;

  case 497:
#line 3537 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing ')'.");
    (yyval.n)=mkapplynode((yyvsp[-3].n), NULL);
    free_node ((yyvsp[-2].n));
  }
#line 8345 "y.tab.c" /* yacc.c:1646  */
    break;

  case 498:
#line 3545 "language.yacc" /* yacc.c:1646  */
    {
    if (TEST_COMPAT(7, 6)) {
      (yyval.number) = Pike_compiler->current_modifiers =
	(THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
    } else {
      (yyval.number) = Pike_compiler->current_modifiers = ID_PROTECTED|ID_INLINE|ID_PRIVATE |
	(THIS_COMPILATION->lex.pragmas & ID_MODIFIER_MASK);
    }
  }
#line 8359 "y.tab.c" /* yacc.c:1646  */
    break;

  case 501:
#line 3558 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mkfloatnode((FLOAT_TYPE)(yyvsp[0].fnum)); }
#line 8365 "y.tab.c" /* yacc.c:1646  */
    break;

  case 507:
#line 3564 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = (yyvsp[0].n); }
#line 8371 "y.tab.c" /* yacc.c:1646  */
    break;

  case 508:
#line 3565 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = (yyvsp[0].n); }
#line 8377 "y.tab.c" /* yacc.c:1646  */
    break;

  case 511:
#line 3569 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_AUTO_MAP_MARKER, (yyvsp[-3].n), 0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 8387 "y.tab.c" /* yacc.c:1646  */
    break;

  case 512:
#line 3575 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_INDEX,(yyvsp[-3].n),(yyvsp[-1].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 8397 "y.tab.c" /* yacc.c:1646  */
    break;

  case 513:
#line 3582 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_RANGE,(yyvsp[-5].n),mknode(':',(yyvsp[-3].n),(yyvsp[-1].n)));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 8407 "y.tab.c" /* yacc.c:1646  */
    break;

  case 514:
#line 3588 "language.yacc" /* yacc.c:1646  */
    {
    /* A[?X] to ((tmp=A) && tmp[X]) */
    if( (yyvsp[-4].n)->token == F_LOCAL )
    {
      (yyval.n)=mknode(F_LAND, copy_node((yyvsp[-4].n)), mknode(F_INDEX,  (yyvsp[-4].n), (yyvsp[-1].n)));
    }
    else
    {
      fix_type_field( (yyvsp[-4].n) );
      if( (yyvsp[-4].n)->type )
      {
        int temporary;
        (yyvsp[-4].n)->type->refs++;

        temporary = add_local_name(empty_pike_string, (yyvsp[-4].n)->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        (yyval.n)=mknode(F_LAND,
                  mknode(F_ASSIGN, (yyvsp[-4].n), mklocalnode(temporary,0)),
                  mknode(F_INDEX,  mklocalnode(temporary,0), (yyvsp[-1].n)));
      }
      else
      {
        (yyval.n)=mknode(F_INDEX, (yyvsp[-4].n),(yyvsp[-1].n));
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node ((yyvsp[-2].n));
  }
#line 8441 "y.tab.c" /* yacc.c:1646  */
    break;

  case 515:
#line 3619 "language.yacc" /* yacc.c:1646  */
    {
    /* A[?X..Y] to ((tmp=A) && tmp[X..Y]) */
    node *range = mknode(':',(yyvsp[-3].n),(yyvsp[-1].n));
    if( (yyvsp[-6].n)->token == F_LOCAL )
    {
      (yyval.n) = mknode( F_LAND, copy_node((yyvsp[-6].n)), mknode(F_RANGE, (yyvsp[-6].n), range) );
    }
    else
    {
      fix_type_field( (yyvsp[-6].n) );
      if( (yyvsp[-6].n)->type )
      {
        int temporary;
        (yyvsp[-6].n)->type->refs++;

        temporary = add_local_name(empty_pike_string, (yyvsp[-6].n)->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        (yyval.n)=mknode(F_LAND,
                  mknode(F_ASSIGN, (yyvsp[-6].n), mklocalnode(temporary,0) ),
                  mknode(F_RANGE,  mklocalnode(temporary,0), range) );
      }
      else
      {
        (yyval.n) = mknode( F_LAND, (yyvsp[-6].n), mknode(F_RANGE,(yyvsp[-6].n),range) );
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
    free_node ((yyvsp[-4].n));
  }
#line 8476 "y.tab.c" /* yacc.c:1646  */
    break;

  case 516:
#line 3650 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=(yyvsp[-3].n);
    free_node ((yyvsp[-2].n));
    yyerrok;
  }
#line 8486 "y.tab.c" /* yacc.c:1646  */
    break;

  case 517:
#line 3656 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'.");
    yyerror("Unexpected end of file.");
    free_node ((yyvsp[-2].n));
  }
#line 8496 "y.tab.c" /* yacc.c:1646  */
    break;

  case 518:
#line 3662 "language.yacc" /* yacc.c:1646  */
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 8502 "y.tab.c" /* yacc.c:1646  */
    break;

  case 519:
#line 3664 "language.yacc" /* yacc.c:1646  */
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 8508 "y.tab.c" /* yacc.c:1646  */
    break;

  case 520:
#line 3666 "language.yacc" /* yacc.c:1646  */
    {(yyval.n)=(yyvsp[-3].n); yyerror("Missing ']'."); free_node ((yyvsp[-2].n));}
#line 8514 "y.tab.c" /* yacc.c:1646  */
    break;

  case 521:
#line 3668 "language.yacc" /* yacc.c:1646  */
    {
      (yyval.n)=(yyvsp[-1].n);
      if ((yyval.n)) {
	COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      }
      free_node ((yyvsp[-2].n));
    }
#line 8526 "y.tab.c" /* yacc.c:1646  */
    break;

  case 522:
#line 3676 "language.yacc" /* yacc.c:1646  */
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate",(yyvsp[-2].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
      free_node ((yyvsp[-4].n));
    }
#line 8537 "y.tab.c" /* yacc.c:1646  */
    break;

  case 523:
#line 3685 "language.yacc" /* yacc.c:1646  */
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate_mapping",(yyvsp[-2].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-4].n));
      free_node ((yyvsp[-4].n));
      free_node ((yyvsp[-3].n));
    }
#line 8549 "y.tab.c" /* yacc.c:1646  */
    break;

  case 524:
#line 3693 "language.yacc" /* yacc.c:1646  */
    {
      /* FIXME: May eat lots of stack; cf Standards.FIPS10_4.divisions */
      (yyval.n)=mkefuncallnode("aggregate_multiset",(yyvsp[-1].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 8560 "y.tab.c" /* yacc.c:1646  */
    break;

  case 525:
#line 3700 "language.yacc" /* yacc.c:1646  */
    {
      yyerror("Missing '>'.");
      (yyval.n)=mkefuncallnode("aggregate_multiset",(yyvsp[-1].n));
      COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
      free_node ((yyvsp[-2].n));
    }
#line 8571 "y.tab.c" /* yacc.c:1646  */
    break;

  case 526:
#line 3706 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerrok; }
#line 8577 "y.tab.c" /* yacc.c:1646  */
    break;

  case 527:
#line 3708 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 8586 "y.tab.c" /* yacc.c:1646  */
    break;

  case 528:
#line 3712 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'."); }
#line 8592 "y.tab.c" /* yacc.c:1646  */
    break;

  case 529:
#line 3713 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerror("Missing ')'."); }
#line 8598 "y.tab.c" /* yacc.c:1646  */
    break;

  case 530:
#line 3714 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerrok; }
#line 8604 "y.tab.c" /* yacc.c:1646  */
    break;

  case 531:
#line 3715 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Missing '>'.");
    (yyval.n)=(yyvsp[-2].n); yyerrok;
  }
#line 8613 "y.tab.c" /* yacc.c:1646  */
    break;

  case 532:
#line 3720 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'.");
    yyerror("Unexpected end of file.");
  }
#line 8622 "y.tab.c" /* yacc.c:1646  */
    break;

  case 533:
#line 3724 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'."); }
#line 8628 "y.tab.c" /* yacc.c:1646  */
    break;

  case 534:
#line 3725 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-2].n); yyerror("Missing '>)'."); }
#line 8634 "y.tab.c" /* yacc.c:1646  */
    break;

  case 535:
#line 3727 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_ARROW,(yyvsp[-3].n),(yyvsp[0].n));
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-1].n));
    free_node ((yyvsp[-1].n));
  }
#line 8644 "y.tab.c" /* yacc.c:1646  */
    break;

  case 536:
#line 3733 "language.yacc" /* yacc.c:1646  */
    {
    /* A?->B to ((tmp=A) && tmp->B) */
    int temporary;
    if( (yyvsp[-3].n)->token == F_LOCAL )
    {
      (yyval.n)=mknode(F_LAND, copy_node((yyvsp[-3].n)), mknode(F_ARROW, (yyvsp[-3].n), (yyvsp[0].n)));
    }
    else
    {
      fix_type_field( (yyvsp[-3].n) );
      if( (yyvsp[-3].n)->type )
      {
        (yyvsp[-3].n)->type->refs++;

        temporary = add_local_name(empty_pike_string, (yyvsp[-3].n)->type, 0);
        Pike_compiler->compiler_frame->variable[temporary].flags |= LOCAL_VAR_IS_USED;
        (yyval.n)=mknode(F_LAND,
                  mknode(F_ASSIGN, (yyvsp[-3].n), mklocalnode(temporary,0)),
                  mknode(F_ARROW,  mklocalnode(temporary,0), (yyvsp[0].n)));
      }
      else
      {
        (yyval.n)=mknode(F_ARROW, (yyvsp[-3].n),(yyvsp[0].n));
        yyerror("Indexing unexpected value.");
      }
    }
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-1].n));
    free_node ((yyvsp[-1].n));
  }
#line 8678 "y.tab.c" /* yacc.c:1646  */
    break;

  case 537:
#line 3763 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=index_node((yyvsp[-3].n),".",(yyvsp[0].n)->u.sval.u.string);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-1].n));
    free_node ((yyvsp[-3].n));
    free_node ((yyvsp[-1].n));
    free_node ((yyvsp[0].n));
  }
#line 8690 "y.tab.c" /* yacc.c:1646  */
    break;

  case 538:
#line 3770 "language.yacc" /* yacc.c:1646  */
    {(yyval.n)=(yyvsp[-3].n); free_node ((yyvsp[-1].n));}
#line 8696 "y.tab.c" /* yacc.c:1646  */
    break;

  case 540:
#line 3775 "language.yacc" /* yacc.c:1646  */
    {
    int i;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    if (((i = find_shared_string_identifier(Pike_compiler->last_identifier,
					    Pike_compiler->new_program)) >= 0) ||
	((i = really_low_find_shared_string_identifier(Pike_compiler->last_identifier,
						       Pike_compiler->new_program,
						       SEE_PROTECTED|
						       SEE_PRIVATE)) >= 0)) {
      struct reference *ref = Pike_compiler->new_program->identifier_references + i;
      if (IDENTIFIER_IS_VARIABLE (
	    ID_FROM_PTR (Pike_compiler->new_program, ref)->identifier_flags)) {
	/* Allowing local:: on variables would lead to pathological
	 * behavior: If a non-local variable in a class is referenced
	 * both with and without local::, both references would
	 * address the same variable in all cases except where an
	 * inheriting program overrides it (c.f. [bug 1252]).
	 *
	 * Furthermore, that's not how it works currently; if this
	 * error is removed then local:: will do nothing on variables
	 * except forcing a lookup in the closest surrounding class
	 * scope. */
	yyerror ("Cannot make local references to variables.");
	(yyval.n) = 0;
      }
      else {
	if (!(ref->id_flags & ID_LOCAL)) {
	  /* We need to generate a new reference. */
	  int d;
	  struct reference funp = *ref;
	  funp.id_flags = (funp.id_flags & ~ID_INHERITED) | ID_INLINE|ID_HIDDEN;
	  i = -1;
	  for(d = 0; d < (int)Pike_compiler->new_program->num_identifier_references; d++) {
	    struct reference *refp;
	    refp = Pike_compiler->new_program->identifier_references + d;

	    if (!(refp->id_flags & ID_LOCAL)) continue;

	    if((refp->inherit_offset == funp.inherit_offset) &&
	       (refp->identifier_offset == funp.identifier_offset)) {
	      i = d;
	      break;
	    }
	  }
	  if (i < 0) {
	    add_to_identifier_references(funp);
	    i = Pike_compiler->new_program->num_identifier_references - 1;
	  }
	}
	(yyval.n) = mkidentifiernode(i);
      }
    } else {
      if (Pike_compiler->compiler_pass == 2) {
	my_yyerror("%S not defined in local scope.",
		   Pike_compiler->last_identifier);
	(yyval.n) = 0;
      } else {
	(yyval.n) = mknode(F_UNDEFINED, 0, 0);
      }
    }

    free_node((yyvsp[0].n));
  }
#line 8767 "y.tab.c" /* yacc.c:1646  */
    break;

  case 541:
#line 3842 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
  }
#line 8775 "y.tab.c" /* yacc.c:1646  */
    break;

  case 543:
#line 3849 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=index_node((yyvsp[-2].n), Pike_compiler->last_identifier?Pike_compiler->last_identifier->str:NULL,
		  (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[0].n));
  }
#line 8788 "y.tab.c" /* yacc.c:1646  */
    break;

  case 544:
#line 3857 "language.yacc" /* yacc.c:1646  */
    {}
#line 8794 "y.tab.c" /* yacc.c:1646  */
    break;

  case 545:
#line 3858 "language.yacc" /* yacc.c:1646  */
    {}
#line 8800 "y.tab.c" /* yacc.c:1646  */
    break;

  case 548:
#line 3872 "language.yacc" /* yacc.c:1646  */
    {
    struct compilation *c = THIS_COMPILATION;
    struct program_state *state = Pike_compiler;
    int depth;
    int e = -1;

    inherit_state = NULL;
    inherit_depth = 0;

    /* NB: The heuristics here are a bit strange
     *     (all to make it as backward compatible as possible).
     *
     *     The priority order is as follows:
     *
     *     1: Direct inherits in the current class.
     *
     *     2: The name of the current class.
     *
     *     3: 1 & 2 recursively for surrounding parent classes.
     *
     *     4: Indirect inherits in the current class.
     *
     *     5: 4 recursively for surrounding parent classes.
     *
     *     6: this_program.
     *
     * Note that a deep inherit in the current class trumphs
     * a not so deep inherit in a parent class (but not a
     * direct inherit in a parent class). To select the deep
     * inherit in the parent class in this case, prefix it
     * with the name of the parent class.
     */
    for (depth = 0;; depth++, state = state->previous) {
      int inh = find_inherit(state->new_program, (yyvsp[-1].n)->u.sval.u.string);
      if (inh &&
	  (!inherit_state ||
	   (state->new_program->inherits[inh].inherit_level == 1))) {
	/* Found, and we've either not found anything earlier,
	 * or this is a direct inherit (and the previous
	 * wasn't since we didn't break out of the loop).
	 */
	e = inh;
	inherit_state = state;
	inherit_depth = depth;
	if (state->new_program->inherits[inh].inherit_level == 1) {
	  /* Name of direct inherit ==> Done. */
	  break;
	}
      }
      /* The top-level class does not have a name, so break here. */
      if (depth == c->compilation_depth) break;
      if (ID_FROM_INT (state->previous->new_program,
		       state->parent_identifier)->name ==
	  (yyvsp[-1].n)->u.sval.u.string) {
	/* Name of surrounding class ==> Done. */
	e = 0;
	inherit_state = state;
	inherit_depth = depth;
	break;
      }
    }
    if (e == -1) {
      inherit_state = state;
      inherit_depth = depth;
      if ((yyvsp[-1].n)->u.sval.u.string == this_program_string || (yyvsp[-1].n)->u.sval.u.string == this_string) {
        inherit_state = Pike_compiler;
        inherit_depth = 0;
        e = 0;
      }
      else
        my_yyerror("No inherit or surrounding class %S.",
                   (yyvsp[-1].n)->u.sval.u.string);
    }
    free_node((yyvsp[-1].n));
    (yyval.number) = e;
  }
#line 8881 "y.tab.c" /* yacc.c:1646  */
    break;

  case 549:
#line 3949 "language.yacc" /* yacc.c:1646  */
    {
    struct compilation *c = THIS_COMPILATION;
    inherit_state = Pike_compiler;
    for (inherit_depth = 0; inherit_depth < c->compilation_depth;
	 inherit_depth++, inherit_state = inherit_state->previous) {}
    (yyval.number) = -1;
  }
#line 8893 "y.tab.c" /* yacc.c:1646  */
    break;

  case 550:
#line 3957 "language.yacc" /* yacc.c:1646  */
    {
    int e = 0;
    if ((yyvsp[-2].number) < 0) {
      (yyvsp[-2].number) = 0;
    }
#if 0
    /* FIXME: The inherit modifiers aren't kept. */
    if (!(inherit_state->new_program->inherits[(yyvsp[-2].number)].flags & ID_PRIVATE)) {
#endif /* 0 */
      e = find_inherit(inherit_state->new_program->inherits[(yyvsp[-2].number)].prog,
		       (yyvsp[-1].n)->u.sval.u.string);
#if 0
    }
#endif /* 0 */
    if (!e) {
      if (inherit_state->new_program->inherits[(yyvsp[-2].number)].name) {
	my_yyerror("No such inherit %S::%S.",
		   inherit_state->new_program->inherits[(yyvsp[-2].number)].name,
		   (yyvsp[-1].n)->u.sval.u.string);
      } else {
	my_yyerror("No such inherit %S.", (yyvsp[-1].n)->u.sval.u.string);
      }
      (yyval.number) = -1;
    } else {
      /* We know stuff about the inherit structure... */
      (yyval.number) = e + (yyvsp[-2].number);
    }
    free_node((yyvsp[-1].n));
  }
#line 8927 "y.tab.c" /* yacc.c:1646  */
    break;

  case 551:
#line 3986 "language.yacc" /* yacc.c:1646  */
    { (yyval.number) = -1; }
#line 8933 "y.tab.c" /* yacc.c:1646  */
    break;

  case 552:
#line 3990 "language.yacc" /* yacc.c:1646  */
    {
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    if(((yyval.n)=lexical_islocal(Pike_compiler->last_identifier)))
    {
      /* done, nothing to do here */
    }else if(!((yyval.n)=find_module_identifier(Pike_compiler->last_identifier,1)) &&
	     !((yyval.n) = program_magic_identifier (Pike_compiler, 0, -1,
					      Pike_compiler->last_identifier, 0))) {
      if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	 (Pike_compiler->compiler_pass==2)) {
	my_yyerror("Undefined identifier %S.",
		   Pike_compiler->last_identifier);
	/* FIXME: Add this identifier as a constant in the current program to
	 *        avoid multiple reporting of the same identifier.
	 * NOTE: This should then only be done in the second pass.
	 */	
	(yyval.n)=0;
      }else{
	(yyval.n)=mknode(F_UNDEFINED,0,0);
      }
    }
    free_node((yyvsp[0].n));
  }
#line 8963 "y.tab.c" /* yacc.c:1646  */
    break;

  case 553:
#line 4016 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *dot;
    MAKE_CONST_STRING(dot, ".");
    if (call_handle_import(dot)) {
      node *tmp=mkconstantsvaluenode(Pike_sp-1);
      pop_stack();
      (yyval.n)=index_node(tmp, ".", (yyvsp[0].n)->u.sval.u.string);
      free_node(tmp);
    }
    else
      (yyval.n)=mknewintnode(0);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[0].n));
  }
#line 8983 "y.tab.c" /* yacc.c:1646  */
    break;

  case 554:
#line 4032 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = resolve_identifier ((yyvsp[0].n)->u.sval.u.string);
    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);
    free_node ((yyvsp[0].n));
  }
#line 8994 "y.tab.c" /* yacc.c:1646  */
    break;

  case 555:
#line 4039 "language.yacc" /* yacc.c:1646  */
    {
    ref_push_string((yyvsp[0].n)->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node((yyvsp[0].n));
    (yyval.n) = 0;
  }
#line 9006 "y.tab.c" /* yacc.c:1646  */
    break;

  case 556:
#line 4047 "language.yacc" /* yacc.c:1646  */
    {
    struct compilation *c = THIS_COMPILATION;
    node *tmp2;

    if(Pike_compiler->last_identifier)
      free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    tmp2 = mkconstantsvaluenode(&c->default_module);
    (yyval.n) = index_node(tmp2, "predef", (yyvsp[0].n)->u.sval.u.string);
    if(!(yyval.n)->name)
      add_ref( (yyval.n)->name=(yyvsp[0].n)->u.sval.u.string );
    free_node(tmp2);
    free_node((yyvsp[0].n));
  }
#line 9026 "y.tab.c" /* yacc.c:1646  */
    break;

  case 557:
#line 4063 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
  }
#line 9034 "y.tab.c" /* yacc.c:1646  */
    break;

  case 558:
#line 4067 "language.yacc" /* yacc.c:1646  */
    {
    struct compilation *c = THIS_COMPILATION;
    int old_major = Pike_compiler->compat_major;
    int old_minor = Pike_compiler->compat_minor;
    struct svalue *efun = NULL;

    change_compiler_compatibility((yyvsp[-2].n)->u.integer.a, (yyvsp[-2].n)->u.integer.b);

    if(Pike_compiler->last_identifier)
      free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    /* Check predef:: first, and then the modules. */

    (yyval.n) = 0;

    if (TYPEOF(c->default_module) == T_MAPPING) {
      if ((efun = low_mapping_lookup(c->default_module.u.mapping,
				     &((yyvsp[0].n)->u.sval))))
	(yyval.n) = mkconstantsvaluenode(efun);
    }

    else if (TYPEOF(c->default_module) != T_INT) {
      JMP_BUF tmp;
      if (SETJMP (tmp))
	handle_compile_exception ("Couldn't index %d.%d "
				  "default module with %O.",
				  (yyvsp[-2].n)->u.integer.a, (yyvsp[-2].n)->u.integer.b,
				  &(yyvsp[0].n)->u.sval);
      else {
	push_svalue (&c->default_module);
	push_svalue (&(yyvsp[0].n)->u.sval);
	f_index (2);
	if (!IS_UNDEFINED (Pike_sp - 1))
	  (yyval.n) = mkconstantsvaluenode (Pike_sp - 1);
	pop_stack();
      }
      UNSETJMP(tmp);
    }

    if (!(yyval.n) && !((yyval.n) = resolve_identifier(Pike_compiler->last_identifier))) {
      if((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	 (Pike_compiler->compiler_pass==2)) {
	my_yyerror("Undefined identifier %d.%d::%S.",
		   (yyvsp[-2].n)->u.integer.a, (yyvsp[-2].n)->u.integer.b,
		   Pike_compiler->last_identifier);
	(yyval.n)=0;
      }else{
	(yyval.n)=mknode(F_UNDEFINED,0,0);
      }
    }

    change_compiler_compatibility(old_major, old_minor);
    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
  }
#line 9095 "y.tab.c" /* yacc.c:1646  */
    break;

  case 559:
#line 4124 "language.yacc" /* yacc.c:1646  */
    {
    free_node((yyvsp[-2].n));
    (yyval.n)=0;
  }
#line 9104 "y.tab.c" /* yacc.c:1646  */
    break;

  case 560:
#line 4129 "language.yacc" /* yacc.c:1646  */
    {
    int id;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    if ((yyvsp[-1].number) > 0)
      id = low_reference_inherited_identifier(inherit_state,
					      (yyvsp[-1].number),
					      Pike_compiler->last_identifier,
					      SEE_PROTECTED);
    else
      id = really_low_find_shared_string_identifier(Pike_compiler->last_identifier,
						    inherit_state->new_program,
						    SEE_PROTECTED|SEE_PRIVATE);

    if (id != -1) {
      if (inherit_depth > 0) {
	(yyval.n) = mkexternalnode(inherit_state->new_program, id);
      } else {
	(yyval.n) = mkidentifiernode(id);
      }
    } else if (((yyval.n) = program_magic_identifier (inherit_state, inherit_depth, (yyvsp[-1].number),
					       Pike_compiler->last_identifier, 1))) {
      /* All done. */
    }
    else {
      if ((Pike_compiler->flags & COMPILATION_FORCE_RESOLVE) ||
	  (Pike_compiler->compiler_pass == 2)) {
	if (((yyvsp[-1].number) >= 0) && inherit_state->new_program->inherits[(yyvsp[-1].number)].name) {
	  my_yyerror("Undefined identifier %S::%S.",
		     inherit_state->new_program->inherits[(yyvsp[-1].number)].name,
		     Pike_compiler->last_identifier);
	} else {
	  my_yyerror("Undefined identifier %S.",
		     Pike_compiler->last_identifier);
	}
	(yyval.n)=0;
      }
      else
	(yyval.n)=mknode(F_UNDEFINED,0,0);
    }

    free_node((yyvsp[0].n));
  }
#line 9154 "y.tab.c" /* yacc.c:1646  */
    break;

  case 561:
#line 4174 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 9160 "y.tab.c" /* yacc.c:1646  */
    break;

  case 562:
#line 4175 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; }
#line 9166 "y.tab.c" /* yacc.c:1646  */
    break;

  case 563:
#line 4177 "language.yacc" /* yacc.c:1646  */
    {
    int e,i;

    if(Pike_compiler->last_identifier) free_string(Pike_compiler->last_identifier);
    copy_shared_string(Pike_compiler->last_identifier, (yyvsp[0].n)->u.sval.u.string);

    (yyval.n)=0;
    for(e=1;e<(int)Pike_compiler->new_program->num_inherits;e++)
    {
      if(Pike_compiler->new_program->inherits[e].inherit_level!=1) continue;
      i=low_reference_inherited_identifier(0,e,(yyvsp[0].n)->u.sval.u.string,SEE_PROTECTED);
      if(i==-1) continue;
      if((yyval.n))
      {
	(yyval.n)=mknode(F_ARG_LIST,(yyval.n),mkidentifiernode(i));
      }else{
	(yyval.n)=mkidentifiernode(i);
      }
    }
    if(!(yyval.n))
    {
      if (!((yyval.n) = program_magic_identifier (Pike_compiler, 0, -1,
					   (yyvsp[0].n)->u.sval.u.string, 1)))
      {
	if (Pike_compiler->compiler_pass == 2) {
          my_yyerror("Undefined identifier ::%S.", (yyvsp[0].n)->u.sval.u.string);
	}
	(yyval.n)=mkintnode(0);
      }
    }else{
      if((yyval.n)->token==F_ARG_LIST) (yyval.n)=mkefuncallnode("aggregate",(yyval.n));
    }
    free_node((yyvsp[0].n));
  }
#line 9205 "y.tab.c" /* yacc.c:1646  */
    break;

  case 564:
#line 4212 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
  }
#line 9213 "y.tab.c" /* yacc.c:1646  */
    break;

  case 565:
#line 4219 "language.yacc" /* yacc.c:1646  */
    {(yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);}
#line 9219 "y.tab.c" /* yacc.c:1646  */
    break;

  case 566:
#line 4221 "language.yacc" /* yacc.c:1646  */
    {(yyval.n) = mknode (F_RANGE_FROM_BEG, (yyvsp[0].n), NULL);}
#line 9225 "y.tab.c" /* yacc.c:1646  */
    break;

  case 567:
#line 4223 "language.yacc" /* yacc.c:1646  */
    {(yyval.n) = mknode (F_RANGE_FROM_END, (yyvsp[0].n), NULL);}
#line 9231 "y.tab.c" /* yacc.c:1646  */
    break;

  case 568:
#line 4225 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected end of file.");
    (yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);
  }
#line 9240 "y.tab.c" /* yacc.c:1646  */
    break;

  case 569:
#line 4230 "language.yacc" /* yacc.c:1646  */
    {
    yyerror("Unexpected end of file.");
    (yyval.n) = mknode (F_RANGE_OPEN, NULL, NULL);
  }
#line 9249 "y.tab.c" /* yacc.c:1646  */
    break;

  case 570:
#line 4237 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mkopernode("`/",
		  mkopernode("`-",
			     mkopernode("`-",
					mkefuncallnode("gethrvtime",
						       mkintnode(1)),
					mknode(F_COMMA_EXPR,
					       mknode(F_POP_VALUE, (yyvsp[0].n), NULL),
					       mkefuncallnode("gethrvtime",
							      mkintnode(1)))),
			     NULL),
		  mkfloatnode((FLOAT_TYPE)1e9));
  }
#line 9267 "y.tab.c" /* yacc.c:1646  */
    break;

  case 571:
#line 4252 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_type *t;
    node *tmp;

    /* FIXME: Why build the node at all? */
    /* Because the optimizer cannot optimize the root node of the
     * tree properly -Hubbe
     */
    tmp=mknode(F_COMMA_EXPR, (yyvsp[-1].n), 0);
    optimize_node(tmp);

    t=(tmp && CAR(tmp) && CAR(tmp)->type ? CAR(tmp)->type : mixed_type_string);
    (yyval.n) = mktypenode(t);
    free_node(tmp);
  }
#line 9287 "y.tab.c" /* yacc.c:1646  */
    break;

  case 572:
#line 4267 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerrok; }
#line 9293 "y.tab.c" /* yacc.c:1646  */
    break;

  case 573:
#line 4268 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9299 "y.tab.c" /* yacc.c:1646  */
    break;

  case 574:
#line 4270 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9308 "y.tab.c" /* yacc.c:1646  */
    break;

  case 575:
#line 4274 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9314 "y.tab.c" /* yacc.c:1646  */
    break;

  case 576:
#line 4277 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=(yyvsp[-1].n); }
#line 9320 "y.tab.c" /* yacc.c:1646  */
    break;

  case 577:
#line 4278 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerrok; }
#line 9326 "y.tab.c" /* yacc.c:1646  */
    break;

  case 578:
#line 4280 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9335 "y.tab.c" /* yacc.c:1646  */
    break;

  case 579:
#line 4284 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9341 "y.tab.c" /* yacc.c:1646  */
    break;

  case 580:
#line 4285 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9347 "y.tab.c" /* yacc.c:1646  */
    break;

  case 582:
#line 4287 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Bad expression for catch."); }
#line 9353 "y.tab.c" /* yacc.c:1646  */
    break;

  case 583:
#line 4291 "language.yacc" /* yacc.c:1646  */
    {
       Pike_compiler->catch_level++;
     }
#line 9361 "y.tab.c" /* yacc.c:1646  */
    break;

  case 584:
#line 4295 "language.yacc" /* yacc.c:1646  */
    {
       (yyval.n)=mknode(F_CATCH,(yyvsp[0].n),NULL);
       Pike_compiler->catch_level--;
     }
#line 9370 "y.tab.c" /* yacc.c:1646  */
    break;

  case 585:
#line 4302 "language.yacc" /* yacc.c:1646  */
    {
    if ((yyvsp[-1].n) && !(THIS_COMPILATION->lex.pragmas & ID_STRICT_TYPES)) {
      mark_lvalues_as_used((yyvsp[-1].n));
    }
    (yyval.n)=mknode(F_SSCANF,mknode(':', mkintnode(TEST_COMPAT(7, 6)? SSCANF_FLAG_76_COMPAT : 0), mknode(F_ARG_LIST,(yyvsp[-4].n),(yyvsp[-2].n))),(yyvsp[-1].n));
  }
#line 9381 "y.tab.c" /* yacc.c:1646  */
    break;

  case 586:
#line 4309 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerrok;
  }
#line 9392 "y.tab.c" /* yacc.c:1646  */
    break;

  case 587:
#line 4316 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9404 "y.tab.c" /* yacc.c:1646  */
    break;

  case 588:
#line 4324 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 9415 "y.tab.c" /* yacc.c:1646  */
    break;

  case 589:
#line 4331 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-4].n));
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 9426 "y.tab.c" /* yacc.c:1646  */
    break;

  case 590:
#line 4338 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerrok;
  }
#line 9436 "y.tab.c" /* yacc.c:1646  */
    break;

  case 591:
#line 4344 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9447 "y.tab.c" /* yacc.c:1646  */
    break;

  case 592:
#line 4351 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 9457 "y.tab.c" /* yacc.c:1646  */
    break;

  case 593:
#line 4357 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0;
    free_node((yyvsp[-2].n));
    yyerror("Missing ')'.");
  }
#line 9467 "y.tab.c" /* yacc.c:1646  */
    break;

  case 594:
#line 4362 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerrok; }
#line 9473 "y.tab.c" /* yacc.c:1646  */
    break;

  case 595:
#line 4364 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=0; yyerror("Missing ')'.");
    yyerror("Unexpected end of file.");
  }
#line 9482 "y.tab.c" /* yacc.c:1646  */
    break;

  case 596:
#line 4368 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9488 "y.tab.c" /* yacc.c:1646  */
    break;

  case 597:
#line 4369 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=0; yyerror("Missing ')'."); }
#line 9494 "y.tab.c" /* yacc.c:1646  */
    break;

  case 599:
#line 4374 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_ARRAY_LVALUE, (yyvsp[-1].n),0);
    COPY_LINE_NUMBER_INFO((yyval.n), (yyvsp[-2].n));
    free_node((yyvsp[-2].n));
  }
#line 9504 "y.tab.c" /* yacc.c:1646  */
    break;

  case 600:
#line 4380 "language.yacc" /* yacc.c:1646  */
    {
    int id = add_local_name((yyvsp[0].n)->u.sval.u.string,compiler_pop_type(),0);
    /* Note: Variable intentionally not marked as used. */
    if (id >= 0)
      (yyval.n)=mklocalnode(id,-1);
    else
      (yyval.n) = 0;
    free_node((yyvsp[0].n));
  }
#line 9518 "y.tab.c" /* yacc.c:1646  */
    break;

  case 601:
#line 4391 "language.yacc" /* yacc.c:1646  */
    { (yyval.n)=mknewintnode(0); }
#line 9524 "y.tab.c" /* yacc.c:1646  */
    break;

  case 602:
#line 4395 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n)=mknode(F_LVALUE_LIST,(yyvsp[-1].n),(yyvsp[0].n));
  }
#line 9532 "y.tab.c" /* yacc.c:1646  */
    break;

  case 603:
#line 4400 "language.yacc" /* yacc.c:1646  */
    { (yyval.n) = 0; }
#line 9538 "y.tab.c" /* yacc.c:1646  */
    break;

  case 604:
#line 4402 "language.yacc" /* yacc.c:1646  */
    {
    (yyval.n) = mknode(F_LVALUE_LIST,(yyvsp[-1].n),(yyvsp[0].n));
  }
#line 9546 "y.tab.c" /* yacc.c:1646  */
    break;

  case 606:
#line 4409 "language.yacc" /* yacc.c:1646  */
    {
    struct compiler_frame *f = Pike_compiler->compiler_frame;
    if (!f || (f->current_function_number < 0)) {
      (yyval.n) = mkstrnode(lfun_strings[LFUN___INIT]);
    } else {
      struct identifier *id =
	ID_FROM_INT(Pike_compiler->new_program, f->current_function_number);
      if (!id->name->size_shift) {
	int len;
	if ((len = strlen(id->name->str)) == id->name->len) {
	  /* Most common case. */
	  (yyval.n) = mkstrnode(id->name);
	} else {
	  struct pike_string *str =
	    make_shared_binary_string(id->name->str, len);
	  (yyval.n) = mkstrnode(str);
	  free_string(str);
	}
      } else {
	struct pike_string *str;
	struct array *split;
	MAKE_CONST_STRING(str, "\0");
	split = explode(id->name, str);
	(yyval.n) = mkstrnode(split->item->u.string);
	free_array(split);
      }
    }
  }
#line 9579 "y.tab.c" /* yacc.c:1646  */
    break;

  case 608:
#line 4441 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-1].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-1].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 9594 "y.tab.c" /* yacc.c:1646  */
    break;

  case 610:
#line 4455 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-2].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 9609 "y.tab.c" /* yacc.c:1646  */
    break;

  case 612:
#line 4470 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-1].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-1].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 9624 "y.tab.c" /* yacc.c:1646  */
    break;

  case 613:
#line 4481 "language.yacc" /* yacc.c:1646  */
    {
    struct pike_string *a,*b;
    copy_shared_string(a,(yyvsp[-2].n)->u.sval.u.string);
    copy_shared_string(b,(yyvsp[0].n)->u.sval.u.string);
    free_node((yyvsp[-2].n));
    free_node((yyvsp[0].n));
    a=add_and_free_shared_strings(a,b);
    (yyval.n)=mkstrnode(a);
    free_string(a);
  }
#line 9639 "y.tab.c" /* yacc.c:1646  */
    break;

  case 615:
#line 4501 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("array"); }
#line 9645 "y.tab.c" /* yacc.c:1646  */
    break;

  case 616:
#line 4503 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("__attribute__"); }
#line 9651 "y.tab.c" /* yacc.c:1646  */
    break;

  case 617:
#line 4505 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("class"); }
#line 9657 "y.tab.c" /* yacc.c:1646  */
    break;

  case 618:
#line 4507 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("__deprecated__"); }
#line 9663 "y.tab.c" /* yacc.c:1646  */
    break;

  case 619:
#line 4509 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("enum"); }
#line 9669 "y.tab.c" /* yacc.c:1646  */
    break;

  case 620:
#line 4511 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("float");}
#line 9675 "y.tab.c" /* yacc.c:1646  */
    break;

  case 621:
#line 4513 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("function");}
#line 9681 "y.tab.c" /* yacc.c:1646  */
    break;

  case 622:
#line 4515 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("__FUNCTION__");}
#line 9687 "y.tab.c" /* yacc.c:1646  */
    break;

  case 623:
#line 4517 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("int"); }
#line 9693 "y.tab.c" /* yacc.c:1646  */
    break;

  case 624:
#line 4519 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("mapping"); }
#line 9699 "y.tab.c" /* yacc.c:1646  */
    break;

  case 625:
#line 4521 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("mixed"); }
#line 9705 "y.tab.c" /* yacc.c:1646  */
    break;

  case 626:
#line 4523 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("multiset"); }
#line 9711 "y.tab.c" /* yacc.c:1646  */
    break;

  case 627:
#line 4525 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("object"); }
#line 9717 "y.tab.c" /* yacc.c:1646  */
    break;

  case 628:
#line 4527 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("program"); }
#line 9723 "y.tab.c" /* yacc.c:1646  */
    break;

  case 629:
#line 4529 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("string"); }
#line 9729 "y.tab.c" /* yacc.c:1646  */
    break;

  case 630:
#line 4531 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("typedef"); }
#line 9735 "y.tab.c" /* yacc.c:1646  */
    break;

  case 631:
#line 4533 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("void"); }
#line 9741 "y.tab.c" /* yacc.c:1646  */
    break;

  case 632:
#line 4535 "language.yacc" /* yacc.c:1646  */
    {
    ref_push_string((yyvsp[0].n)->u.sval.u.string);
    low_yyreport(REPORT_ERROR, NULL, 0, parser_system_string,
		 1, "Unknown reserved symbol %s.");
    free_node((yyvsp[0].n));
  }
#line 9752 "y.tab.c" /* yacc.c:1646  */
    break;

  case 633:
#line 4545 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("inline"); }
#line 9758 "y.tab.c" /* yacc.c:1646  */
    break;

  case 634:
#line 4547 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("local"); }
#line 9764 "y.tab.c" /* yacc.c:1646  */
    break;

  case 635:
#line 4549 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("nomask"); }
#line 9770 "y.tab.c" /* yacc.c:1646  */
    break;

  case 636:
#line 4551 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("predef"); }
#line 9776 "y.tab.c" /* yacc.c:1646  */
    break;

  case 637:
#line 4553 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("private"); }
#line 9782 "y.tab.c" /* yacc.c:1646  */
    break;

  case 638:
#line 4555 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("protected"); }
#line 9788 "y.tab.c" /* yacc.c:1646  */
    break;

  case 639:
#line 4557 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("public"); }
#line 9794 "y.tab.c" /* yacc.c:1646  */
    break;

  case 640:
#line 4559 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("optional"); }
#line 9800 "y.tab.c" /* yacc.c:1646  */
    break;

  case 641:
#line 4561 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("variant"); }
#line 9806 "y.tab.c" /* yacc.c:1646  */
    break;

  case 642:
#line 4563 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("static"); }
#line 9812 "y.tab.c" /* yacc.c:1646  */
    break;

  case 643:
#line 4565 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("extern"); }
#line 9818 "y.tab.c" /* yacc.c:1646  */
    break;

  case 644:
#line 4567 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("final");}
#line 9824 "y.tab.c" /* yacc.c:1646  */
    break;

  case 645:
#line 4569 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("do"); }
#line 9830 "y.tab.c" /* yacc.c:1646  */
    break;

  case 646:
#line 4571 "language.yacc" /* yacc.c:1646  */
    { yyerror("else without if."); }
#line 9836 "y.tab.c" /* yacc.c:1646  */
    break;

  case 647:
#line 4573 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("return"); }
#line 9842 "y.tab.c" /* yacc.c:1646  */
    break;

  case 648:
#line 4575 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("import"); }
#line 9848 "y.tab.c" /* yacc.c:1646  */
    break;

  case 649:
#line 4577 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("inherit"); }
#line 9854 "y.tab.c" /* yacc.c:1646  */
    break;

  case 650:
#line 4579 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("catch"); }
#line 9860 "y.tab.c" /* yacc.c:1646  */
    break;

  case 651:
#line 4581 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("gauge"); }
#line 9866 "y.tab.c" /* yacc.c:1646  */
    break;

  case 652:
#line 4583 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("lambda"); }
#line 9872 "y.tab.c" /* yacc.c:1646  */
    break;

  case 653:
#line 4585 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("sscanf"); }
#line 9878 "y.tab.c" /* yacc.c:1646  */
    break;

  case 654:
#line 4587 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("switch"); }
#line 9884 "y.tab.c" /* yacc.c:1646  */
    break;

  case 655:
#line 4589 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("typeof"); }
#line 9890 "y.tab.c" /* yacc.c:1646  */
    break;

  case 656:
#line 4591 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("break"); }
#line 9896 "y.tab.c" /* yacc.c:1646  */
    break;

  case 657:
#line 4593 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("case"); }
#line 9902 "y.tab.c" /* yacc.c:1646  */
    break;

  case 658:
#line 4595 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("continue"); }
#line 9908 "y.tab.c" /* yacc.c:1646  */
    break;

  case 659:
#line 4597 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("default"); }
#line 9914 "y.tab.c" /* yacc.c:1646  */
    break;

  case 660:
#line 4599 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("for"); }
#line 9920 "y.tab.c" /* yacc.c:1646  */
    break;

  case 661:
#line 4601 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("foreach"); }
#line 9926 "y.tab.c" /* yacc.c:1646  */
    break;

  case 662:
#line 4603 "language.yacc" /* yacc.c:1646  */
    { yyerror_reserved("if"); }
#line 9932 "y.tab.c" /* yacc.c:1646  */
    break;


#line 9936 "y.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 4616 "language.yacc" /* yacc.c:1906  */


static void yyerror_reserved(const char *keyword)
{
  my_yyerror("%s is a reserved word.", keyword);
}

static struct pike_string *get_new_name(struct pike_string *prefix)
{
  char buf[40];
  /* Generate a name for a global symbol... */
  sprintf(buf,"__lambda_%ld_%ld_line_%d",
	  (long)Pike_compiler->new_program->id,
	  (long)(Pike_compiler->local_class_counter++ & 0xffffffff), /* OSF/1 cc bug. */
	  (int) THIS_COMPILATION->lex.current_line);
  if (prefix) {
    struct string_builder sb;
    init_string_builder_alloc(&sb, prefix->len + strlen(buf) + 1,
			      prefix->size_shift);
    string_builder_shared_strcat(&sb, prefix);
    string_builder_putchar(&sb, 0);
    string_builder_strcat(&sb, buf);
    return finish_string_builder(&sb);
  }
  return make_shared_string(buf);
}


static int low_islocal(struct compiler_frame *f,
		       struct pike_string *str)
{
  int e;
  for(e=f->current_number_of_locals-1;e>=0;e--)
    if(f->variable[e].name==str) {
      f->variable[e].flags |= LOCAL_VAR_IS_USED;
      return e;
    }
  return -1;
}


/* Add a local variable to the current function in frame.
 * NOTE: Steals the references to type and def, but not to str.
 */
int low_add_local_name(struct compiler_frame *frame,
		       struct pike_string *str,
		       struct pike_type *type,
		       node *def)
{

  if (str->len) {
    int tmp=low_islocal(frame,str);
    if(tmp>=0 && tmp >= frame->last_block_level)
    {
      my_yyerror("Duplicate local variable %S, "
		 "previous declaration on line %d\n",
		 str, frame->variable[tmp].line);
    }

    if(type == void_type_string)
    {
      my_yyerror("Local variable %S is void.\n", str);
    }
  }

  debug_malloc_touch(def);
  debug_malloc_touch(type);
  debug_malloc_touch(str);
  /* NOTE: The number of locals can be 0..255 (not 256), due to
   *       the use of READ_INCR_BYTE() in apply_low.h.
   */
  if (frame->current_number_of_locals == MAX_LOCAL-1)
  {
    my_yyerror("Too many local variables: no space for local variable %S.",
	       str);
    free_type(type);
    if (def) free_node(def);
    return -1;
  } else {
    int var = frame->current_number_of_locals;

#ifdef PIKE_DEBUG
    check_type_string(type);
#endif /* PIKE_DEBUG */
    if (pike_types_le(type, void_type_string)) {
      if (Pike_compiler->compiler_pass != 1) {
	yywarning("Declaring local variable %S with type void "
		  "(converted to type zero).", str);
      }
      free_type(type);
      copy_pike_type(type, zero_type_string);
    }
    frame->variable[var].type = type;
    frame->variable[var].name = str;
    reference_shared_string(str);
    frame->variable[var].def = def;

    frame->variable[var].line = THIS_COMPILATION->lex.current_line;
    copy_shared_string(frame->variable[var].file,
		       THIS_COMPILATION->lex.current_file);

    if (pike_types_le(void_type_string, type)) {
      /* Don't warn about unused voidable variables. */
      frame->variable[var].flags = LOCAL_VAR_IS_USED;
    } else {
      frame->variable[var].flags = 0;
    }

    frame->current_number_of_locals++;
    if(frame->current_number_of_locals > frame->max_number_of_locals)
    {
      frame->max_number_of_locals = frame->current_number_of_locals;
    }

    return var;
  }
}


/* argument must be a shared string */
/* Note that this function eats a reference to 'type' */
/* If def is nonzero, it also eats a ref to def */
int add_local_name(struct pike_string *str,
		   struct pike_type *type,
		   node *def)
{
  return low_add_local_name(Pike_compiler->compiler_frame,
			    str,
			    type,
			    def);
}

/* Mark local variables declared in a multi-assign or sscanf expression
 * as used. */
static void mark_lvalues_as_used(node *n)
{
  while (n && n->token == F_LVALUE_LIST) {
    if (!CAR(n)) {
      /* Can happen if a variable hasn't been declared. */
    } else if (CAR(n)->token == F_ARRAY_LVALUE) {
      mark_lvalues_as_used(CAAR(n));
    } else if ((CAR(n)->token == F_LOCAL) && !(CAR(n)->u.integer.b)) {
      Pike_compiler->compiler_frame->variable[CAR(n)->u.integer.a].flags |=
	LOCAL_VAR_IS_USED;
    }
    n = CDR(n);
  }
}

#if 0
/* Note that this function eats a reference to each of
 * 'type' and 'initializer', but not to 'name'.
 * Note also that 'initializer' may be NULL.
 */
static node *add_protected_variable(struct pike_string *name,
				    struct pike_type *type,
				    int depth,
				    node *initializer)
{
  struct compiler_frame *f = Pike_compiler->compiler_frame;
  int i;
  int id;
  node *n = NULL;

  if (initializer) {
    /* FIXME: We need to pop levels off local and external variables here. */
  }

  for(i = depth; f && i; i--) {
    f->lexical_scope |= SCOPE_SCOPED;
    f = f->previous;
  }
  if (!f) {
    int parent_depth = i;
    struct program_state *p = Pike_compiler;
    struct pike_string *tmp_name;
    while (i--) {
      if (!p->previous) {
	my_yyerror("Too many levels of protected (%d, max:%d).",
		   depth, depth - (i+1));
	parent_depth -= i+1;
	break;
      }
      p->new_program->flags |= PROGRAM_USES_PARENT;
      p = p->previous;
    }
    
    tmp_name = get_new_name(name);
    id = define_parent_variable(p, tmp_name, type,
				ID_PROTECTED|ID_PRIVATE|ID_INLINE);
    free_string(tmp_name);
    if (id >= 0) {
      if (def) {
	p->init_node =
	  mknode(F_COMMA_EXPR, Pike_compiler->init_node,
		 mkcastnode(void_type_string,
			    mknode(F_ASSIGN, initializer,
				   mkidentifiernode(id))));
	initializer = NULL;
      }
      n = mkexternalnode(id, parent_depth);
    }
  } else if (depth) {
    f->lexical_scope|=SCOPE_SCOPE_USED;
    tmp_name = get_new_name(name);
    id = low_add_local_name(f, tmp_name, type, NULL);
    free_string(tmp_name);
    if(f->min_number_of_locals < id+1)
      f->min_number_of_locals = id+1;
    if (initializer) {
      /* FIXME! */
      yyerror("Initializers not yet supported for protected variables with function scope.");
    }
    n = mklocalnode(id, depth);
  }
  id = add_local_name(name, type, n);
  if (id >= 0) {
    if (initializer) {
      return mknode(F_ASSIGN, initializer, mklocalnode(id,0));
    }
    return mklocalnode(id, 0);
  }
  if (initializer) {
    free_node(initializer);
  }
  return NULL;
}
#endif /* 0 */

int islocal(struct pike_string *str)
{
  return low_islocal(Pike_compiler->compiler_frame, str);
}

/* argument must be a shared string */
static node *lexical_islocal(struct pike_string *str)
{
  int e,depth=0;
  struct compiler_frame *f=Pike_compiler->compiler_frame;
  
  while(1)
  {
    for(e=f->current_number_of_locals-1;e>=0;e--)
    {
      if(f->variable[e].name==str)
      {
	struct compiler_frame *q=Pike_compiler->compiler_frame;

	f->variable[e].flags |= LOCAL_VAR_IS_USED;

	while(q!=f) 
	{
	  q->lexical_scope|=SCOPE_SCOPED;
	  q=q->previous;
	}

	if(depth) {
	  q->lexical_scope|=SCOPE_SCOPE_USED;

	  if(q->min_number_of_locals < e+1)
	    q->min_number_of_locals = e+1;
	}

	if(f->variable[e].def) {
	  /*fprintf(stderr, "Found prior definition of \"%s\"\n", str->str); */
	  return copy_node(f->variable[e].def);
	}

	return mklocalnode(e,depth);
      }
    }
    if(!(f->lexical_scope & SCOPE_LOCAL)) return 0;
    depth++;
    f=f->previous;
  }
}

static node *safe_inc_enum(node *n)
{
  JMP_BUF recovery;
  STACK_LEVEL_START(0);

  if (SETJMP(recovery)) {
    handle_compile_exception ("Bad implicit enum value (failed to add 1).");
    push_int(0);
  } else {
    if (n->token != F_CONSTANT) Pike_fatal("Bad node to safe_inc_enum().\n");
    push_svalue(&n->u.sval);
    push_int(1);
    f_add(2);
  }
  UNSETJMP(recovery);
  STACK_LEVEL_DONE(1);
  free_node(n);
  n = mkconstantsvaluenode(Pike_sp-1);
  pop_stack();
  return n;
}


static int call_handle_import(struct pike_string *s)
{
  struct compilation *c = THIS_COMPILATION;
  int args;

  ref_push_string(s);
  ref_push_string(c->lex.current_file);
  if (c->handler && c->handler->prog) {
    ref_push_object(c->handler);
    args = 3;
  }
  else args = 2;

  if (safe_apply_handler("handle_import", c->handler, c->compat_handler,
			 args, BIT_MAPPING|BIT_OBJECT|BIT_PROGRAM|BIT_ZERO))
    if (TYPEOF(Pike_sp[-1]) != T_INT)
      return 1;
    else {
      pop_stack();
      my_yyerror("Couldn't find module to import: %S", s);
    }
  else
    handle_compile_exception ("Error finding module to import");

  return 0;
}

void cleanup_compiler(void)
{
}
